/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_insn.h 182 2015-06-24 07:14:37Z t_ishikawa $
 */

/*
 *		ץåü̿Υ饤ؿV850ѡ
 */
#ifndef TOPPERS_PRC_INSN_H
#define TOPPERS_PRC_INSN_H

#include <prc_tool.h>

/*
 *  V850E3V5Τߥݡ
 */
#ifndef __v850e3v5__
#error Only support v850e3v5 architecture!!
#endif /* __v850e3v5__ */

#ifndef TOPPERS_MACRO_ONLY

#define SYNCM	__syncm();

LOCAL_INLINE void
disable_int(void)
{
	__DI();
}

LOCAL_INLINE void
enable_int(void)
{
	__EI();
}

LOCAL_INLINE uint32
current_psw(void)
{
	return(__stsr_rh(5, 0));
}

LOCAL_INLINE void
set_psw(uint32 psw)
{
	__ldsr_rh(5, 0, psw);
}

/*
 *  V850E3V5Ѥγߥȥ롼
 */
LOCAL_INLINE void
set_pmr(uint16 pmr)
{
	uint32 psw;

	/* PMR must be set in di sate(PSW.ID = 1) */
	psw = current_psw();
	disable_int();

	__ldsr_rh(11, 2, pmr);

	set_psw(psw);
}

LOCAL_INLINE uint16
get_ispr(void)
{
	return(__stsr_rh(10, 2));
}

LOCAL_INLINE void
clear_ispr(void)
{
	uint32 psw;

	/* ISPR must be set in di sate(PSW.ID = 1) */
	psw = current_psw();
	disable_int();

	__ldsr_rh(13, 2, 1);    /* INTCFG = 1; ISPR 񤭴ǽ */
	__ldsr_rh(10, 2, 0);    /* ISPR = 0 */
	__ldsr_rh(13, 2, 0);    /* INTCFG = 0; ISPR 񤭴ػߤ(ư) */
	__syncp();

	set_psw(psw);
}

LOCAL_INLINE void
set_intbp(uint32 intbp)
{
	uint32 psw;

	/* INTBP must be set in di sate(PSW.ID = 1) */
	psw = current_psw();
	disable_int();

	__ldsr_rh(4, 1, intbp);

	set_psw(psw);
}

#define LDSR_REG(reg, sel, val) {\
    __ldsr_rh(reg, sel, val);\
}

#define STSR_REG(reg, sel, val) {\
    val = __stsr_rh(reg, sel); \
}

#define MPA_WRITE(mpuid, mpla, mpua, mpat) { \
    __ldsr_rh(mpuid*4, 6, mpla); \
    __ldsr_rh(mpuid*4+1, 6, mpua); \
    __ldsr_rh(mpuid*4+2, 6, mpat); \
}

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_INSN_H */
