;/* 
 ;*  TOPPERS ATK2
 ;*      Toyohashi Open Platform for Embedded Real-Time Systems
 ;*      Automotive Kernel Version 2
 ;*
 ;*  Copyright (C) 2012-2015 by Center for Embedded Computing Systems
 ;*              Graduate School of Information Science, Nagoya Univ., JAPAN
 ;*  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 ;*  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 ;*  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 ;*  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 ;*  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 ;*  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 ;*  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 ;*  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 ;*  Copyright (C) 2013 by Embedded and Real-Time Systems Laboratory
 ;*              Graduate School of Information Science, Nagoya Univ., JAPAN
 ;*
 ;*  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 ;*  ܥեȥѤΤޤࡥʲƱˤѡʣ
 ;*  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 ;*  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 ;*      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 ;*      ˴ޤޤƤ뤳ȡ
 ;*  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 ;*      ѤǤǺۤˤϡۤȼɥȡ
 ;*      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 ;*      ̵ݾڵǺܤ뤳ȡ
 ;*  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 ;*      ѤǤʤǺۤˤϡΤ줫ξ
 ;*      ȡ
 ;*    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 ;*        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 ;*    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 ;*        𤹤뤳ȡ
 ;*  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 ;*      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 ;*      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 ;*      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 ;*      դ뤳ȡ
 ;*
 ;*  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 ;*  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 ;*  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 ;*  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 ;*
 ;*  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 ;*  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 ;*  ФŬޤơʤݾڤԤʤޤܥեȥ
 ;*  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 ;*  Ǥʤ
 ;*
 ;*  $Id: prc_support.asm 189 2015-06-26 01:54:57Z t_ishikawa $
 ;*/

;/*
 ;*		åȰ¸
 ;*/
$include (v850asm.inc)
$include (offset.h)

$ifdef USE_ASMCONFIG_INC
$include (asm_config.inc)
$endif ;/* USE_ASMCONFIG_INC */

$ifdef __v850e2v3__

;/*
 ;*  V850E2Ѥγߥȥ롼
 ;*/
GET_ISPR .macro reg
	mov		ISPR_H, reg
	ld.h	0[reg],reg
.endm

CLEAR_ISPR .macro reg1, reg2
	mov		ISPC_H,reg1
	mov		0xffff,reg2
	st.h	reg2,0[reg1]
	mov		ISPR_H, reg1
	st.h	r0,0[reg1]
.endm

SET_PMR .macro reg_val, reg_tmp
	mov     PMR, reg_tmp
	st.h    reg_val, 0[reg_tmp]  ;/* set interrupt level */
	syncm
.endm

$endif ;/* __v850e2v3__ */

$ifdef __v850e3v5__

;/*
 ;*  V850E3V5Ѥγߥȥ롼
 ;*/
GET_ISPR .macro reg
	stsr 10, reg, 2
.endm

SET_ISPR .macro val, reg 
	movea val,r0,reg
	ldsr reg, 10, 2
	syncp
.endm

SET_INTCFG .macro val, reg 
	movea val,r0,reg
	ldsr reg, 13, 2
	syncp
.endm

CLEAR_ISPR .macro reg1, reg2
	SET_INTCFG 1, reg1 ;/* ISPR 񤭴ǽ */
	SET_ISPR   0, reg1 ;/* ISPR Υꥢ */
	SET_INTCFG 0, reg1 ;/* ISPR 񤭴ػߤ(ư) */
.endm

GET_PMR .macro reg
	stsr 11, reg, 2
.endm

SET_PMR .macro reg_val, reg_tmp
	stsr psw, reg_tmp
	di
	ldsr reg_val, 11, 2
	ldsr reg_tmp, psw
	syncp
.endm

GET_ICSR .macro reg
	stsr sr12, reg, 2
.endm

SET_ICSR .macro val, reg 
	movea val,r0,reg
	ldsr \reg, sr12, 2
.endm

$endif ;/* !__v850e3v5__ */


;/*
 ;*  OS߶ػߥޥ
 ;*  ͥȤΰֳ¦ǸƤӽФ뤳ȤꤷƤ
 ;*/
OUTER_LOCK_OS_INT .macro   reg12, reg13

    ;/* pmr_isr2_mask -> PMR */
    Lea     _pmr_isr2_mask, reg13
    ld.h    0[reg13], reg13
    SET_PMR reg13, reg12

    ;/* nested_lock_os_int_cnt = 1 */
    Lea     _nested_lock_os_int_cnt, reg12
    mov     1, reg13
    st.b    reg13, 0[reg12]

.endm

;/*
 ;*  OS߶ػ߲ޥ
 ;*  ͥȤΰֳ¦ǸƤӽФ뤳ȤꤷƤ
 ;*/
OUTER_UNLOCK_OS_INT .macro  reg12, reg13

    ;/* nested_lock_os_int_cnt = 0 */
    Lea     _nested_lock_os_int_cnt, reg12
    mov     r0, reg13
    st.b    reg13, 0[reg12]

    ;/* pmr_setting_tbl[current_iintpri] -> PMR */
    Lea     _current_iintpri, reg12
    ld.bu   0[reg12], reg12
    shl     1, reg12

    Lea     _pmr_setting_tbl, reg13
    add     reg12, reg13
    ld.h    0[reg13], reg13
    SET_PMR reg13, reg12  ;/* set interrupt level */

.endm

;/* =begin modified for SC3 */
;/*
 ;*  OS߶ػߥޥ
 ;*  ͥȤ
 ;*/
NESTED_LOCK_OS_INT .macro   reg12, reg13

    ;/* nested_lock_os_int_cnt == 0 ? */
    Lea     _nested_lock_os_int_cnt, reg13
    ld.b    0[reg13], reg12
    cmp     r0, reg12
    bne     increment_nest_lock

    ;/* pmr_isr2_mask -> PMR */
    Lea     _pmr_isr2_mask, reg13
    ld.h    0[reg13], reg13
    SET_PMR reg13, reg12  ;/* set interrupt level */
    Lea     _nested_lock_os_int_cnt, reg13
    mov     r0, reg12                ;/* nested_lock_os_int_cnt = 0 */

increment_nest_lock:
    ;/* nested_lock_os_int_cnt += 1 */
    add     1, reg12
    st.b    reg12, 0[reg13]

.endm

;/*
 ;*  OS߶ػ߲ޥ
 ;*  ͥȤ
 ;*/
NESTED_UNLOCK_OS_INT .macro  reg12, reg13

    ;/* nested_lock_os_int_cnt -= 1 */
    Lea     _nested_lock_os_int_cnt, reg12
    ld.b    0[reg12], reg13
    add     -1, reg13
    st.b    reg13, 0[reg12]
    cmp     r0, reg13
    bne     nested_unlock_exit

    ;/* pmr_setting_tbl[current_iintpri] -> PMR */
    Lea     _current_iintpri, reg12
    ld.bu   0[reg12], reg12
    shl     1, reg12

    Lea     _pmr_setting_tbl, reg13
    add     reg12, reg13
    ld.h    0[reg13], reg13
    SET_PMR reg13, reg12  ;/* set interrupt level */

nested_unlock_exit:
.endm

;/* =end modified for SC3 */

	;/*
	 ;* 㳰ǤΥ쥸¸ޥ
	 ;*/
INT_EXC_SAVEREG .macro
$ifdef TOPPERS_USE_HFLOAT
	addi    -88 , sp , sp
$else ;/* !TOPPERS_USE_HFLOAT */
	addi    -84 , sp , sp
$endif ;/* TOPPERS_USE_HFLOAT */
	st.w    r30, 12[sp]  ;/* r30(ep) */
    ;/*
     ;* ȯr2eiwr¸Ƥ
     ;* ǡr2ϤǤ˥쥸Ȥ
     ;* Ǥ뤿ᡤ񤭤ʤ
     ;* r2äƤֹ˲ʤ褦
     ;*/
    stsr    eiwr, r30    ;/* r2->r30 */
	st.w    r30, 76[sp]
	mov     sp, ep 
	sst.w   r1, 80[ep]
	sst.w   r5, 72[ep]
	sst.w   r6, 68[ep]
	sst.w   r7, 64[ep]
	sst.w   r8, 60[ep]
	sst.w   r9, 56[ep]
	sst.w   r10, 52[ep]
	sst.w   r11, 48[ep]
	sst.w   r12, 44[ep]
	sst.w   r13, 40[ep]
	sst.w   r14, 36[ep]
	sst.w   r15, 32[ep]
	sst.w   r16, 28[ep]
	sst.w   r17, 24[ep]
	sst.w   r18, 20[ep]
	sst.w   r19, 16[ep]
	sst.w   r31, 8[ep]
$ifdef TOPPERS_USE_HFLOAT
	stsr    fpsr, r19     ;/* load FPSR */
	sst.w   r19, 84[ep]
$endif ;/* TOPPERS_USE_HFLOAT */
.endm

	;/*
	 ;* 㳰ǤΥ쥸ޥ
	 ;*/
INT_EXC_RESTOREREG .macro
$ifdef TOPPERS_USE_HFLOAT
	sld.w   84[ep], r19
	ldsr    r19, fpsr     ;/* store FPSR */
$endif ;/* TOPPERS_USE_HFLOAT */
	sld.w   80[ep], r1
	sld.w   76[ep], r2
	sld.w   72[ep], r5
	sld.w   68[ep], r6
	sld.w   64[ep], r7
	sld.w   60[ep], r8
	sld.w   56[ep], r9
	sld.w   52[ep], r10
	sld.w   48[ep], r11
	sld.w   44[ep], r12
	sld.w   40[ep], r13
	sld.w   36[ep], r14
	sld.w   32[ep], r15
	sld.w   28[ep], r16
	sld.w   24[ep], r17
	sld.w   20[ep], r18
	sld.w   16[ep], r19
	sld.w    8[ep], r31
$ifdef TOPPERS_USE_HFLOAT
	addi    88, ep, sp
$else ;/* !TOPPERS_USE_HFLOAT */
	addi    84, ep, sp
$endif ;/* TOPPERS_USE_HFLOAT */
	sld.w   12[ep], r30 ;/* r30(ep) */
    ldsr    r2, eiwr    ;/* r2 */
.endm


$ifdef __v850e3v5__
	;/* 
	 ;* V850E3V5ѥ٥
	 ;* RBASEꤵ뤳ȤʤŸγϥɥ쥹
	 ;* (EI٥ߤϥơ֥뻲Ѥ뤿ܥ٥ϻѤʤ)
	 ;*/
	RESET .cseg text
	.extern __reset
__reset:
	jr __start
	.rept 6
	nop
	.endm
__syserr: ;/* 0x0010 */
    ldsr  r2, eiwr
    movea E_OS_PROTECTION_EXCEPTION, r0, r2
	jr _fe_exception_entry
	.rept 2
	nop
	.endm
__hvtrap: ;/* 0x0020 */
    ldsr  r2, eiwr
    movea E_OS_PROTECTION_EXCEPTION, r0, r2
	jr _fe_exception_entry
	.rept 2
	nop
	.endm
__fetrap: ;/* 0x0030 */
    ldsr  r2, eiwr
    movea E_OS_PROTECTION_EXCEPTION, r0, r2
	jr _fe_exception_entry
	.rept 2
	nop
	.endm
__trap0:  ;/* 0x0040 */
    ldsr  r2, eiwr
    movea E_OS_PROTECTION_EXCEPTION, r0, r2
	jr _ei_exception_entry
	.rept 2
	nop
	.endm
__trap1:  ;/* 0x0050 */
    ldsr  r2, eiwr
    movea E_OS_PROTECTION_EXCEPTION, r0, r2
	jr _ei_exception_entry
	.rept 2
	nop
	.endm
__rie:    ;/* 0x0060 */
    ldsr  r2, eiwr
    movea E_OS_PROTECTION_EXCEPTION, r0, r2
	jr _ei_exception_entry
	.rept 2
	nop
	.endm
__fppfpi: ;/* 0x0070 */
    ldsr  r2, eiwr
    movea E_OS_PROTECTION_EXCEPTION, r0, r2
	jr _ei_exception_entry
	.rept 2
	nop
	.endm
__ucpop:  ;/* 0x080 */
    ldsr  r2, eiwr
    movea E_OS_PROTECTION_EXCEPTION, r0, r2
	jr _fe_exception_entry
	.rept 2
	nop
	.endm
__mip:    ;/* 0x0090 */
    ldsr  r2, eiwr
    movea E_OS_PROTECTION_MEMORY, r0, r2
	jr _fe_exception_entry
	.rept 2
	nop
	.endm
__pie:   ;/* 0x00a0 */
    ldsr  r2, eiwr
    movea E_OS_PROTECTION_EXCEPTION, r0, r2
	jr _fe_exception_entry
	.rept 2
	nop
	.endm
__debug:  ;/* 0x00b0 */
	jr __debug
	.rept 6
	nop
	.endm
__mae:    ;/* 0x00c0 */
    ldsr  r2, eiwr
    movea E_OS_PROTECTION_EXCEPTION, r0, r2
	jr _fe_exception_entry
	.rept 2
	nop
	.endm
__rfu:    ;/* 0x00d0 */
	jr __rfu
	.rept 6
	nop
	.endm
__fenmi:  ;/* 0x00e0 */
    ldsr  r2, eiwr
    movea E_OS_PROTECTION_EXCEPTION, r0, r2
	jr _fe_exception_entry
	.rept 2
	nop
	.endm
__feint:  ;/* 0x00f0 */
    ldsr  r2, eiwr
    movea E_OS_PROTECTION_EXCEPTION, r0, r2
	jr _fe_exception_entry
	.rept 2
	nop
	.endm
__eiintn0:  ;/*ͥ0 0x0100 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn1:  ;/*ͥ1 0x0110 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn2:  ;/*ͥ2 0x0120 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn3:  ;/*ͥ3 0x0130 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn4:  ;/*ͥ4 0x0140 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn5:  ;/*ͥ5 0x0150 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn6:  ;/*ͥ6 0x0160 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn7:  ;/*ͥ7 0x0170 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn8:  ;/*ͥ8 0x0180 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn9:  ;/*ͥ9 0x0190 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn10: ;/*ͥ10 0x01a0 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn11: ;/*ͥ11 0x01b0 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn12: ;/*ͥ12 0x01c0 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn13: ;/*ͥ13 0x01d0 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn14: ;/*ͥ14 0x01e0 */
	jr _default_int_handler
	.rept 6
	nop
	.endm
__eiintn15: ;/*ͥ15 0x01f0 */
	jr _default_int_handler
	.rept 6
	nop
	.endm

$endif ;/* __v850e3v5__ */

    kernel.text .cseg text
	;/*
	 ;*  㳰ȥferetǥ꥿󤹤㳰ѡ
     ;*  ǡCY = FEPSW.IMPr2 = error code
     ;*  r2㳰ȥǥå¸Ѥ
	 ;*/
	.extern _fe_exception_entry
_fe_exception_entry:
    ldsr    r2, fewr                ;/* 顼ɤ¸ */
    stsr    fepsw, r2
    shl     PSW_SV, r2              ;/* r2 << PSW_SV ˤ㳰ȯΥ⡼ɼ */
    stsr    fewr, r2                ;/* 顼ɤ */
    bnc     fe_exception_0          ;/* ø㳰ʤХå */
    ldsr    r5, fewr                ;/* tpr5ˤ */
    Lea     _hook_savedsp, r5
    ld.w    0[r5], r5
    cmp     r0, r5
    be      fe_exception_from_utask
    ;/*
     ;*  桼եå㳰
     ;*  hook_savedsp桼å¸
     ;*  +------------------+ <- sp
     ;*  | hook_savedsp |
     ;*  +------------------+ <- hook_savedsp
     ;*  | ................ |
     ;*  +------------------+
     ;*/
    addi    -4, r5, r5
    st.w    sp, 0[r5]               ;/* *(hook_savedsp - 4) = sp */
    mov     r5, sp                  ;/* sp = hook_savedsp - 4 */   
    stsr    fewr, r5                ;/* tpr5ˤ */
    br      fe_exception_0
fe_exception_from_utask:
    ;/*
     ;*  桼㳰
     ;*/
    Lea     _p_runtsk, r5
    ld.w    0[r5], r5
    st.w    sp, TCB_usp[r5]         ;/* uspTCB¸ */
    ld.w    TCB_p_tinib[r5], r5
    ld.w    TINIB_sstk_bottom[r5], sp         ;/* ssp */
    stsr    fewr, r5                ;/* tpr5ˤ */
fe_exception_0:
    ;/* å쥸¸ */
    INT_EXC_SAVEREG

	;/* ¿ųߤΤᡤߤFEPCFEPSW¸ */
	stsr    fepc, r6
	sst.w   r6, 4[ep]
	stsr    fepsw, r6
	sst.w   r6, 0[ep]

	;/*
	 ;* ץƥեåOS٥Ǽ¹Ԥ뤿OS߶ػ߾֤ˤ
	 ;* OS߶ػ߾֤㳰ȯǽ뤿ᡤͥȴԤ
	 ;* 㳰ϼξȯ
	 ;*  ISR1¹Ծ֤ȯ
	 ;*  ISR1¹Ծְʳȯ
	 ;*  OS߲֤ȯ
	 ;*  OS߶ػ߾֤ȯ
	 ;*/

	;/*
	 ;* ƥ1γ߰ʳ㳰ȯȽǤ
	 ;* ƥ1㳰ȯfe_exception_1إ
	 ;*/
	GET_ISPR r6
	Lea     _pmr_isr1_mask, r7
	ld.h    0[r7], r7
	and     r7, r6
	cmp     r0, r6
	bne     fe_exception_1

	;/*
	 ;*  ISR1¹Ծְʳȯ
	 ;*/
	Lea     _nested_lock_os_int_cnt, r12
	ld.b    0[r12], r13
	mov     1, r14
	add     r14, r13
	st.b    r13, 0[r12]
	cmp     1, r13
	bne     fe_exception_1

	;/*
	 ;* OS߲֤ȯ
	 ;* OS߶ػ߾֤Ȥ
	 ;*/
	Lea     _pmr_isr2_mask, r7
	ld.h    0[r7], r7
	SET_PMR r7, r6  ;/* pmr_isr2_mask -> PMR */

fe_exception_1:
	;/*
	 ;*  ȯѹΤǳ߲˼
	 ;*/
	stsr    feic, r19                   ;/* 㳰װ */
	stsr    fepc, r18                   ;/* 㳰ȯPC */

	;/* 
	 ;* C1ISRդ뤿ᡤNPbit ꥢ 
	 ;*/
	stsr    psw, r12
	mov     !0x0080, r13
	and     r12, r13
	ldsr    r13, psw

fe_exception_2:
	;/*
	 ;*  ͥ뵯ưƤʤ˵CPU㳰ϡ̵¥롼פ
	 ;*/
	Lea   _kerflg, r12          ;/* kerflgFALSEʤ̵¥롼 */
	ld.b  0[r12], r12
	cmp   r0, r12
infinity_loop_fe:
	be    infinity_loop_fe

	;/*
	 ;* ¿ųߤȽ
	 ;*/
	Lea     _except_nest_cnt, r12
	ld.w    0[r12], r13
	mov     1, r14                      ;/*  ߡ㳰ΥͥȲΥ󥯥 */
	add     r14, r13
	st.w    r13, 0[r12]

	mov     sp, r9                      ;/* sp r9 */

	cmp     1, r13
	bne     fe_exception_3              ;/* _nested_lock_os_int_cnt > 1 -> fe_exception_3 */

	;/*
	 ;* C1ISR¹Ծ֤ȯϥåݥ󥿤ؤʤ
	 ;*/
	GET_ISPR r6
	Lea     _pmr_isr1_mask, r7
	ld.h    0[r7], r7
	and     r7, r6
	cmp     r0, r6
	bne     fe_exception_3

	;/* åݥ󥿤¸ؤ */
	Lea     __ostkpt, r12
	ld.w    0[r12], r12
	add     -4, r12
	st.w    sp, 0[r12]                      ;/* åݥ󥿤¸ */
	mov     r12, sp                         ;/* åݥ󥿤ڤؤ */

fe_exception_3:
	UNLOCK_ALL_INT

$ifdef CFG_USE_PROTECTIONHOOK
	;/* v850_cpu_exp_*򤹤륹ڡ */
	addi    -12, sp, sp

	;/* v850_cpu_exp_sp */
	Lea     _v850_cpu_exp_sp, r12
	st.w    r9, 0[r12]
	st.w    ep, 0[sp]
	mov     sp, ep

	;/* v850_cpu_exp_no */
	Lea     _v850_cpu_exp_no, r12
	ld.w    0[r12], r13
	sst.w   r13, 8[ep]
	st.w    r19, 0[r12]                     ;/* r19 㳰װ */

	;/* v850_cpu_exp_pc */
	Lea     _v850_cpu_exp_pc, r12
	ld.w    0[r12], r13
	sst.w   r13, 4[ep]
	mov     r18, r17                        ;/* r18:fepc */
	add     -4, r17
	st.w    r17, 0[r12]

$endif ;/* CFG_USE_PROTECTIONHOOK */

	;/*
	 ;* CPU㳰ȯ硤OSE_OS_PROTECTION_EXCEPTIONѥ᡼Ȥ
	 ;* ץƥեåƤӽФ
	 ;*/
    ;/* =begin modified for SC3 */
    ;/*
     ;*  㳰װMIP or 0xMDPΤȤΤ
     ;*  E_OS_PROTECTION_MEMORYѥ᡼Ȥ
     ;*/
    andi    FE_MP_MASK, r19, r6
    addi    FE_MP_BIT, r0, ep
    cmp     ep, r6
    be      fe_exception_4
    mov     E_OS_PROTECTION_EXCEPTION, r2

fe_exception_4:
	mov     r2, r6
    ;/* =end modified for SC3 */
	jarl    _call_protectionhk_main, r31

$ifdef CFG_USE_PROTECTIONHOOK
	mov     sp, ep

	;/* v850_cpu_exp_no */
	Lea     _v850_cpu_exp_no, r12
	sld.w   8[ep], r13
	st.w    r13, 0[r12]

	;/* v850_cpu_exp_pc */
	Lea     _v850_cpu_exp_pc, r12
	sld.w   4[ep], r13
	st.w    r13, 0[r12]

	;/* v850_cpu_exp_sp */
	Lea     _v850_cpu_exp_sp, r12
	sld.w   0[ep], r13
	st.w    r13, 0[r12]

	;/* v850_cpu_exp_*򤷤ڡ᤹ */
	addi    12, sp, sp
$endif ;/* CFG_USE_PROTECTIONHOOK */

fe_ret_exc:
	LOCK_ALL_INT

	;/*
	 ;* ץƥեåOS߶ػ߾֤Ǽ¹Ԥ
	 ;*/

	;/*
	 ;*  ߡ㳰ΥͥȲΥǥ
	 ;*/
	Lea     _except_nest_cnt, r12
	ld.w    0[r12], r13
	mov     -1, r14
	add     r14, r13
	st.w    r13, 0[r12]

	;/*
	 ;*  OS߶ػ߾֤β
	 ;*/
	;/*
	 ;* ISR1¹Ծ֤ȯ
	 ;* (1)åݥ󥿤ؤ򤷤ʤ
	 ;* (2)OS߶ػ߾֤β򤷤ʤ
	;*/
	GET_ISPR r6
	Lea     _pmr_isr1_mask, r7
	ld.h    0[r7], r7
	and     r7, r6
	cmp     r0, r6
	bne     ret_exc_2

	;/*
	 ;*  ͥȲ1ʾʤ߸ISRʤ㳰ȯ
	 ;*  åݥ󥿤ؤʤ
	 ;*/
	cmp     r0, r13
	bne     ret_exc_1

	;/*
	 ;*  褬ʤ᥹å᤹
	 ;*/
	ld.w    0[sp], sp

ret_exc_1:
	;/*
	 ;*  ISR1¹Ծְʳȯ硤OS߶ػ߾֤β
	 ;*/
	Lea     _nested_lock_os_int_cnt, r12
	ld.b    0[r12], r13
	mov     -1, r14
	add     r14, r13
	st.b    r13, 0[r12]
	cmp     r0, r13
	bne     ret_exc_2

	;/* OSߤ */
	;/* pmr_setting_tbl[current_iintpri] -> PMR */
	Lea     _current_iintpri, r12
	ld.bu   0[r12], r12
	shl     1, r12

	Lea     _pmr_setting_tbl, r13
	add     r12, r13
	ld.h    0[r13], r13
	SET_PMR r13, r12     ;/* set interrupt level */

	;/*
	 ;*  㳰ȯ
	 ;*/
ret_exc_2:
	;/*
	 ;* 쥸
	 ;*/
	mov     sp, ep
	sld.w    4[ep], r10
	ldsr    r10, fepc
	sld.w   0[ep], r10
	ldsr    r10, fepsw

    ;/* å쥸 */
    INT_EXC_RESTOREREG

    ldsr    r2, fewr
	stsr    fepsw, r2   ;/* r2 = fepsw */
    shl     PSW_SV, r2         ;/* r2 << PSW_SV ˤ㳰ȯΥ⡼ɼ */
    bnc     return_from_fe_exception    ;/* ø㳰ʤХå */
    Lea     _hook_savedsp, r2
    ld.w    0[r2], r2
    cmp     r0, r2
    be      fe_exception_to_utask
    addi    -4, r2, r2
    ld.w    0[r2], sp               ;/* sp *(hook_savedsp - 4) */
    ;/*
     ;*  ǡhook_savedsp򹹿ɬפϤʤ
     ;*/
    br      return_from_fe_exception
fe_exception_to_utask:
    Lea     _p_runtsk, r2
    ld.w    0[r2], r2
    ld.w    TCB_usp[r2], sp         ;/* usp */
return_from_fe_exception:
    stsr    eiwr, r2
	feret

	;/*
	 ;*  㳰ȥeiretǥ꥿󤹤㳰ѡ
     ;*  ǡCY = EIPSW.IMPr2 = error code
     ;*  r2OS¦ͽ󤹤ʳߡ㳰ν
     ;*  쥸ȤƻѤˤᡤ
     ;*  å¸ʤ
	 ;*/
	.extern _ei_exception_entry
_ei_exception_entry:
    ldsr    r2, fewr                ;/* 顼ɤ¸ */
    stsr    eipsw, r2
    shl     PSW_SV, r2              ;/* r2 << PSW_SV ˤ㳰ȯΥ⡼ɼ */
    stsr    fewr, r2                ;/* 顼ɤ */
    bnc     ei_exception_0          ;/* ø㳰ʤХå */
    ldsr    r5, fewr                ;/* tpr5ˤ */
    Lea     _hook_savedsp, r5
    ld.w    0[r5], r5
    cmp     r0, r5
    be      ei_exception_from_utask
    ;/*
     ;*  桼եå㳰
     ;*  hook_savedsp桼å¸
     ;*  +------------------+ <- sp
     ;*  | hook_savedsp |
     ;*  +------------------+ <- hook_savedsp
     ;*  | ................ |
     ;*  +------------------+
     ;*/
    addi    -4, r5, r5
    st.w    sp, 0[r5]               ;/* *(hook_savedsp - 4) = sp */
    mov     r5, sp                  ;/* sp = hook_savedsp - 4 */   
    stsr    fewr, r5                ;/* tpr5ˤ */
    br      ei_exception_0
ei_exception_from_utask:
    ;/*
     ;*  桼㳰
     ;*/
    Lea     _p_runtsk, r5
    ld.w    0[r5], r5
    st.w    sp, TCB_usp[r5]         ;/* usp¸ */
    ld.w    TCB_p_tinib[r5], r5
    ld.w    TINIB_sstk_bottom[r5], sp         ;/* ssp */
    stsr    fewr, r5                ;/* tpr5ˤ */
ei_exception_0:
    ;/* å쥸¸ */
    INT_EXC_SAVEREG

	;/* ¿ųߤΤᡤߤEIPCEIPSW¸ */
	stsr    eipc, r6
	sst.w   r6, 4[ep]
	stsr    eipsw, r6
	sst.w   r6, 0[ep]

	;/*
	 ;* ץƥեåOS٥Ǽ¹Ԥ뤿OS߶ػ߾֤ˤ
	 ;* OS߶ػ߾֤㳰ȯǽ뤿ᡤͥȴԤ
	 ;* 㳰ϼξȯ
	 ;*  ISR1¹Ծ֤ȯ
	 ;*  ISR1¹Ծְʳȯ
	 ;*  OS߲֤ȯ
	 ;*  OS߶ػ߾֤ȯ
	 ;*/

	;/*
	 ;* ƥ1γ߰ʳ㳰ȯȽǤ
	 ;* ƥ1㳰ȯei_exception_1إ
	 ;*/
	GET_ISPR r6
	Lea     _pmr_isr1_mask, r7
	ld.h    0[r7], r7
	and     r7, r6
	cmp     r0, r6
	bne     ei_exception_1

	;/*
	 ;*  ISR1¹Ծְʳȯ
	 ;*/
	Lea     _nested_lock_os_int_cnt, r12
	ld.b    0[r12], r13
	mov     1, r14
	add     r14, r13
	st.b    r13, 0[r12]
	cmp     1, r13
	bne     ei_exception_1

	;/*
	 ;* OS߲֤ȯ
	 ;* OS߶ػ߾֤Ȥ
	 ;*/
	Lea     _pmr_isr2_mask, r7
	ld.h    0[r7], r7
	SET_PMR r7, r6                   ;/* pmr_isr2_mask -> PMR */

ei_exception_1:
	;/*
	 ;*  ȯѹΤǳ߲˼
	 ;*/
	stsr    eiic, r19                   ;/* 㳰װ */
	stsr    eipc, r18                   ;/* 㳰ȯPC */


ei_exception_2:
	;/*
	 ;*  ͥ뵯ưƤʤ˵CPU㳰ϡ̵¥롼פ
	 ;*/
	Lea   _kerflg, r12          ;/* kerflgFALSEʤ̵¥롼 */
	ld.b  0[r12], r12
	cmp   r0, r12
infinity_loop_ei:
	be    infinity_loop_ei

	;/*
	 ;* ¿ųߤȽ
	 ;*/
	Lea     _except_nest_cnt, r12
	ld.w    0[r12], r13
	mov     1, r14                      ;/*  ߡ㳰ΥͥȲΥ󥯥 */
	add     r14, r13
	st.w    r13, 0[r12]

	mov     sp, r9                      ;/* sp r9 */

	cmp     1, r13
	bne     ei_exception_3             ;/* _nested_lock_os_int_cnt > 1 -> ei_exception_3 */

	;/*
	 ;* ISR1¹Ծ֤ȯϥåݥ󥿤ؤʤ
	 ;*/
	GET_ISPR r6
	Lea     _pmr_isr1_mask, r7
	ld.h    0[r7], r7
	and     r7, r6
	cmp     r0, r6
	bne     ei_exception_3

	;/* åݥ󥿤¸ؤ */
	Lea     __ostkpt, r12
	ld.w    0[r12], r12
	add     -4, r12
	st.w    sp, 0[r12]                      ;/* åݥ󥿤¸ */
	mov     r12, sp                         ;/* åݥ󥿤ڤؤ */

ei_exception_3:
	UNLOCK_ALL_INT

$ifdef CFG_USE_PROTECTIONHOOK
	;/* v850_cpu_exp_*򤹤륹ڡ */
	addi    -12, sp, sp

	;/* v850_cpu_exp_sp */
	Lea     _v850_cpu_exp_sp, r12
	st.w    r9, 0[r12]
	st.w    ep, 0[sp]
	mov     sp, ep

	;/* v850_cpu_exp_no */
	Lea     _v850_cpu_exp_no, r12
	ld.w    0[r12], r13
	sst.w   r13, 8[ep]
	st.w    r19, 0[r12]                     ;/* r19 㳰װ */

	;/* v850_cpu_exp_pc */
	Lea     _v850_cpu_exp_pc, r12
	ld.w    0[r12], r13
	sst.w   r13, 4[ep]
	mov     r18, r17                        ;/* r18:fepc */
	add     -4, r17
	st.w    r17, 0[r12]

$endif ;/* CFG_USE_PROTECTIONHOOK */

	;/*
	 ;* CPU㳰ȯ硤OSE_OS_PROTECTION_EXCEPTIONѥ᡼Ȥ
	 ;* ץƥեåƤӽФ
	 ;*/
    ;/* =begin modified for SC3 */
	mov     r2, r6
    ;/* =end modified for SC3 */
	jarl    _call_protectionhk_main, r31

$ifdef CFG_USE_PROTECTIONHOOK
	mov     sp, ep

	;/* v850_cpu_exp_no */
	Lea     _v850_cpu_exp_no, r12
	sld.w   8[ep], r13
	st.w    r13, 0[r12]

	;/* v850_cpu_exp_pc */
	Lea     _v850_cpu_exp_pc, r12
	sld.w   4[ep], r13
	st.w    r13, 0[r12]

	;/* v850_cpu_exp_sp */
	Lea     _v850_cpu_exp_sp, r12
	sld.w   0[ep], r13
	st.w    r13, 0[r12]

	;/* v850_cpu_exp_*򤷤ڡ᤹ */
	addi    12, sp, sp
$endif ;/* CFG_USE_PROTECTIONHOOK */

ei_ret_exc:
	LOCK_ALL_INT

	;/*
	 ;* ץƥեåOS߶ػ߾֤Ǽ¹Ԥ
	 ;*/

	;/*
	 ;*  ߡ㳰ΥͥȲΥǥ
	 ;*/
	Lea     _except_nest_cnt, r12
	ld.w    0[r12], r13
	mov     -1, r14
	add     r14, r13
	st.w    r13, 0[r12]

	;/*
	 ;*  OS߶ػ߾֤β
	 ;*/
	;/*
	 ;* ISR1¹Ծ֤ȯ
	 ;* (1)åݥ󥿤ؤ򤷤ʤ
	 ;* (2)OS߶ػ߾֤β򤷤ʤ
	;*/
	GET_ISPR r6
	Lea     _pmr_isr1_mask, r7
	ld.h    0[r7], r7
	and     r7, r6
	cmp     r0, r6
	bne     ei_ret_exc_2

	;/*
	 ;*  ͥȲ1ʾʤ߸ISRʤ㳰ȯ
	 ;*  åݥ󥿤ؤʤ
	 ;*/
	cmp     r0, r13
	bne     ei_ret_exc_1

	;/*
	 ;*  褬ʤ᥹å᤹
	 ;*/
	ld.w    0[sp], sp

ei_ret_exc_1:
	;/*
	 ;*  ISR1¹Ծְʳȯ硤OS߶ػ߾֤β
	 ;*/
	Lea     _nested_lock_os_int_cnt, r12
	ld.b    0[r12], r13
	mov     -1, r14
	add     r14, r13
	st.b    r13, 0[r12]
	cmp     r0, r13
	bne     ei_ret_exc_2

	;/* OSߤ */
	;/* pmr_setting_tbl[current_iintpri] -> PMR */
	Lea     _current_iintpri, r12
	ld.bu   0[r12], r12
	shl     1, r12

	Lea     _pmr_setting_tbl, r13
	add     r12, r13
	ld.h    0[r13], r13
	SET_PMR r13, r12             ;/* set interrupt level */

	;/*
	 ;*  㳰ȯ
	 ;*/
ei_ret_exc_2:
	;/*
	 ;* 쥸
	 ;*/
	mov     sp, ep
	sld.w    4[ep], r10
	ldsr    r10, eipc
	sld.w   0[ep], r10
	ldsr    r10, eipsw

    ;/* å쥸 */
    INT_EXC_RESTOREREG

	stsr    eipsw, r2   ;/* r2 = eipsw */
    shl     PSW_SV, r2  ;/* r2 << PSW_SV ˤ㳰ȯΥ⡼ɼ */
    bnc     return_from_ei_exception    ;/* ø㳰ʤХå */
    Lea     _hook_savedsp, r2
    ld.w    0[r2], r2
    cmp     r0, r2
    be      ei_exception_to_utask
    addi    -4, r2, r2
    ld.w    0[r2], sp                ;/* sp *(hook_savedsp - 4) */
    ;/*
     ;*  ǡhook_savedsp򹹿ɬפϤʤ
     ;*/
    br      return_from_ei_exception
ei_exception_to_utask:
    Lea     _p_runtsk, r2
    ld.w    0[r2], r2
    ld.w    TCB_usp[r2], sp         ;/* usp */
return_from_ei_exception:
    stsr    eiwr, r2
	eiret

	;/*
	 ;*  ͥ뵯ưƤʤ˵CPU㳰̵¥롼
	 ;*/
infinity_loop:
	br infinity_loop

	;/*
	 ;*  ߥȥ
	 ;*  V850E2
	 ;*   ٥ơ֥뤫 Os_Lcfg.c Ƴߤγߥȥ
	 ;*   饸פr2˳ֹ椬¸줿֤Ǽ¹Ԥ
	 ;*  V850E3V5
	 ;*   ٥ơ֥뤫ľܼ¹Ԥ뤿ᡤåγݤ쥸¸
	 ;*   ä˹ԤƤʤ֤Ǽ¹Ԥ
	 ;*/
	.extern _interrupt
_interrupt:
$ifdef __v850e3v5__
    ldsr    r2, eiwr
	;/* װ */
	stsr	eiic,   r2
	;/* EICߤ0x1000  */
	addi   -0x1000, r2, r2
$endif ;/* __v850e3v5__ */
	;/*
	 ;*  ĤΥ쥸 EPǤΥڤؤƹԤ
     ;* ǡCY = EIPSW.IMPr2[31:16] = intno
     ;*  r2OS¦ͽ󤹤ʳߡ㳰ν
     ;*  쥸ȤƻѤˤᡤ
     ;*  å¸ʤ
	 ;*/
    ldsr    r2, fewr                ;/* 顼ɤ¸ */
    stsr    eipsw, r2
    shl     PSW_SV, r2              ;/* r2 << PSW_SV ˤ㳰ȯΥ⡼ɼ */
    stsr    fewr, r2                ;/* 顼ɤ */
    bnc     interrupt_0             ;/* øγߤʤХå */
    ldsr    r5, fewr                ;/* tpr5ˤ */
    Lea     _hook_savedsp, r5
    ld.w    0[r5], r5
    cmp     r0, r5
    be      interrupt_from_utask
    ;/*
     ;*  桼եåؤγ
     ;*  hook_savedsp桼å¸
     ;*  +------------------+ <- sp
     ;*  | hook_savedsp |
     ;*  +------------------+ <- hook_savedsp
     ;*  | ................ |
     ;*  +------------------+
     ;*/
    addi    -4, r5, r5
    st.w    sp, 0[r5]               ;/* *(hook_savedsp - 4) = sp */
    mov     r5, sp                  ;/* sp = hook_savedsp - 4 */   
    stsr    fewr, r5                ;/* tpr5ˤ */
    br      interrupt_0
interrupt_from_utask:
    ;/*
     ;*  桼ؤγ
     ;*/
    Lea     _p_runtsk, r5
    ld.w    0[r5], r5
    st.w    sp, TCB_usp[r5]         ;/* usp¸ */
    ld.w    TCB_p_tinib[r5], r5
    ld.w    TINIB_sstk_bottom[r5], sp         ;/* ssp */
    stsr    fewr, r5                ;/* tpr5ˤ */
interrupt_0:
    ;/* å쥸¸ */
    INT_EXC_SAVEREG

	;/* ¿ųߤΤᡤߤEIPCEIPSW¸ */
	stsr    eipc, r6
	sst.w   r6, 4[ep]
	stsr    eipsw, r6
	sst.w   r6, 0[ep]

$if 0
$ifdef __v850e3v5__
	;/* װ */
	stsr	eiic,   r12
	;/* EICߤ0x1000  */
	addi   -0x1000, r12, r12
$else ;/* __v850e2v3__ */
	;/* 
	 ;* V850E2V3ǤϡOs_Lcfg.c.xxˤװr2ꤵ졤
	 ;* _interrupt ƤӽФ롥
	 ;* r2 ϳߤεĤˤ񤭤뤿r12Ѥ롥 
	 ;*/
	mov     r2, r12
$endif ;/* __v850e3v5__ */
$else
	mov     r2, r12
$endif

	;/* ͥ٤(r11) */
	GET_ISPR r13
	sch1r	r13, r11   
	add		-1,r11

	;/* 
	 ;*  _current_iintpri ι 
	 ;*  ߽ISPRưŪꤵƤ뤿ᡤPMRꤹɬפʤ
	 ;*/
	Lea     _current_iintpri, r6
	ld.bu   0[r6], r19
	st.b    r11,0[r6]

	;/*
	 ;*  ¿ųߤȽ
	 ;*/
	Lea     _except_nest_cnt, r13
	ld.w    0[r13], r6

	;/*
	 ;*  ߡ㳰ΥͥȲΥ󥯥
	 ;*/
	add     1,  r6
	st.w    r6, 0[r13]
	cmp     1,  r6
	bne     interrupt_1     ;/* ͥȤƤϥå̵ */

	;/*
	 ;*  ˳
	 ;*  åݥ󥿤¸ؤ
	 ;*/
	mov     sp , r13
	Lea     __ostkpt, sp
	ld.w    0[r3], r3
	add     -4, sp
	st.w    r13, 0[sp]

interrupt_1:
    ;/*
     ;*  ȯγͥ٥ޥ򥹥å¸
     ;*/
    add     -4, sp
    st.w    r19, 0[sp]

	UNLOCK_ALL_INT

$ifdef CFG_USE_STACKMONITORING
    ;/* 
     ;*  ֹ¸
     ;*  åХեΥץƥեå˲ǽ
     ;*/
    push    r12 
	;/*
	 ;*  åΥХեå
	 ;*/

	;/*
	 ;* ¿ųߤξϥåΥå˥󥰤Ԥʤ
	 ;*/
	cmp     1,  r6
	bne     int_nested

	;/*
	 ;*  åݥ󥿥å
	 ;*/
	Lea     _p_runtsk, r6                   ;/* ֥åƬɥ쥹 */
	ld.w    0[r6], r6
	ld.w    TCB_p_tinib[r6], r6             ;/* ֥åƬɥ쥹 */
    ;/* =begin modified for SC3 */
    ;/* ƥॹå˥ */
	ld.w    TINIB_sstksz[r6], r7            ;/* ƥॹå */
	ld.w    TINIB_sstk_bottom[r6], r6       ;/* ƥॹåüɥ쥹 */
    sub     r7, r6
    mov     r0, r9
	mov     PEOB_STACKMONITORING_INTERRUPT, r8  ;/* ISRǤΥå˥ */
	cmp     r6, r13                         ;/* åݥ <= åƬξNG  */
    Lea     stack_monitoring_exit, lp     
    ;/* =end modified for SC3 */
	bnh      stack_monitoring_error_isr

	;/*
	 ;* ޥåʥСå
	 ;*/
    ld.w    0[r6], r6
    mov     STACK_MAGIC_NUMBER, r7
	;/*
	 ;*  ޥåʥС̤˲ʤ顤߽
	 ;*  ˳硤ߥååʤ
	 ;*/
	cmp     r7, r6
	be      stack_monitoring_exit
    ;/* =begin modified for SC3 */
    Lea     stack_monitoring_exit, lp     
    ;/* =end modified for SC3 */
	br      stack_monitoring_error_isr

	;/* 
	 ;* ¿ųߤξ 
	 ;*/
int_nested:
	;/*
	 ;*  ߥåΥХեå
	 ;*/

	;/*
	 ;*  ḁ̊å
	 ;*/
	Lea     _isr_p_isrcb_tbl, r7
	mov     r12, r11
	shl     2, r11                          ;/* ֹ4ܤƥեåȤ  */
	add     r11, r7
    ld.w    0[r7], r7                       ;/* r7 = &isrcb_table[x] */
    ;/* =begin modified for SC3 */
	ld.w    ISRCB_p_isrinib[r7], r7         
	ld.w    ISRINIB_p_intinib[r7], r7
    mov     1, r9
	mov     PEOB_STACKMONITORING_INTERRUPT, r8  ;/* ISRǤΥå˥ */
    ;/* =end modified for SC3 */
	ld.w    INTINIB_remain_stksz[r7], r7    ;/* ֹбåμ */
	Lea     __ostk, r6                      ;/* ߥåƬɥ쥹 */
	ld.w    0[r6], r6
	add     r6, r7                          ;/* Ƭɥ쥹ISRλѤ륹å */
	cmp     r7, sp                          ;/* åݥ <= Ƭɥ쥹ISRλѤ륹åξOK  */
    ;/* =begin modified for SC3 */
    Lea     stack_monitoring_exit, lp     
    ;/* =end modified for SC3 */
	bnh     stack_monitoring_error_isr

	;/*
	 ;* ޥåʥСå
	 ;*/
	ld.w    0[r6], r6                       ;/* Υɥ쥹μ˥ޥåʥСäƤ */
	mov     STACK_MAGIC_NUMBER, r7
	cmp     r7, r6
    ;/* =begin modified for SC3 */
    Lea     stack_monitoring_exit, lp     
    ;/* =end modified for SC3 */
	bne     stack_monitoring_error_isr

stack_monitoring_exit:
    pop     r12 
$endif ;/* CFG_USE_STACKMONITORING */

	;/*
	 ;*  _callevel_stat ¸
	 ;*/
	Lea     _callevel_stat, r6
	ld.h    0[r6], r7
	Push    r7

	;/*
	 ;*  _callevel_stat 
	 ;*/
	mov     TCL_ISR2, r8
	or      r8, r7
	st.h    r7, 0[r6]

    ;/* =begin added for SC3 */
	;/*
	 ;*  run_trusted ¸
	 ;*/
    Lea     _run_trusted, r6
    ld.b    0[r6], r7
    Push    r7

	;/*
	 ;*  run_trusted 
	 ;*/
	mov     TRUE, r8
    st.b    r8, 0[r6]

	;/*
	 ;*  p_runosap ¸
	 ;*/
    Lea     _p_runosap, r6
    ld.w    0[r6], r7
	Push    r7
    ;/* =end added for SC3 */

	;/*
	 ;* p_runisr ¸
	 ;*/
	Lea     _p_runisr, r6
	ld.w    0[r6], r7
	Push    r7

	;/*
	 ;* p_runisr 
	 ;*/
	Lea     _isr_p_isrcb_tbl, r7
	shl     2, r12                      ;/* ֹ4ܤƥեåȤ  */
	add     r12, r7
	Lea     _p_runisr, r8
	ld.w    0[r7], r7
	st.w    r7, 0[r8]

	;/*
	 ;*  ߥϥɥΥɥ쥹ɤ߹
	 ;*/
	Lea     _isr_tbl, r6
	add     r12, r6

    ;/* =begin modified for SC3 */
    ;/*
     ;*  p_runosap 
     ;*/
    cmp     r7, r0                      ;/* r7 = p_runisr == NULL ? */
    be      int_handler_call            ;/* p_runisr  NULL ǤʤХå */
    ld.w    ISRCB_p_isrinib[r7], ep     ;/* ep = p_runisr->p_isrinib */
    sld.w   ISRINIB_p_osapcb[ep], r8    ;/* r8 = p_runisr->p_isrinib->p_osapcb */
    Lea     _p_runosap, ep
    sst.w   r8, 0[ep]                   ;/* p_runosap = p_runisr->p_isrinib->p_osapcb */

int_handler_call:
    ;/* =end modified for SC3 */
	;/*
	 ;*  ߥϥɥƤӽФ
	 ;*/
	Lea     end_int_handler, r31
	ld.w    0[r6], r6
	jmp     [r6]

	;/*
	 ;*  åХեν
	 ;*/
$ifdef CFG_USE_STACKMONITORING
	;/*
	 ;*  åХեץƥեåƤӽФ
	 ;*  å򹹤˲ʤᡤߥåνͤѤ
     ;*  ISRνХפǤ褦ˤ֤
     ;*  stack_monitoring_errorؤƧ
	 ;*/
stack_monitoring_error_isr:
    br  stack_monitoring_error
$endif ;/* CFG_USE_STACKMONITORING */

end_int_handler:

$ifdef CFG_USE_STACKMONITORING
	;/*
	 ;*  ߥåΥХեå
	 ;*  ߤäåݥ󥿤äϤʤΤǡ
	 ;*  ޥåʥСåΤ߼»
	 ;*/

	;/*
	 ;* ޥåʥСå
	 ;*/
	Lea     __ostk, r6                       ;/* ߥåƬɥ쥹 */
	ld.w    0[r6], r6
	ld.w    0[r6], r6                       ;/* Υɥ쥹μ˥ޥåʥСäƤ */
    ;/* =begin modified for SC3 */
    mov     1, r9
	mov     PEOB_STACKMONITORING_INTERRUPT, r8  ;/* ISRǤΥå˥ */
	mov     STACK_MAGIC_NUMBER, r7
	cmp     r7, r6
    Lea     stack_monitoring_exit2, lp     
	bne     stack_monitoring_error_isr

stack_monitoring_exit2:
    ;/* =end modified for SC3 */
$endif ;/* CFG_USE_STACKMONITORING */

	;/*
	 ;* ISR2λå
	 ;*/
	jarl    _exit_isr2, r31

	;/*
	 ;* p_runisr 
	 ;*/
	Lea     _p_runisr, r7
	Pop     r6
	st.w    r6, 0[r7]

    ;/* =begin modified for SC3 */
	;/*
	 ;*  p_runosap 
	 ;*/
    Lea     _p_runosap, r7
	Pop     r6
    st.w    r6, 0[r7]

	;/*
	 ;*  run_trusted 
	 ;*/
    Lea     _run_trusted, r7
	Pop     r6
    st.b    r6, 0[r7]
    ;/* =end modified for SC3 */


	;/*
	 ;* _callevel_stat 
	 ;*/
	Lea     _callevel_stat, r7
	Pop     r6
	st.h    r6, 0[r7]

;/*
 ;*  ߥϥɥи
 ;*/
ret_int:
	;/*
	 ;* _except_nest_cntȥåڤؤδ֤OS߶ػߤˤ
	 ;* ɬפ
	 ;* 衤ؤΥ꥿󤫡ٱǥѥåʬ롥
	 ;* ؤΥ꥿ˤߤɬפǤꡤٱǥѥåˤ
	 ;* ͥȴOS߶ػߤˤɬפ뤿ᡤǤϰö߶
	 ;* ߤȤ
	 ;*/

	LOCK_ALL_INT

    ;/*
     ;*  ȯγͥ٥ޥ򥹥å
     ;*/
    ld.w    0[sp], r19
    add     4, sp
	Lea     _current_iintpri, r6
	st.b    r19, 0[r6]              ;/* current_iintpri */

	;/*
	 ;*  ߡ㳰ΥͥȲΥǥ
	 ;*/
	Lea     _except_nest_cnt, r6
	ld.w    0[r6], r7
	add     -1, r7
	st.w    r7, 0[r6]

	;/*
	 ;*  ͥȲ0ʤ顤߸
	 ;*/
	cmp     r0, r7
	be      ret_int_task

	;/*
	 ;*  ISR2ߤΥ꥿ϳ߸
	 ;*  ISR2Ǥ뤿᤽Τޤޥ꥿
	 ;*/
	br      ret_int_1


	;/*
	 ;*  ߸ξ
	 ;*/
ret_int_task:
	ld.w    0[sp], sp                       ;/* åݥ󥿤᤹     */

	;/*  
     ;*  ͥ٥ޥѤAPIʤᡤ
     ;*  ATK2Ǥϳͥ٥ޥ
     ;*/
	;/*
	 ;*  ߥϥɥ¹ԻˤϡISPRͥ٤ưŪ˾夬뤿ᡤ
	 ;*  PMRѹƤʤߥϥɥ x_nested_unlock_os_int() 
	 ;*  ƤӽФPMR񤭴롥ǥѥåɬפǤʤϡret_int_1
	 ;*  PMR򸵤᤹ͤǥѥåɬפʾϡOS߶ػߤȤ뤿ᡤ
	 ;*  ǡPMR򹹿ɬפϤʤ
	 ;*/

	;/*
	 ;*  褬ξ硤ǥѥåɬפ뤫å
	 ;*/
	Lea     _p_runtsk, r6
	ld.w    0[r6], r6
	Lea     _p_schedtsk, r7
	ld.w    0[r7], r7
	cmp     r6, r7
	be      ret_int_1      ;/* ǥѥåɬפʤг߸ */

	;/*
	 ;*  Ǥϡ褬Ǥꡤåϡå
	 ;*  å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
	 ;*  ߤػߤ֤ȤʤäƤ
	 ;*/

	;/* 
	 ;*  ͥ٥ޥΥꥢ 
	 ;*  eiret¹Ԥʤᡤeiretˤߥȥͥ٥ޥ
	 ;*  (󥵡ӥץ饤ƥ)ΥꥢԤʤᡤISPC
	 ;*  Ѥƥꥢ롥
	 ;*/
	CLEAR_ISPR r10, r12

	;/*
	 ;*  OS߶ػ߾֤˰ܹԤ
	 ;*
	 ;*  λOS߶ػ߾֤ȤΤϡdispatcher¹Ԥݤ
	 ;*  OS߶ػ߾֤ˤʤäƤɬפ뤿Ǥ
	 ;*
	 ;*  (ǥ)ͥ٥ޥ0Ǥ뤿ᡤISR1ʳγߤƶػߤ
	 ;*/

	OUTER_LOCK_OS_INT r12, r13
	;/* ret_int ߶ػ߾֤Ȥ */
	UNLOCK_ALL_INT

	;/*
	 ;* ƥȤ 
	 ;*/
	addi    -48, sp, sp
	mov     sp, ep
	sst.w   r10, 44[ep]
	sst.w   r11, 40[ep]
	sst.w   r20, 36[ep]
	sst.w   r21, 32[ep]
	sst.w   r22, 28[ep]
	sst.w   r23, 24[ep]
	sst.w   r24, 20[ep]
	sst.w   r25, 16[ep]
	sst.w   r26, 12[ep]
	sst.w   r27, 8[ep]
	sst.w   r28, 4[ep]
	sst.w   r29, 0[ep]

	;/* åȼεưϤ¸ */
	Lea     _p_runtsk, ep
	sld.w   0[ep], ep
    ;/* =begin modified for SC3 */
	sst.w   sp, TCB_ssp[ep]
    ;/* =end modified for SC3 */
	Lea     ret_int_r, r6
	sst.w   r6, TCB_pc[ep]
	br      dispatcher

	;/*
	 ;*  ߡ㳰ǥƥ¸롼
	 ;*/
ret_int_r:
	;/*
	 ;* ƥȤ
	 ;*/
	mov     sp, ep
	sld.w   44[ep], r10
	sld.w   40[ep], r11
	sld.w   36[ep], r20
	sld.w   32[ep], r21
	sld.w   28[ep], r22
	sld.w   24[ep], r23
	sld.w   20[ep], r24
	sld.w   16[ep], r25
	sld.w   12[ep], r26
	sld.w   8[ep], r27
	sld.w   4[ep], r28
	sld.w   0[ep], r29
	addi    48, ep, sp

	LOCK_ALL_INT

	OUTER_UNLOCK_OS_INT r12, r13
	;/*
	 ;*  ߤ롼
	 ;*/
ret_int_1:
	;/*
	 ;* 쥸
	 ;*/
	mov     sp, ep

	;/*  
     ;*  ͥ٥ޥѤAPIʤᡤ
     ;*  ATK2Ǥϳͥ٥ޥ
     ;*/
	;/*
	 ;*  PMR򸵤᤹
	 ;*  ߥϥɥ¹ԻˤϡISPRͥ٤ưŪ˾夬뤿ᡤ
	 ;*  PMRѹƤʤߥϥɥ x_nested_unlock_os_int() 
	 ;*  ƤӽФPMR񤭴뤿ᤳǸ᤹ͤ
	 ;*  OUTER_UNLOCK_OS_INT  nested_lock_os_int_cnt 0ˤ뤬
	 ;*  Ǥϴ0Ǥ뤿ʤ
	 ;*/
	OUTER_UNLOCK_OS_INT  r1, r6
	sld.w    4[ep], r10
	ldsr    r10, eipc
	sld.w   0[ep], r10
	ldsr    r10, eipsw

    ;/* å쥸 */
    INT_EXC_RESTOREREG

	stsr    eipsw, r2           ;/* r2 = eipsw */
    shl     PSW_SV, r2          ;/* r2 << PSW_SV ˤ㳰ȯΥ⡼ɼ */
    bnc     return_from_int     ;/* øγߤʤХå */
    Lea     _hook_savedsp, r2
    ld.w    0[r2], r2
    cmp     r0, r2
    be      int_to_utask
    addi    -4, r2, r2
    ld.w    0[r2], sp                ;/* sp *(hook_savedsp - 4) */
    ;/*
     ;*  ǡhook_savedsp򹹿ɬפϤʤ
     ;*/
    br      return_from_int
int_to_utask:
    Lea     _p_runtsk, r2
    ld.w    0[r2], r2
    ld.w    TCB_usp[r2], sp     ;/* usp */
return_from_int:
    stsr    eiwr, r2
	eiret

;/*
 ;* ǥѥå
 ;*/
	.extern _dispatch
_dispatch:
	;/*
	 ;*  Υ롼ϡƥȡOS߶ػ߾֡ǥѥå
	 ;*  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
	 ;*  
	 ;*/
	addi    -60, sp, sp
	st.w    ep,  0[sp]
	mov     sp,  ep
	sst.w   r2,  56[ep]
	sst.w   r10, 52[ep]
	sst.w   r11, 48[ep]
	sst.w   r20, 44[ep]
	sst.w   r21, 40[ep]
	sst.w   r22, 36[ep]
	sst.w   r23, 32[ep]
	sst.w   r24, 28[ep]
	sst.w   r25, 24[ep]
	sst.w   r26, 20[ep]
	sst.w   r27, 16[ep]
	sst.w   r28, 12[ep]
	sst.w   r29, 8[ep]
	sst.w   r31, 4[ep]
	;/* åȼεưϤ¸ */
	Lea     _p_runtsk, ep
	sld.w   0[ep], ep
    ;/* =begin modified for SC3 */
	sst.w   sp, TCB_ssp[ep]
    ;/* =end modified for SC3 */
	Lea     dispatch_r, r10
	sst.w   r10, TCB_pc[ep]
$ifdef CFG_USE_STACKMONITORING
	;/*
	 ;*  ¹楿ΥåΥХեå
	 ;*/
	;/*
	 ;*  åݥ󥿥å
	 ;*/
	Lea     _p_runtsk, r6                   ;/* ֥åƬɥ쥹 */
	ld.w    0[r6], r6
	ld.w    TCB_p_tinib[r6], r6             ;/* ֥åƬɥ쥹 */
    ;/* =begin modified for SC3 */
    ;/* ƥॹå˥ */
	ld.w    TINIB_sstksz[r6], r7            ;/* ƥॹå */
	ld.w    TINIB_sstk_bottom[r6], r6       ;/* ƥॹåüɥ쥹 */
    sub     r7, r6
    mov     1, r9
	mov     PEOB_STACKMONITORING_DISPATCH, r8  ;/* ǥѥåǤΥå˥ */
	cmp     r6, sp                          ;/* åݥ <= åƬξNG  */
    Lea     dispatcher, lp
    ;/* =end modified for SC3 */
	bnh      stack_monitoring_error
	;/*
	 ;* ޥåʥСå
	 ;*/
	ld.w    0[r6], r6
	mov     STACK_MAGIC_NUMBER, r7
	cmp     r7, r6
    ;/* =begin modified for SC3 */
    Lea     dispatcher, lp
    ;/* =end modified for SC3 */
	bne     stack_monitoring_error
$endif ;/* CFG_USE_STACKMONITORING */
	br      dispatcher

	;/* 
	 ;* ǥѥå롼 
	 ;*/
dispatch_r:
	mov     sp, ep
	sld.w   56[ep], r2
	sld.w   52[ep], r10
	sld.w   48[ep], r11
	sld.w   44[ep], r20
	sld.w   40[ep], r21
	sld.w   36[ep], r22
	sld.w   32[ep], r23
	sld.w   28[ep], r24
	sld.w   24[ep], r25
	sld.w   20[ep], r26
	sld.w   16[ep], r27
	sld.w   12[ep], r28
	sld.w    8[ep], r29
	sld.w    4[ep], r31
	addi    60, ep, sp
	ld.w    0[sp], ep
	jmp     [lp]

	;/*
	 ;*  åХեν
	 ;*/
$ifdef CFG_USE_STACKMONITORING
	;/*
	 ;*  åХեץƥեåƤӽФ
	 ;*  å򹹤˲ʤᡤߥåνͤѤ
     ;*  r8 = å˥󥰤򤷤ս
     ;*   PEOB_STACKMONITORING_TERMTASK ||
     ;*   PEOB_STACKMONITORING_DISPATCH ||
     ;*   PEOB_STACKMONITORING_INTERRUPT
     ;*  r9 = ostkptνͤڤؤ뤫?
	 ;*/
stack_monitoring_error:
	;/*
	 ;*  r9==0ξǤ⡤_ostkptȤäƤΤǡ
	 ;*  except_nest_cnt򥤥󥯥ȤƤϤʤ
	 ;*/
	Lea     _except_nest_cnt, r12               ;/* _ostkptȤexcept_nest_cnt򥤥󥯥Ȥ */
	ld.w    0[r12], r13
	add     1, r13
	st.w    r13, 0[r12]

    ;/* =begin modified for SC3 */
    cmp     r0, r9
    be      stack_monitoring_error_1
    ;/* =end modified for SC3 */

	Lea    __ostkpt, r12                        ;/* å򹹤˲ʤᡤߥåνͤѤ */
	ld.w    0[r12], r12
	mov     r12, sp

    ;/* =begin modified for SC3 */
stack_monitoring_error_1:
	;/*
	 ;*  ץƥեåOS߶ػ߾֤ǸƤӽФ
	 ;*/
	NESTED_LOCK_OS_INT r12, r13
    ;/* =end modified for SC3 */

	mov     E_OS_STACKFAULT, r6                 ;/* ץƥեåΰ */
    or      r8, r6                              ;/* r6 = E_OS_STACKFAULT | PEOB_STACKMONITORING_XXX */
    ;/* =begin modified for SC3 */
    push    lp
	jarl    _call_protectionhk_main, r31        ;/* ץƥեåƤӽФ */
    pop     lp

	;/*
	 ;*  except_nest_cntǥ
	 ;*/
	Lea     _except_nest_cnt, r12
	ld.w    0[r12], r13
	add     -1, r13
	st.w    r13, 0[r12]
	;/*
	 ;*  OS߶ػ߾֤򥢥ͥ
	 ;*/
	NESTED_UNLOCK_OS_INT r12, r13
    jmp     [lp]
    ;/* =end modified for SC3 */
$endif ;/* CFG_USE_STACKMONITORING */


;/*
 ;*  ǥѥåư
 ;*/
	.extern _start_dispatch
_start_dispatch:
	;/*
	 ;*  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
	 ;* ߶ػ߾֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
	 ;*  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ
	 ;*
	 ;*  dispatcherϡOS߶ػ߾֤ǸƤӽФ
	 ;*/
	;/* OS߶ػ߾ */
	OUTER_LOCK_OS_INT r12, r13
	;/* ߶ػ߲֤ */
	UNLOCK_ALL_INT
	br    dispatcher_0

    ;/* =begin modified for SC3 */
	.extern _exit_and_dispatch_nohook
	;/*
	 ;*  λξPostTaskHookƽФʤ
	 ;*  ξΥȥǤ
	 ;*/
_exit_and_dispatch_nohook:

	br    dispatcher_0
    ;/* =end modified for SC3 */

	;/*
	 ;*  ߤΥƥȤΤƤƥǥѥå
	 ;*/
	.extern _exit_and_dispatch
_exit_and_dispatch:
$ifdef CFG_USE_STACKMONITORING
	;/*
	 ;*  ¹ΥåΥХեå
	 ;*/
	;/*
	 ;*  åݥ󥿥å
	 ;*/
	Lea     _p_runtsk, r6                   ;/* ֥åƬɥ쥹 */
	ld.w    0[r6], r6
	ld.w    TCB_p_tinib[r6], r6             ;/* ֥åƬɥ쥹 */
    ;/* =begin modified for SC3 */
    ;/* ƥॹå˥ */
	ld.w    TINIB_sstksz[r6], r7            ;/* ƥॹå */
	ld.w    TINIB_sstk_bottom[r6], r6       ;/* ƥॹåüɥ쥹 */
    sub     r7, r6
    mov     1, r9
	mov     PEOB_STACKMONITORING_TERMTASK, r8  ;/* λΥå˥ */
	cmp     r6, sp                          ;/* åݥ <= åƬξNG  */
    Lea     dispatcher, lp
    ;/* =end modified for SC3 */
	bnh      stack_monitoring_error
	;/*
	 ;* ޥåʥСå
	 ;*/
	ld.w    0[r6], r6
	mov     STACK_MAGIC_NUMBER, r7
	cmp     r7, r6
    ;/* =begin modified for SC3 */
    Lea     dispatcher, lp
    ;/* =end modified for SC3 */
	bne     stack_monitoring_error
$endif ;/* CFG_USE_STACKMONITORING */
	;/* ǥѥåΡdispatcherˤ */

dispatcher:
	;/*
	 ;*  PostTaskHookθƤӽФ
	 ;*/
$ifdef CFG_USE_POSTTASKHOOK
	Lea     _PostTaskHook, r20
	cmp     r20, r0
	be      dispatcher_0
posttaskhook_call:
	Lea     _call_posttaskhook, r6
	jarl    _stack_change_and_call_func_1, r31
$endif ;/* CFG_USE_POSTTASKHOOK */

dispatcher_0:
	;/*
	 ;*  Υ롼ϡƥȡOS߶ػ߾֡ǥѥå
	 ;*  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
	 ;*  롥¹ԺƳϤؤ⤳ξ֤Τޤʬ
	 ;*/
$ifdef LOG_DSP_ENTER
	Lea     _p_runtsk, r21
	ld.w    0[r21], r21
	cmp     r0, r21
	be      dispatcher_0_1
	mov     r21, r6                            ;/* _p_runtsk */
	jarl    _log_dsp_enter, r31
dispatcher_0_1:
$endif	;/* LOG_DSP_ENTER */

	Lea     _callevel_stat, r21
	ld.h    0[r21], r22
	mov     TSYS_DISALLINT, r20
	and     r22, r20
	be      dispatcher_1

	mov     !TSYS_DISALLINT, r20
	and     r22, r20
	st.h    r20, 0[r21]
	UNLOCK_ALL_INT                             ;/* ߶ػ߲֤ */

	;/*
	 ;*  㳰ʳ/CPU㳰ˤΥͥȲstart_dispatch䡤dispatcher_3:
	 ;*  褿'1'ȤʤäƤ뤿ᡤåڤ괹塤
	 ;*  '0'˽롥
	 ;*/
dispatcher_1:
	Lea     _p_runtsk, r21
	Lea     _p_schedtsk, r20
	ld.w    0[r20], r22
	st.w    r22, 0[r21]
	cmp     r22, r0
	be      dispatcher_3

	mov     r22, ep 
    ;/* =begin modified for SC3 */
	sld.w   TCB_ssp[ep], sp
    ;/* =end modified for SC3 */
	Lea     _except_nest_cnt, r20
	st.w    r0, 0[r20]

    ;/* =begin modified for SC3 */
    sld.w   TCB_p_tinib[ep], ep
    mov     ep, r25                     ;/* r25 = p_tinib */
    sld.w   TINIB_p_osapcb[ep], r26     ;/* r26 = p_osapcb */
    Lea     _p_runosap, ep              ;/* ep = &p_runosap */
    sst.w   r26, 0[ep]                  ;/* p_runosap = p_osapcb */
    ld.w    OSAPCB_p_osapinib[r26], r29 ;/* r29 = p_osapinib */
    ld.bu   OSAPINIB_osap_trusted[r29], r24 ;/* r24 = trusted? */
    Lea     _run_trusted, ep
    sst.b   r24, 0[ep]                      ;/* run_trusted = trusted? */
    cmp     r0, r24                         ;/* ʤХå */
    bne     dispatcher_5

$ifdef __v850e2v3__
    ori     0x1001, r0, r27
    ldsr    r27, bsel
    ;/*
     ;*  桼åΰ
     ;*/
    mov     r25, ep
    sld.w   TINIB_start_ustk[ep], r27   ;/* Ƭ */
    ori     0x01, r27, r27
    sld.w   TINIB_limit_ustk[ep], r28   ;/* ݸ°ȥ */
    ori     0x06, r28, r28
    ldsr    r27, dpa0l
    ldsr    r28, dpa0u
$elseif defined(__v850e3v5__)
    ;/*
     ;*  桼åΰ
     ;*/
    mov     r25, ep
    sld.w   TINIB_start_ustk[ep], r27   ;/* Ƭ */
    sld.w   TINIB_limit_ustk[ep], r28   ;/* ݸ°ȥ */
    ldsr    r27, 0, 6                   ;/* MPLA0 */
    ldsr    r28, 1, 6                   ;/* MPUA0 */

$endif ;/* __v850e2v3__ */

   	;/*
	 ;*  ¹ԥɥᥤݸɥᥤ(MPU)ƱʤС
     ;*  ɥᥤΥΰ衦ǡΰMPUꤷľɬפϤʤ
     ;*/
    Lea     _p_ctxosap, ep      ;/* ep = &p_ctxosap */	
    sld.w   0[ep], r27          ;/* r27 = p_ctxosap */
	cmp     r27, r26            ;/* p_ctxosap == p_runosap ? */
	be      dispatcher_5        ;/* Ʊʤdispatcher_5 */
    nop
	sst.w   r26, 0[ep]          ;/* p_ctxosap = p_runosap : ݸɥᥤؤ */
$ifdef __v850e2v3__
    ldsr    r26, vmtid          ;/* ݸȿ̻Ҥp_runosapȤ */
    mov     r29, ep             ;/* ep = p_osapinib */

    ;/*
     ;*  ݸɥᥤѤromΰ
     ;*/
    sld.w   OSAPINIB_start_text[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_text[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, ipa0l
    ldsr    r28, ipa0u
    ;/*
     ;*  ݸɥᥤѤrosdataΰ
     ;*/
    sld.w   OSAPINIB_start_rosdata[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_rosdata[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, ipa1l
    ldsr    r28, ipa1u
    ;/* 
     ;* ݸɥᥤѤRWXΰ
     ;*/
    sld.w   OSAPINIB_start_ram[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_ram[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, dpa1l
    ldsr    r28, dpa1u
    ;/* 
     ;* ݸɥᥤѤRWXΰ(sdata)
     ;*/
    sld.w   OSAPINIB_start_sram[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_sram[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, dpa2l
    ldsr    r28, dpa2u
    ;/*
     ;* ͭ꡼/ѥ饤ΰΰ
     ;*/
    sld.w   OSAPINIB_start_srpw[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_srpw[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, dpa3l
    ldsr    r28, dpa3u
     ;/*
     ;* ͭ꡼/ѥ饤ΰΰ(sdata)
     ;*/
    sld.w   OSAPINIB_start_ssrpw[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_ssrpw[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, dpa4l
    ldsr    r28, dpa4u

$elseif defined(__v850e3v5__)
    mov     r29, ep             ;/* ep = p_osapinib */

$ifdef MPU_REGION_11
    ;/*
     ;*  ݸɥᥤѤromΰ
     ;*/
    sld.w   OSAPINIB_start_text[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_text[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, 16, 6                     ;/* MPLA4 */
    ldsr    r28, 17, 6                     ;/* MPUA4 */

    ;/*
     ;*  ݸɥᥤѤrosdataΰ
     ;*/
    sld.w   OSAPINIB_start_rosdata[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_rosdata[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, 20, 6                     ;/* MPLA5 */
    ldsr    r28, 21, 6                     ;/* MPUA5 */

    ;/* 
     ;* ݸɥᥤѤRWXΰ
     ;*/
    sld.w   OSAPINIB_start_ram[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_ram[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, 24, 6                     ;/* MPLA6 */
    ldsr    r28, 25, 6                     ;/* MPUA6 */

    ;/* 
     ;* ݸɥᥤѤRWXΰ(sdata)
     ;*/
    sld.w   OSAPINIB_start_sram[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_sram[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, 28, 6                     ;/* MPLA7 */
    ldsr    r28, 29, 6                     ;/* MPUA7 */

$endif ;/* (MPU_REGION_NUM >= 11) */

    ;/*
     ;* ͭ꡼/ѥ饤ΰΰ
     ;*/
    sld.w   OSAPINIB_start_srpw[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_srpw[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, 4, 6                     ;/* MPLA1 */
    ldsr    r28, 5, 6                     ;/* MPUA1 */

    ;/*
     ;* ͭ꡼/ѥ饤ΰΰ(sdata)
     ;*/
    sld.w   OSAPINIB_start_ssrpw[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_ssrpw[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, 8, 6                      ;/* MPLA2 */
    ldsr    r28, 9, 6                      ;/* MPUA2 */

    sld.w   OSAPINIB_mprc[ep], r27  ;/* MPRC */
    ldsr    r27, 1, 5
$endif ;/* __v850e2v3__ */

dispatcher_5:
$ifdef __v850e2v3__
    ldsr    r0, bsel    ;/* bsel᤹ */
$endif ;/* __v850e2v3__ */
    ;/* =end modified for SC3 */

$ifdef LOG_DSP_LEAVE
	ld.w    0[r21], r6                          ;/* _p_runtsk */
	jarl    _log_dsp_leave, r31
$endif	;/* LOG_DSP_LEAVE */

$ifdef CFG_USE_PRETASKHOOK
	Lea     _PreTaskHook, r20
	cmp     r20, r0
	be      dispatcher_2

pretaskhook_call:
	Lea     _call_pretaskhook, r6
	jarl    _stack_change_and_call_func_1, r31
$endif ;/* CFG_USE_PRETASKHOOK */

dispatcher_2:
	Lea     _p_runtsk, r20
	ld.w    0[r20], r22
	mov     r22, ep
	sld.w   TCB_pc[ep], r31
	jmp     [r31]

dispatcher_3:
	;/*
	 ;* OS߶ػ߾֤βȡ󥿥ƥȼ¹Ծ֤ؤ
	 ;* 򤹤
	 ;*
	 ;*  󥿥ƥȤڤؤsp󥿥ƥ
	 ;*  ѥåݥ󥿡except_nest_cnt1)ΤϡOS߶ػ߲
	 ;*  ȯ߽ˤɤΥåȤȤβ
	 ;*  ȡߥϥɥǤΥǥѥåɻߤȤ2Ĥΰ
	 ;*  ̣
	 ;*/
	Lea     __ostkpt, r20		;/* 󥿥ƥѤΥåɤ߹ߥåݥ󥿤ؤ */
	ld.w    0[r20], r3

	Lea     _except_nest_cnt, r20
	mov     1, r21
	st.w    r21, 0[r20]

	;/*
	 ;*  OS߶ػ߲֤
	 ;*  ߤĤ󥿥ƥȼ¹Ծ֤ȤߤԤ
	 ;*
	 ;*  ץåԤ˰ܹԤȡߵĤȤϡԲ
	 ;*  ʬ˹Ԥʤɬפ
	 ;*  Բʬ˹Ԥʤʤ硤ߤĤľ˳
	 ;*  ߤꡤǥ¹Բǽ֤ˤʤȡ¹Ԥ٤
	 ;*  ˤ⤫餺ץåԤˤʤäƤޤ
	 ;*  Բʬ˹ԤᡤdiˤꥳǤγߤػߤ֤ǡ
	 ;*  INTCγͥ٥ޥ򲼤ƤhaltƤӽФ
	 ;*  ߤȯϡhaltƼeiǥ٥
	 ;*  פ롥
	 ;*
	 ;*  Ԥδ֤ϡp_runtskNULLʡ0ˤꤷʤФʤʤ
	 ;*  Τ褦ꤷʤȡߥϥɥ餫GetTaskIDƤӽ
	 ;*  ݤưͤ˹פʤʤ
	 ;*/

	di
	OUTER_UNLOCK_OS_INT r12, r13

$if 0
	nop
	nop
	nop
	nop
$else
	halt
$endif
	ei

	;/*
	 ;*  OS߶ػ߾֤
	 ;*  (ǥ)ͥ٥ޥ0Ǥ뤿ᡤISR1ʳγߤƶػߤ
	 ;*  å󥿥ƥȤΥåѤƤ뤿ᡤ_except_nest_cntϡ
	 ;*  '1'ΤޤޤȤ
	 ;*/
	OUTER_LOCK_OS_INT r12, r13
	br      dispatcher_1


;/*
 ;*  ϻ
 ;*
 ;*  dispatcherƤӽФ
 ;*/
    ;/* =begin modified for SC3 */
	.extern _start_stask_r
_start_stask_r:
    Lea		_p_runtsk, ep                   ;/* ep = p_runtsk */
	sld.w	0[ep], ep
	;/*
	 ;*  λݸԤ褦
	 ;*  ꥢɥ쥹exit_task
	 ;*/
	Lea     __kernel_exit_task, r31
    mov     r0, r6
    br      _start_r

	.extern _start_utask_r
_start_utask_r:
$ifndef __v850e3v5__
    ldsr    r0, bsel
$endif
    Lea		_p_runtsk, ep                   ;/* ep = p_runtsk */
	sld.w	0[ep], ep
    clr1    0, TCB_priv_mode[ep]            ;/* ø⡼ɼ¹Ԥȴ */
    sld.w   TCB_p_tinib[ep], r20            ;/* ep = p_runtsk->p_tinib */
    ld.w    TINIB_ustk_bottom[r20], r20     ;/* r20 = 桼åݥ󥿤ν */
    mov     r20, sp
	;/*
	 ;*  λݸԤ褦
	 ;*  ꥢɥ쥹exit_utask
	 ;*/
    Lea     _exit_utask, lp                 ;/* lp = _exit_utask */
    stsr    psw, r10

    ;/* 
     ;*  ߶ػ߾֤
     ;*  ƥȤؤΥפǲ
     ;*/
    di

    ;/* 
	 ;* ø⡼ɤư褦
     ;* ݸǽͭءˡߵ
     ;* PP,NPV,DMP,IMP = 1, ID = 0
     ;*/
$ifdef __v850e2v3__
    movhi   0x000f, r0, r7                  
$elseif defined(__v850e3v5__)
    movhi   0x4000, r0, r7  
$endif ;/* __v850e2v3__ */
    or      r7, r10         ;/* psw |= (PP|NPV|DMP|IMP) */
	ldsr    r10, eipsw      ;/* eipsw = psw */
    mov     1, r6

	.extern _start_r
_start_r:
	ld.w    TCB_p_tinib[ep], r22
$ifdef CFG_USE_STACKMONITORING
	;/*
	 ;*  SC3ǤϥλΤǡư˥ޥåʥС
	 ;*  
	 ;*/
	ld.w    TINIB_sstk_bottom[r22], r21
    ld.w    TINIB_sstksz[r22], r10
    sub     r10, r21
	mov     STACK_MAGIC_NUMBER, r10
	st.w	r10, 0[r21]
$endif ;/* CFG_USE_STACKMONITORING */

	;/*
	 ;*  OS߶ػ߲˸ͥ(TCB.curpri)¹ͥ(TINIB.exepri)
	 ;*  ѹ(꥽)
	 ;*/
	ld.b    TINIB_exepri[r22], r21			;/* TINIB.exepri -> TCB.curpri */
	st.b    r21, TCB_curpri[ep]

	;/*
	 ;*  OS߶ػ߲֤
	 ;*  (ǥ)ͥ٥ޥ0Ǥ뤿ᡤͭʳߤƵĤ
	 ;*/

	OUTER_UNLOCK_OS_INT r12, r13

	ld.w    TCB_p_tinib[ep], r22
	ld.w    TINIB_task[r22], r10
    cmp     r0, r6
    bne     _start_r_1              ;/* r6 != 0 ʤ _start_r_1 */
	jmp     [r10]

_start_r_1:
	ldsr    r10, eipc               ;/* EIPC = pc */
    eiret
    ;/* =end modified for SC3 */

    ;/*
     ;*  ext_tsksvc̿ǸƤӽФ
     ;*/
    shared.text .cseg text
    .align 4
    .public _exit_utask
_exit_utask:
    mov     TFN_EXIT_TASK, r11
    syscall NO_SVC
    nop

    kernel.text .cseg text
	.extern _stack_change_and_call_func_1 
	.extern _stack_change_and_call_func_2
_stack_change_and_call_func_1:
_stack_change_and_call_func_2:

	Lea     _except_nest_cnt, r12
	ld.w    0[r12], r13
	add     1, r13
	st.w    r13, 0[r12]
	cmp     1, r13
	bne     _stack_change_and_call_func_1_1

	;/* åݥ󥿤¸ؤ */
	Lea     __ostkpt, r12
	ld.w    0[r12], r12
	add     -4, r12
	st.w    sp, 0[r12]                      ;/* åݥ󥿤¸ */
	mov     r12, sp                         ;/* åݥ󥿤ڤؤ */
    

_stack_change_and_call_func_1_1:
	push    lp
	Lea     stack_change_and_call_func_r, lp  ;/* ꥢɥ쥹 */
	mov     r6, r12
	mov     r7, r6
	mov     r8, r7
	jmp     [r12]

stack_change_and_call_func_r:
	pop     lp
	Lea     _except_nest_cnt, r12
	ld.w    0[r12], r13
	add     -1, r13
	st.w    r13, 0[r12]
	cmp     r0, r13
	bne     stack_change_and_call_func_r_1

	ld.w    0[sp], sp                    ;/* åݥ󥿤     */
stack_change_and_call_func_r_1:
	jmp     [lp]


$ifdef ENABLE_RETURN_MAIN
;/*
 ;*  AKTSPѤmain()ؤΥ꥿󥳡
 ;*/
	.extern _return_main
_return_main:
	Lea   __ostkpt, sp
	ld.w  0[sp],sp
	jarl  _main, r31
$endif ;/* ENABLE_RETURN_MAIN */

    ;/* =begin modified for SC3 */
;/*
 ;*  SYSCALLơ֥
 ;*  syscall̿ϡscbp + scbp[x] Ϥ˥פ
 ;*/
    .public _syscall_table
    kernel.text .cseg text
    .align 4
_syscall_table:
    .dw (_syscall_error_handler - _syscall_table)
    .dw (_svc_entry - _syscall_table)
    .dw (_call_nontrusted_hook_trap_ret - _syscall_table)

    .public _syscall_error_handler
    .public _svc_entry
;/*
 ;*  SYSCALL顼ϥɥ
 ;*/
_syscall_error_handler:
    br  _syscall_error_handler
    nop

;/*
 ;*  ӥν
 ;*  PP,NPV,DMP,IMP = 0, ID,EP = 1
 ;*  eipc = pc, eipsw = psw : ei¸
 ;*    r10 : ֤
 ;*    r11ؿ
 ;*    r6 - r9 : 4Ĥޤǡ
 ;*    r20 : 5
 ;*    å쥸¸Ѥ
 ;*    lp¸Ѥ
 ;*/
_svc_entry:
    ;/*
     ;*  ƽФø⡼ɤ
     ;*  eipswå
     ;*/
$ifndef __v850e3v5__
    ldsr    r0, bsel
$endif
    stsr    eipsw, r13
    shl     PSW_SV, r13         ;/* r13 << PSW_SV ˤ㳰ȯΥ⡼ɼ */
    bnc     svc_entry_2         ;/* ø⡼ɤθƽФʤХå */

    ;/*
     ;*  ƽФեå¹椫
     ;*  hook_savedspå
     ;*  եå¹ʤХå
     ;*/
    Lea     _hook_savedsp, ep
    sld.w   0[ep], ep
    cmp     r0, ep
    be      svc_entry_1             ;/* hook_savedsp == 0:ƥ */
    addi    -4, ep, ep
    sst.w   sp, 0[ep]               ;/* *(hook_savedsp - 4) = sp */
    mov     ep, sp                  ;/* sp = hook_savedsp - 4 */   
    br      svc_entry_2

svc_entry_1:
    ;/*
     ;*  ƥȤθƽФξ
     ;*/
    ;/*
     ;*  桼åȥƥॹåؤ
     ;*  ξ֤ø⡼ɼ¹˰ܹԤ
     ;*  褬ø⡼ɤեå¹ǤʤС
     ;*  ¹ǤϤʤΤǡp_runtskNULLɤ
     ;*  åɬפʤϤ
     ;*/
    Lea     _p_runtsk, ep
    sld.w   0[ep], ep
    set1    0, TCB_priv_mode[ep]    ;/* p_runtsk->priv_mode |= 0x01 */
    sst.w   sp, TCB_usp[ep]         ;/* usp¸ */
    sld.w   TCB_p_tinib[ep], ep
    sld.w   TINIB_sstk_bottom[ep], sp         ;/* ssp */

svc_entry_2:
    ;/*
     ;*  eipceipswsyscallƽФpcpswˤ¸
     ;*  ߤ꥿
     ;*  +--------------+ <- new sp
     ;*  | eipsw        |
     ;*  +--------------+
     ;*  | eipc         |
     ;*  +--------------+ <- old sp
     ;*/
    addi    -8, sp, sp
    mov     sp, ep
    stsr    eipc, r12
    sst.w   r12, 4[ep]
    stsr    eipsw, r12
    sst.w   r12, 0[ep]
    ;/*
     ;*  eipswݸϢӥåȤ0ˤ
     ;*/
$ifdef __v850e2v3__
    movhi   0x000f, r0, r13
$elseif defined(__v850e3v5__)
    movhi   0x4000, r0, r13
$endif ;/* __v850e2v3__ */
    not     r13, r13
    and     r13, r12
    ldsr    r12, eipsw          ;/* PP,NPV,DMP,IMP = 0 */
    Lea     svc_entry_3, r12
    ldsr    r12, eipc
    eiret

svc_entry_3:
    ;/*
     ;*  ǽɤΥå
     ;*/
    mov     TMAX_SVCID, r12
    cmp     r12, r11            ;/* ǽɤξ¥å(TMAX_SVCID < r11) */
    bgt     svc_entry_error     ;/* ¤򥪡ФƤʤХ顼 */

    ;/*
     ;*  ӥΥơ֥
     ;*  ӥΤƤ
     ;*/
    Lea     _svc_table, r12
    shl     2, r11                  ;/* r11 *= 4 */
    add     r11, r12                ;/* r12 = &svc_table[r11] */
	ld.w    0[r12], r12             ;/* ơ֥ */
    Lea     svc_entry_r, lp         ;/* Ϥ */
	jmp     [r12]                   ;/* ӥ롼Ƥ */
    nop

svc_entry_error:
    jarl    _no_support_service, lp ;/* no_support_service Ƥ */

svc_entry_r:
    ;/*
     ;*  λǤpswr11¸
     ;*  ߶ػߤǹؤб
     ;*/
    stsr    psw, r11

    ;/*
     ;*  ߶ػ߾֤
     ;*/
    di

    ;/*
     ;*  eipceipswsyscallƽФpcpswˤ
     ;*  Ǥϡ߽ǤʤʥӥƽФ
     ;*  eiretȯԤƤˤeiretѤƥ꥿󤹤
     ;*  +--------------+ <- old sp
     ;*  | eipc         |
     ;*  +--------------+
     ;*  | eipsw        |
     ;*  +--------------+ <- new sp
     ;*/
    mov     sp, ep
    sld.w   4[ep], r15
    sld.w   0[ep], r16
    addi    8, sp, sp

    ;/*
	 ;*  å᤹å
	 ;*/
    ;/*
     ;*  ƽФø⡼ɤ
     ;*  eipswå
     ;*/
$ifdef __v850e2v3__
    ldsr    r0, bsel
    movhi   0x000f, r0, r12
$elseif defined(__v850e3v5__)
    movhi   0x4000, r0, r12
$endif ;/* __v850e2v3__ */
    tst     r16, r12
    be      svc_prv_r           ;/* ø⡼ɤθƽФʤХå */

    ;/*
     ;*  ƽФեå¹椫
     ;*  hook_savedspå
     ;*  եå¹ʤХå
     ;*/
    Lea     _hook_savedsp, ep
    sld.w   0[ep], ep
    cmp     r0, ep
    be      svc_entry_r_1           ;/* hook_savedsp == 0:ƥȤΥå */
    addi    -4, ep, ep
    sld.w   0[ep], sp               ;/* sp = *(hook_savedsp - 4) */
    ;/*
     ;*  ǡhook_savedsp򹹿ɬפϤʤ
     ;*/
    br      svc_prv_r

svc_entry_r_1:
    Lea     _p_runtsk, ep
    sld.w   0[ep], ep
    tst1    0, TCB_priv_mode[ep]    ;/* usp¸ */
    be      svc_prv_r               ;/* usp¸ƤʤʤХå */

svc_usr_r:
    ;/* 
     ;*  ø⡼ɼ¹Ԥȴ
     ;*  sstkustkؤ
     ;*  褬ƥȤʤС¹ǤϤ
     ;*  ʤΤǡp_runtskNULLɤΥåɬפʤϤ
     ;*/
    clr1    0, TCB_priv_mode[ep]    ;/* p_runtsk->priv_mode &= !0x01 */
    sld.w   TCB_usp[ep], sp         ;/* usp */
    
svc_prv_r:
    ;/*
     ;*  ƥॵӥǥåȤ줿ͥ٥ޥȿǤ
     ;*/
    mov     0x20, r12
    and     r12, r11    ;/* PSW.IDʳ0 */
    not     r12, r12    ;/* r12 = !0x20 */
    and     r12, r16    ;/* eipsw &= !0x20 */
    or      r11, r16    ;/* eipsw |= r11 */
    ldsr    r16, eipsw
    ldsr    r15, eipc
    eiret               ;/* ƽФإ꥿ */
    nop

    ;/*
     ;*  ꥷåȥեåθƽФ
     ;*  r6 = եåΥɥ쥹
     ;*  r7 = եåϤ顼
     ;*/
    .extern _call_trusted_hook
_call_trusted_hook:
    ;/*
     ;*  ؿƽФǸƤФΤǡcallee saved Τ¸
     ;*/
	addi    -68, sp, sp
	st.w    ep,  0[sp]
	mov     sp,  ep
	sst.w   r2,  56[ep]
	sst.w   r10, 52[ep]
	sst.w   r11, 48[ep]
	sst.w   r20, 44[ep]
	sst.w   r21, 40[ep]
	sst.w   r22, 36[ep]
	sst.w   r23, 32[ep]
	sst.w   r24, 28[ep]
	sst.w   r25, 24[ep]
	sst.w   r26, 20[ep]
	sst.w   r27, 16[ep]
	sst.w   r28, 12[ep]
	sst.w   r29, 8[ep]
	sst.w   r31, 4[ep]  ;/* lp */
    ;/*
     ;*  󥻥뤷ȤΤ˲Υǡ¸
     ;*  except_nest_cnt¸
     ;*   åȥեå¹˥եåͥȤ뤿Ӥ+1
     ;*   Τ᤹
     ;*  callevel_stat¸
     ;*   åȥեå¹ɲä줿callevel᤹
     ;*  sp ¸
     ;*/
    Lea     _except_nest_cnt, r2
    ld.w    0[r2], r2
    sst.w   r2, 64[ep]
    Lea     _callevel_stat, r2
    ld.h    0[r2], r2
    sst.w   r2, 60[ep]
    Lea     _trusted_hook_savedsp, ep
    sst.w   sp, 0[ep]
    ;/*
     ;*  եåƤ
     ;*/
    mov     r6, r11
    mov     r7, r6
    Lea     _trusted_hook_ret, lp
    jmp     [r11]

    .extern _exit_trusted_shutdown_hook
_exit_trusted_shutdown_hook:
    ;/*
     ;*  sp  trusted_hook_savedsp 
     ;*/
    Lea     _trusted_hook_savedsp, ep
    sld.w   0[ep], sp
    ld.h    60[sp], r2
    Lea     _callevel_stat, r10
    st.h    r2, 0[r10]
    ld.w    64[sp], r2
    Lea     _except_nest_cnt, r10
    st.w    r2, 0[r10]    
_trusted_hook_ret:
    ;/*
     ;*  trusted_hook_savedsp 0
     ;*/
    Lea     _trusted_hook_savedsp, ep
    sst.w   r0, 0[ep]
	mov     sp, ep
	sld.w   56[ep], r2
	sld.w   52[ep], r10
	sld.w   48[ep], r11
	sld.w   44[ep], r20
	sld.w   40[ep], r21
	sld.w   36[ep], r22
	sld.w   32[ep], r23
	sld.w   28[ep], r24
	sld.w   24[ep], r25
	sld.w   20[ep], r26
	sld.w   16[ep], r27
	sld.w   12[ep], r28
	sld.w    8[ep], r29
	sld.w    4[ep], r31
	addi    68, ep, sp
	ld.w    0[sp], ep
	jmp     [lp]

    ;/*
     ;*  եåθƽФ
     ;*  r6 = եåΥɥ쥹
     ;*  r7 = եåϤ顼
     ;*  r8 = եåμ
     ;*/
    .extern _call_nontrusted_hook
_call_nontrusted_hook:
    ;/*
     ;*  ؿƽФǸƤФΤǡcallee saved Τ¸
     ;*/
	addi    -76, sp, sp
	st.w    ep,  0[sp]
	mov     sp,  ep
	sst.w   r2,  56[ep]
	sst.w   r10, 52[ep]
	sst.w   r11, 48[ep]
	sst.w   r20, 44[ep]
	sst.w   r21, 40[ep]
	sst.w   r22, 36[ep]
	sst.w   r23, 32[ep]
	sst.w   r24, 28[ep]
	sst.w   r25, 24[ep]
	sst.w   r26, 20[ep]
	sst.w   r27, 16[ep]
	sst.w   r28, 12[ep]
	sst.w   r29, 8[ep]
	sst.w   r31, 4[ep]
    ;/*
     ;*  hook_savedsp򥹥å¸
     ;*  sp hook_savedsp¸
     ;*  shutdown_hook_savedsp򥹥å¸
     ;*/
    Lea     _hook_savedsp, r11
    ld.w    0[r11], r10
    sst.w   r10, 60[ep]
    st.w    sp, 0[r11]
    Lea     _shutdown_hook_savedsp, r2
    ld.h    0[r2], r2
    sst.w   r2, 72[ep]
    ;/*
     ;*  except_nest_cnt¸
     ;*   åȥեå¹˥եåͥȤ뤿Ӥ+1
     ;*   Τ᤹
     ;*  callevel_stat¸
     ;*   åȥեå¹ɲä줿callevel᤹
     ;*/
    Lea     _except_nest_cnt, r2
    ld.w    0[r2], r2
    sst.w   r2, 68[ep]
    Lea     _callevel_stat, r2
    ld.h    0[r2], r2
    sst.w   r2, 64[ep]
	;/*
	 ;*  ꥷåȥեåζλΤ˲Υǡ¸
     ;*  sp ¸
     ;*    ꥷåȥեå¹椫ɤȽǤ
     ;*/
    mov     SHUTDOWN_HOOK, r11
    cmp     r8, r11
    bne     call_nontrusted_hook_1      ;/* åȥեåǤʤХå */
    Lea     _shutdown_hook_savedsp, ep
    sst.w   sp, 0[ep]
call_nontrusted_hook_1:
    ;/*
     ;*  PSWr13
     ;*  bselڤؤ뤿߶ػ
     ;*/
    stsr    psw, r13
    LOCK_ALL_INT

    ;/*
     ;*  ƥ쥸ΥХڤؤ
     ;*  MPU
     ;*/
$ifdef __v850e2v3__
    ori     0x1001, r0, r27
    ldsr    r27, bsel
$endif ;/* __v850e2v3__ */
	;/*
     ;*  եåͥȤƤʤեåѥåڤؤ
	 ;*  hook_savedsp == 0ξեå롼󤬥ͥȤƤʤ
	 ;*/
    cmp     r0, r10                     ;/* 0 == hook_savedsp ? */
    bne     call_nontrusted_hook_2

    ;/*
     ;*  MPUΥåΰؤ
     ;*  եåѤΥåΰ
     ;*  եå¹ˤϥƥȤڤؤʤᡤ
     ;*  ͥȤƤˤMPUΥåΰڤؤɬפʤ
     ;*/
    Lea     __nthkstk, ep
    sld.w   0[ep], r27      ;/* Ƭ */
    Lea     __nthkstksz, ep
    sld.w   0[ep], r28      ;/*  */
    add     r27, r28        ;/* ü */
	
    ;/*
     ;*  եåѥåڤؤ
     ;*  call_nontrusted_hookø⡼ɤΤ߸ƤӽФ롥
     ;*  äơλǤspեåѥåǤꤨʤ
     ;*  ǤեåϥͥȤƤʤΤǡåǽ
	 ;*/
    mov     r28, sp

$ifdef __v850e2v3__
    ori     0x01, r27, r27  ;/* ͭӥå */
    ori     0x06, r28, r28  ;/* RW */
    ldsr    r27, dpa0l
    ldsr    r28, dpa0u
$elseif defined(__v850e3v5__)
    ldsr    r27, 0, 6                   ;/* MPLA0 */
    ldsr    r28, 1, 6                   ;/* MPUA0 */
$endif ;/* __v850e2v3__ */

    br      call_nontrusted_hook_3
    
call_nontrusted_hook_2:
	;/*
     ;*  եåѥåڤؤ
     ;*  call_nontrusted_hookø⡼ɤΤ߸ƤӽФ롥
     ;*  äơλǤspեåѥåǤꤨʤ
     ;*  ǤեåͥȤƤꡤեåø⡼
     ;*  ˰ܹԤեåƤФ줿Ǥ롥
     ;*  եåø⡼ɤڤؤΤϡtrap̿ȯԻ
     ;*  ʥƥॵӥƽФˡޤϡ㳰ȯǤ롥
     ;*  嵭ø⡼ػեå¹Ǥˤϡ
     ;*  åڤؤȤˡ*(hook_savedsp-4)sp¸뤳ȤȤ
     ;*  hook_savedspcall_nontrusted_hookǤΤѲ
     ;*  եå¹ˤϡʥƥȤڤؤʤ
     ;*  hook_savedspƥॹåݥ󥿤Ȥʤ뤿ᡤhook_savedsp
     ;*  sp³뤳ȤǤ
     ;*  եåsp򤹤Ѥѿߤˡͤ뤬
     ;*  ߤ㳰ΥȥʬʣȤʤ뤿ᡤܼǤϻѤʤ
	 ;*/
    addi    -4, r10, r10
    ld.w    0[r10], sp 

call_nontrusted_hook_3:
   	;/*
	 ;*  ¹ԥɥᥤݸɥᥤ(MPU)ƱʤС
     ;*  ɥᥤΥΰ衦ǡΰMPUꤷľɬפϤʤ
     ;*/
    Lea     _p_runosap, ep      ;/* ep = &p_runosap */	
    sld.w   0[ep], r26          ;/* r26 = p_runosap */
    Lea     _p_ctxosap, ep      ;/* ep = &p_ctxosap */	
    sld.w   0[ep], r27          ;/* r27 = p_ctxosap */
	cmp     r27, r26            ;/* p_ctxosap == p_runosap ? */
	be      call_nontrusted_hook_4  ;/* Ʊʤcall_nontrusted_hook_4 */
    nop
	sst.w   r26, 0[ep]          ;/* p_ctxosap = p_runosap : ݸɥᥤؤ */
$ifdef __v850e2v3__
    ldsr    r26, vmtid          ;/* ݸȿ̻Ҥp_runosapȤ */
    ld.w    OSAPCB_p_osapinib[r26], ep  ;/* ep = p_osapinib */

    ;/*
     ;*  ݸɥᥤѤromΰ
     ;*/
    sld.w   OSAPINIB_start_text[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_text[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, ipa0l
    ldsr    r28, ipa0u
    ;/*
     ;*  ݸɥᥤѤrosdataΰ
     ;*/
    sld.w   OSAPINIB_start_rosdata[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_rosdata[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, ipa1l
    ldsr    r28, ipa1u
    ;/* 
     ;* ݸɥᥤѤRWXΰ
     ;*/
    sld.w   OSAPINIB_start_ram[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_ram[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, dpa1l
    ldsr    r28, dpa1u
    ;/* 
     ;* ݸɥᥤѤRWXΰ(sdata)
     ;*/
    sld.w   OSAPINIB_start_sram[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_sram[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, dpa2l
    ldsr    r28, dpa2u
    ;/*
     ;* ͭ꡼/ѥ饤ΰΰ
     ;*/
    sld.w   OSAPINIB_start_srpw[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_srpw[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, dpa3l
    ldsr    r28, dpa3u
     ;/*
     ;* ͭ꡼/ѥ饤ΰΰ(sdata)
     ;*/
    sld.w   OSAPINIB_start_ssrpw[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_ssrpw[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, dpa4l
    ldsr    r28, dpa4u
$elseif defined(__v850e3v5__)
    ld.w    OSAPCB_p_osapinib[r26], ep  ;/* ep = p_osapinib */

    ;/*
     ;* ͭ꡼/ѥ饤ΰΰ
     ;*/
    sld.w   OSAPINIB_start_srpw[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_srpw[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, 4, 6                     ;/* MPLA1 */
    ldsr    r28, 5, 6                     ;/* MPUA1 */

    ;/*
     ;* ͭ꡼/ѥ饤ΰΰ(sdata)
     ;*/
    sld.w   OSAPINIB_start_ssrpw[ep], r27  ;/* Ƭ */
    sld.w   OSAPINIB_limit_ssrpw[ep], r28  ;/* ݸ°ȥ */
    ldsr    r27, 8, 6                      ;/* MPLA2 */
    ldsr    r28, 9, 6                      ;/* MPUA2 */

    sld.w   OSAPINIB_mprc[ep], r27  ;/* MPRC */
    ldsr    r27, 1, 5
$endif ;/* __v850e2v3__ */


call_nontrusted_hook_4:
$ifdef __v850e2v3__
    ldsr    r0, bsel    ;/* bsel᤹ */
$endif ;/* __v850e2v3__ */
    
    ;/*
     ;*  եåΥɥ쥹
     ;*  եåϤexit_nontrusted_hook_trap˻
     ;*/
    ldsr    r6, eipc
    Lea     _exit_nontrusted_hook_trap, lp

    ;/*
     ;*  եåΰ
     ;*/
    mov     r7, r6      ;/* 顼 */

    ;/* 
     ;* ݸǽͭء
     ;* ߶ػ/Ĥ᤹
     ;* PP,NPV,DMP,IMP = 1, ID = PSW.ID
     ;*/
$ifdef __v850e2v3__
    movhi   0x000f, r0, r14                  
$elseif defined(__v850e3v5__)
    movhi   0x4000, r0, r14                  
$endif ;/* __v850e2v3__ */
    or      r14, r13            ;/* psw |= (PP|NPV|DMP|IMP) */
	ldsr    r13, eipsw          ;/* eipsw = psw */
    eiret
    nop

    .extern _exit_nontrusted_hook
_exit_nontrusted_hook:
    Lea     _hook_savedsp, ep
    sld.w   0[ep], sp 
    ld.h    64[sp], r2
    Lea     _callevel_stat, r10
    st.h    r2, 0[r10]
    ld.w    68[sp], r2
    Lea     _except_nest_cnt, r10
    st.w    r2, 0[r10]    
    ;/*
     ;*  PSW.IDr10¸
     ;*/
    stsr    eipsw, r10
    andi    0x20, r10, r10
    br      call_nontrusted_hook_r_1

	;/*
	 ;*  ååؿ
	 ;*    r6  Ѥ륹å
	 ;*   Ѥ륹å̤ĤäƤʤϥ顼
	 ;*/
    .extern _trustedfunc_stack_check
_trustedfunc_stack_check:
    Lea     _callevel_stat, ep
    sld.h   0[ep], r10
    addi    TCL_ISR2, r0, r11     
    tst     r11, r10
    be      trustedfunc_stack_check_1       ;/* TCL_TASKξϥå */

    ;/*
     ;*  _ostk
     ;*/
    Lea     __ostk, ep
    sld.w   0[ep], r11
    br      trustedfunc_stack_check_2

trustedfunc_stack_check_1:
    ;/*
     ;*  Υƥॹå
     ;*/
    Lea     _p_runtsk, ep
    sld.w   0[ep], ep
    sld.w   TCB_p_tinib[ep], ep
    sld.w   TINIB_sstk_bottom[ep], r11
    sld.w   TINIB_sstksz[ep], r12
    sub     r12, r11
trustedfunc_stack_check_2:
    ;/*
     ;*  åλ̤å
     ;*  r11 = åƬ
     ;*/
    subr    sp, r6                      ;/* r6 = ssp - tf_stksz */
    bl      trustedfunc_stack_check_3   ;/* ssp < tfstksz ʤХ顼 */
    cmp     r11, r6                     ;/* r11 < r6  */
    bnh      trustedfunc_stack_check_3   ;/* ǤʤХ顼 */
    addi    E_OK, r0, r10
    jmp     [lp]

trustedfunc_stack_check_3:
    addi    E_OS_STACKINSUFFICIENT, r0, r10
    jmp     [lp]

    ;/*
     ;*  եåΥ꥿
     ;*  syscallǸƤФ
     ;*/
    .extern _call_nontrusted_hook_trap_ret
_call_nontrusted_hook_trap_ret:
    ;/*
     ;*  sp  hook_savedsp
     ;*/
    Lea     _hook_savedsp, ep
    sld.w    0[ep], sp
    ;/*
     ;*  syscallPSW.IDr10¸
     ;*/
    stsr    eipsw, r10
    andi    0x20, r10, r10

call_nontrusted_hook_r_1:
	;/*
	 ;*  hook_savedsp򤷤Ƥ᤹ͤ
	 ;*  shutdown_hook_savedsp򤷤Ƥ᤹ͤ
	 ;*/
    ld.w    72[sp], r2
    sst.w   r2, 0[ep]
    ld.w    60[sp], r20
    Lea     _shutdown_hook_savedsp, ep
    sst.w   r20, 0[ep]

	;/*
	 ;*  ͥȤξ(hook_savedsp != 0)Ϥǥ꥿
	 ;*  եå¹ϥڤؤʤMPUʤ
	 ;*/
    cmp     r0, r20         ;/* hook_savedsp == NULL ? */
    bne     call_nontrusted_hook_r_2
    Lea     _p_runtsk, ep
    sld.w   0[ep], ep
    cmp     r0, ep          ;/* p_runtsk != NULL ? */
    be      call_nontrusted_hook_r_2
    sld.w   TCB_p_tinib[ep], ep

    ;/*
     ;*  bselѹ뤿߶ػ
     ;*/
    LOCK_ALL_INT

    ;/*
     ;*  ƥ쥸ΥХڤؤ
     ;*  MPU
     ;*/
$ifdef __v850e2v3__
    ori     0x1001, r0, r27
    ldsr    r27, bsel
    ;/*
     ;*  桼åΰ
     ;*/
    sld.w   TINIB_start_ustk[ep], r27   ;/* Ƭ */
    ori     0x01, r27, r27
    sld.w   TINIB_limit_ustk[ep], r28   ;/* ݸ°ȥ */
    ori     0x06, r28, r28
    ldsr    r27, dpa0l
    ldsr    r28, dpa0u

    ldsr    r0, bsel    ;/* bsel᤹ */
$elseif defined(__v850e3v5__)
    ;/*
     ;*  桼åΰ
     ;*/
    sld.w   TINIB_start_ustk[ep], r27   ;/* Ƭ */
    sld.w   TINIB_limit_ustk[ep], r28   ;/* ݸ°ȥ */
    ldsr    r27, 0, 6                   ;/* MPLA0 */
    ldsr    r28, 1, 6                   ;/* MPUA0 */
$endif ;/* __v850e2v3__ */

$if 0
    UNLOCK_ALL_INT
$else
    ;/*
     ;*  PSW.ID᤹
     ;*/
    mov     0x20, r11
    tst     r10, r11
    bnz     call_nontrusted_hook_r_2

    UNLOCK_ALL_INT
$endif ;/* 0 */

call_nontrusted_hook_r_2:
	mov     sp,  ep
	sld.w   56[ep], r2
	sld.w   52[ep], r10
	sld.w   48[ep], r11
	sld.w   44[ep], r20
	sld.w   40[ep], r21
	sld.w   36[ep], r22
	sld.w   32[ep], r23
	sld.w   28[ep], r24
	sld.w   24[ep], r25
	sld.w   20[ep], r26
	sld.w   16[ep], r27
	sld.w   12[ep], r28
	sld.w    8[ep], r29
	sld.w    4[ep], r31
	sld.w    0[ep], ep
	addi    76, sp, sp
    jmp     [lp]

    ;/*
     ;* (6-22-2) void cancel_nontrusted_hook(void)
     ;* cancel_nontrusted_hookϥλˡå¸ƤӽФ롥
     ;* եå¹եååΰMPU̵롥
     ;*/
    .extern _cancel_nontrusted_hook
_cancel_nontrusted_hook:
    ;/*
     ;*  PSW.IDr10¸
     ;*/
    stsr    psw, r10
    andi    0x20, r10, r10

    Lea     _hook_savedsp, r11
    ld.w    0[r11], r12
	;/*
	 ;*  ͥȤξ(hook_savedsp == 0)Ϥǥ꥿
	 ;*/
    cmp     r0, r12         ;/* hook_savedsp == NULL ? */
    be      cancel_nontrusted_hook_r
    ;/*
     ;*  hook_savedsp = 0
     ;*/
    st.w    r0, 0[r11]

    ;/*
     ;*  bselѹ뤿߶ػ
     ;*/
    LOCK_ALL_INT

$ifdef __v850e2v3__
    ;/*
     ;*  ƥ쥸ΥХڤؤ
     ;*  MPU
     ;*/
    ori     0x1001, r0, r11
    ldsr    r11, bsel
    ;/*
     ;*  桼åΰNULL
     ;*/
    ldsr    r0, dpa0l
    ldsr    r0, dpa0u

    ldsr    r0, bsel    ;/* bsel᤹ */
$elseif defined(__v850e3v5__)
    ;/*
     ;*  桼åΰ
     ;*/
    ldsr    r0, 0, 6                   ;/* MPLA0 */
    ldsr    r0, 1, 6                   ;/* MPUA0 */
$endif ;/* __v850e2v3__ */

    ;/*
     ;*  PSW.ID᤹
     ;*/
    mov     0x20, r11
    tst     r10, r11
    bnz     cancel_nontrusted_hook_r

    UNLOCK_ALL_INT

cancel_nontrusted_hook_r:
    jmp     [lp]

    shared.text .cseg text
    .public  _exit_nontrusted_hook_trap
_exit_nontrusted_hook_trap:
    syscall NO_HOOK_RET
    nop
    ;/* =end modified for SC3 */
