/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *  Copyright (C) 2013 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Platform_Types.h 187 2015-06-25 03:39:04Z t_ishikawa $
 */

/*
 *		AUTOSAR platform types header file
 */

#ifndef TOPPERS_PLATFORM_TYPES_H
#define TOPPERS_PLATFORM_TYPES_H

/*
 *  Symbol definitions - general
 */
#define CPU_TYPE_8		UINT_C(8)
#define CPU_TYPE_16		UINT_C(16)
#define CPU_TYPE_32		UINT_C(32)

#define MSB_FIRST		UINT_C(0)
#define LSB_FIRST		UINT_C(1)

#define HIGH_BYTE_FIRST	UINT_C(0)
#define LOW_BYTE_FIRST	UINT_C(1)

#ifndef TRUE
#define TRUE			UINT_C(1)
#endif /* TRUE */

#ifndef FALSE
#define FALSE			UINT_C(0)
#endif /* FALSE */

/*
 *  Symbol definitions - platform
 */
#define CPU_TYPE		(CPU_TYPE_32)
#define CPU_BIT_ORDER	(MSB_FIRST)
#define CPU_BYTE_ORDER	(LOW_BYTE_FIRST)

/*
 *  Stack definitions - platform
 */
/* =begin modified for SC3 */
#define DEFINE_VAR_SEC_NOBITS(type, var, sec)	type __attribute__((section(sec))) var
#define DEFINE_VAR_SSTACK(type, var)			type __attribute__((section(".prsv_kernel"), aligned(4))) var
#define DEFINE_VAR_USTACK(type, var, sec)		type __attribute__((section(sec), aligned(64))) var
#define DEFINE_VAR_NTHKSTK(type, var)			type __attribute__((section(".prsv_kernel"), aligned(64))) var
/* =end modified for SC3 */

/*
 *  Type definitions
 */
#ifndef TOPPERS_MACRO_ONLY

#include <stdint.h>

typedef unsigned char boolean;

typedef char				char8;
typedef unsigned char		uint8;
typedef signed char			sint8;
typedef unsigned short		uint16;
typedef signed short		sint16;
typedef unsigned int		uint32;
typedef signed int			sint32;
typedef unsigned long long	uint64;
typedef signed long long	sint64;

typedef unsigned long	uint8_least;
typedef unsigned long	uint16_least;
typedef unsigned long	uint32_least;
typedef signed long		sint8_least;
typedef signed long		sint16_least;
typedef signed long		sint32_least;

typedef float	float32;
typedef double	float64;

typedef uint32	uintptr;                /* ݥ󥿤ǼǤ̵ */
typedef sint32	sintptr;                /* ݥ󥿤ǼǤդ */

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PLATFORM_TYPES_H */
