/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: SmpC1ISR.S 117 2014-12-10 03:58:03Z t_ishikawa $
 */

#define TOPPERS_MACRO_ONLY

#define UINT_C(val)	(val)
#define CAST(type, val)	(val)	/* 㥹ȤԤޥ */

#include "v850asm.inc"
#include "target_test.h"
#include "kernel/kernel_impl.h"
#include "target_timer.h"
#include "v850.h"

.global C1ISRMainSmpC1ISR
.global _C1ISRMainSmpC1ISR

C1ISRMainSmpC1ISR:
_C1ISRMainSmpC1ISR:

	/* 쥸¸ */
	addi    -80, sp, sp
	st.w    ep, 12[sp]
	mov     sp, ep 
	sst.w   r1, 72[ep]
	sst.w   r6, 68[ep]
	sst.w   r7, 64[ep]
	sst.w   r8, 60[ep]
	sst.w   r9, 56[ep]
	sst.w	r10, 52[ep]
	sst.w	r11, 48[ep]
	sst.w	r12, 44[ep]
	sst.w   r13, 40[ep]
	sst.w   r14, 36[ep]
	sst.w   r15, 32[ep]
	sst.w   r16, 28[ep]
	sst.w   r17, 24[ep]
	sst.w   r18, 20[ep]
	sst.w   r19, 16[ep]
	sst.w   r31, 8[ep]

	/* ¿ųߤΤᡤߤEIPCEIPSW¸ */
	stsr    eipc, r6
	sst.w   r6, 4[ep]
	stsr    eipsw, r6
	sst.w   r6, 0[ep]

    /* debug led4 on */
    Lea     P24, r6
    ld.h    0[r6], r7             /* P24 -> r7 */
    mov     ~0x0800, r8
    and     r7, r8
    st.h    r8, 0[r6]

	UNLOCK_ALL_INT      /* ߲ */

	/* ȯcallevel_stat򥹥å¸ */
	Lea     _callevel_stat, r6
	ld.h    0[r6], r7
	sst.w   r7, 76[ep]

	/* callevel_statC1ISR򥻥å */

	Lea     TSYS_ISR1, r8
	or      r8, r7
	st.h    r7, 0[r6]

	/*
	 *  ޳ߤ򥯥ꥢ
	 */
    Lea     ICTAUA0I(TAUA_CH7), r6
    ld.h    0[r6], r7
    mov     ~EIRFn, r8
    and      r8, r7
    st.h    r7, 0[r6]

/*	jarl	_c1isr_syslog, r31  FIXME */

	Lea     _callevel_stat, r6
	sld.w    76[ep], r7
	st.h    r7, 0[r6]

	LOCK_ALL_INT      /*  */

   /* debug led4 off */
    Lea     P24, r6
    ld.h    0[r6], r7           /* P24 -> r7 */
    mov     0x0800, r8
    or     r7, r8
    st.h    r8, 0[r6]

	/* 쥸 */
	mov     sp, ep
	sld.w    4[ep], r10
	ldsr    r10, eipc
	sld.w   0[ep], r10
	ldsr    r10, eipsw
	sld.w   72[ep], r1
	sld.w   68[ep], r6
	sld.w   64[ep], r7
	sld.w   60[ep], r8
	sld.w   56[ep], r9
	sld.w   52[ep], r10
	sld.w   48[ep], r11
	sld.w   44[ep], r12
	sld.w   40[ep], r13
	sld.w   36[ep], r14
	sld.w   32[ep], r15
	sld.w   28[ep], r16
	sld.w   24[ep], r17
	sld.w   20[ep], r18
	sld.w   16[ep], r19
	sld.w    8[ep], r31
	addi    80, ep, sp
	sld.w   12[ep], r30
	eiret

