/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_config.c 187 2015-06-25 03:39:04Z t_ishikawa $
 */

/*
 *		ץå¸⥸塼V850ѡ
 */
#include "kernel_impl.h"

/*
 *  㳰ʳ/CPU㳰ˤΥͥȲΥ
 *  ƥȻȤΤ˻
 */
uint32			except_nest_cnt;

#ifdef CFG_USE_PROTECTIONHOOK
uint32			v850_cpu_exp_no;
uint32			v850_cpu_exp_pc;
uint32			v850_cpu_exp_sp;
#endif /* CFG_USE_PROTECTIONHOOK */

/*
 * ߤγͥ٥ޥ͡ɽ
 */
uint8			current_iintpri;

/* ׵ޥơ֥ */
const uint16	pmr_setting_tbl[] =
{
#if TNUM_INTPRI == 16
	0xffff, /* ISR2 LEVEL -16 MASK */
	0xfffe, /* ISR2 LEVEL -15 MASK */
	0xfffc, /* ISR2 LEVEL -14 MASK */
	0xfff8, /* ISR2 LEVEL -13 MASK */
	0xfff0, /* ISR2 LEVEL -12 MASK */
	0xffe0, /* ISR2 LEVEL -11 MASK */
	0xffc0, /* ISR2 LEVEL -10 MASK */
	0xff80, /* ISR2 LEVEL -9 MASK */
	0xff00, /* ISR2 LEVEL -8 MASK */
	0xfe00, /* ISR2 LEVEL -7 MASK */
	0xfc00, /* ISR2 LEVEL -6 MASK */
	0xf800, /* ISR2 LEVEL -5 MASK */
	0xf000, /* ISR2 LEVEL -4 MASK */
	0xe000, /* ISR2 LEVEL -3 MASK */
	0xc000, /* ISR2 LEVEL -2 MASK */
	0x8000, /* ISR2 LEVEL -1 MASK */
	0x0000  /* Dummy			  */
#elif TNUM_INTPRI == 8
	0x00ff, /* ISR2 LEVEL -8 MASK */
	0x00fe, /* ISR2 LEVEL -7 MASK */
	0x00fc, /* ISR2 LEVEL -6 MASK */
	0x00f8, /* ISR2 LEVEL -5 MASK */
	0x00f0, /* ISR2 LEVEL -4 MASK */
	0x00e0, /* ISR2 LEVEL -3 MASK */
	0x00c0, /* ISR2 LEVEL -2 MASK */
	0x0080, /* ISR2 LEVEL -1 MASK */
	0x0000  /* Dummy			  */
#else
#error TNUM_INTPRI is illegal.
#endif /* TNUM_INTPRI == 16 */
};

/*
 *  x_nested_lock_os_int()ΥͥȲ
 */
volatile uint8	nested_lock_os_int_cnt;

/*
 *  OS߶ػ߾֤λ˳ͥ٥ޥ¸ѿ
 */
volatile uint16	current_intpri;

/* =begin added for SC3 */
/*
 *  եå롼¹ԤΥƥॹåΥåݥ
 */
uint32				hook_savedsp;

uint32				shutdown_hook_savedsp;

uint32				trusted_hook_savedsp;
/* =end added for SC3 */

/*
 *  ưΥϡɥ
 */
void
prc_hardware_initialize(void)
{
}

#ifdef __v850e3v5__
extern const uint32 intbp_tbl[];
#endif /* __v850e3v5__ */

/*
 *  ץå¸ν
 */
void
prc_initialize(void)
{
	/*
	 *  ͥ뵯ư󥿥ƥȤȤư뤿1
	 */
	except_nest_cnt = 1U;

	/*
	 * ͥ٥ޥνͤϺͥ
	 */
	current_iintpri = INT_IPM(0);

    /* =begin added for SC3 */
    target_mpu_initialize();
    /* =end added for SC3 */
#ifdef __v850e3v5__
	/* ơ֥뻲INTBPɥ쥹 */
	set_intbp((uint32)intbp_tbl);
#endif /* __v850e3v5__ */
}

/*
 *  ץå¸νλ
 */
void
prc_terminate(void)
{
	/* ߽ǽλꤷISPR򥯥ꥢ */
	clear_ispr();

	/* 㳰齪λꤷNP/EPӥåȤ򥯥ꥢ */
	set_psw(current_psw() & ~(0x0080 | 0x0040));
}

/*
 *  ׵饤°
 */
void
x_config_int(InterruptNumberType intno, AttributeType intatr, PriorityType intpri)
{
	uint32 eic_address;

	ASSERT(VALID_INTNO(intno));

	eic_address = EIC_ADDRESS(intno);

	/*
	 *  ߤΥޥ
	 *
	 *  ߤդޤޡ٥ȥꥬåȥꥬ䡤
	 *  ͥ٤ԤΤϴʤᡤ°ˤ餺
	 *  öޥ롥
	 */
	(void) x_disable_int(intno);

	/*
	 *  ͥ٤
	 */
	sil_wrh_mem((void *) eic_address,
				((sil_reh_mem((void *) eic_address) & ~0x0f) | INT_IPM(intpri)));

#ifdef __v850e3v5__
	/* ơ֥뻲 */
	sil_wrh_mem((uint16 *) eic_address,
				(sil_reh_mem((uint16 *) eic_address) | (1 << 6)));
#endif /* __v850e3v5__ */

    if ((intatr & ENABLE) != 0U) {
        /*
         *  ֤ߵĤǤСߤ
         */
        (void) x_enable_int(intno);
    }
}

#ifndef OMIT_DEFAULT_INT_HANDLER

/*
 *  ̤γߤäν
 */
void
default_int_handler(void)
{
	target_fput_str("Unregistered Interrupt occurs.");
	ASSERT(0);
}

#endif /* OMIT_DEFAULT_INT_HANDLER */

/*
 *  ̵¥롼׽
 *  (ǥХå̵¥롼ãǧ / ŬɻߤΤᤳ)
 */
void
infinite_loop(void)
{
	while (1) {
	}
}

/* =begin added for SC3 */
/*
 *  startendޤǤΰ褬
 *  եå롼¹ԻΥå˴ޤޤ뤫å
 */
AccessType
probe_nthkstk(const MemoryStartAddressType start, const MemoryStartAddressType end)
{
	AccessType result = AP_NoAccess;

	if (hook_savedsp != 0U) {
		if ((start >= (const MemoryStartAddressType) _nthkstk) &&
			(end <= (const MemoryStartAddressType) ((const MemorySizeType) _nthkstk + _nthkstksz))) {
			result = AP_Writable | AP_Readable | AP_StackSpace;
		}
	}
	return(result);
}

/*
 *  ʵǽɤꤷơƥॵӥȯԻν
 */

StatusType
no_support_service(void)
{
	StatusType ercd = E_OS_SERVICEID;

#ifdef CFG_USE_ERRORHOOK
	x_nested_lock_os_int();
	call_errorhook(ercd, OSServiceId_INVALID);
	x_nested_unlock_os_int();
#endif /* CFG_USE_ERRORHOOK */

	return(ercd);
}

/* =end added for SC3 */

