/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *  Copyright (C) 2013 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_config.h 189 2015-06-26 01:54:57Z t_ishikawa $
 */

/*
 *		ץå¸⥸塼V850ѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

#include "prc_sil.h"
#include "target_mpu.h"

/*
 *  顼åˡλ
 */
/* =begin modified for SC3 */
#ifndef CHECK_SSTKSZ_ALIGN
#define CHECK_SSTKSZ_ALIGN	UINT_C(4)   /* ƥॹåΥ饤ñ */
#endif /* CHECK_STKSZ_ALIGN */

#ifndef CHECK_USTKSZ_ALIGN
#define CHECK_USTKSZ_ALIGN	UINT_C(16)   /* 桼åΥ饤ñ */
#endif /* CHECK_USTKSZ_ALIGN */
/* =end modified for SC3 */

#ifndef CHECK_FUNC_ALIGN
#define CHECK_FUNC_ALIGN	UINT_C(2)   /* ؿΥ饤ñ */
#endif /* CHECK_FUNC_ALIGN */

#define CHECK_FUNC_NONNULL      /* ؿNULLå */

#ifndef CHECK_STACK_ALIGN
#define CHECK_STACK_ALIGN	UINT_C(4)   /* åΰΥ饤ñ */
#endif /* CHECK_STACK_ALIGN */

#define CHECK_STACK_NONNULL     /* åΰNULLå */

/* =begin modified for SC3 */
/*
 *  åȤɲä륷ƥॵӥơ֥
 */
#ifndef OTHER_PRC_SVC_TABLE
#ifdef USE_KERNEL_LIBRARY_SYSLOG
/* ǽͭ */
#define PRC_SVC_TABLE	(void *) &call_nontrusted_hook_trap_ret, \
	(void *) &_kernel_KernelLibrarySyslog
#define PRC_SVC_NUM		2
#else /* USE_KERNEL_LIBRARY_SYSLOG */
/* ǽ̵ */
#define PRC_SVC_TABLE	(void *) &call_nontrusted_hook_trap_ret
#define PRC_SVC_NUM		1
#endif /* USE_KERNEL_LIBRARY_SYSLOG */
#else /* OTHER_PRC_SVC_TABLE */
#define STR(a)	STR_(a)
#define STR_(a)	# a
#include STR(OTHER_PRC_SVC_TABLE)
#endif /* OTHER_PRC_SVC_TABLE */

#define TFN_HOOK_RETURN	(TMAX_SVCID - PRC_SVC_NUM + 1)
/*
 *  svcǸƤӽФμ
 *   ƥॵӥ
 *   եåνи
 */
#define SYSCALL_SIZE    2
/* =end modified for SC3 */

#define call_errorhook(ercd, svcid)		stack_change_and_call_func_2((void *) &internal_call_errorhook, (ercd), (svcid))
#define call_shutdownhook(ercd)			stack_change_and_call_func_1((void *) &internal_call_shtdwnhk, ((uint32) (ercd)))

/*
 *  ֹϰϤȽ
 */
#if TMIN_INTNO == 0
#define VALID_INTNO(intno)	((intno) <= (InterruptNumberType) (TMAX_INTNO))
#else /* TMIN_INTNO != 0 */
#define VALID_INTNO(intno)	(((InterruptNumberType) (TMIN_INTNO) <= (intno)) && ((intno) <= (InterruptNumberType) (TMAX_INTNO)))
#endif /* TMIN_INTNO == 0 */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  󥿥ƥѤΥåϥɥ쥹ޥ
 */
#define TOPPERS_OSTKPT(stk, stksz)	((StackType *) ((sint8 *) (stk) + (stksz)))

/*
 *  ץåü̿Υ饤ؿ
 */
#include <prc_insn.h>

/*
 *  TOPPERSɸ߽ǥμ¸
 */

/*
 * 㳰ʳ/CPU㳰ˤΥͥȲΥ
 *
 * ƥȻȤΤ˻
 */
extern uint32		except_nest_cnt;

/*
 *  ͥʥƥ2ˤγߤػߤ뤿PMR
 */
extern const uint16	pmr_isr2_mask;

/*
 *  ͥʥƥ1ˤγߤȤʤͥ٤PMRΥӥå
 */
extern const uint16	pmr_isr1_mask;

/*
 *  ߤγͥ٤͡ɽ
 */
extern uint8		current_iintpri;

/*
 * ׵ޥơ֥PMRؤ͡
 */
extern const uint16	pmr_setting_tbl[];

/*
 *  ̵¥롼׽
 */
extern void infinite_loop(void) NoReturn;

/* =begin modified for SC3 */
extern char8 call_nontrusted_hook_trap_ret;
/* =end modified for SC3 */

/*
 *  ͥ٤ɽȳɽѹ
 */
#ifndef TOPPERS_MACRO_ONLY
#define EXT_IPM(iipm)	((PriorityType) (iipm - (TNUM_INTPRI)))     /* ɽɽ */
#define INT_IPM(ipm)	((uint32) (ipm + (TNUM_INTPRI)))            /* ɽɽ */
#else /* TOPPERS_MACRO_ONLY */
#define EXT_IPM(iipm)	(iipm - (TNUM_INTPRI))              /* ɽɽ */
#define INT_IPM(ipm)	(ipm + (TNUM_INTPRI))               /* ɽɽ */
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ߶ػ߾֤ؤΰܹ
 */
LOCAL_INLINE void
x_lock_all_int(void)
{
	disable_int();
}

/*
 *  ߶ػ߾֤β
 */
LOCAL_INLINE void
x_unlock_all_int(void)
{
	enable_int();
}

/*
 *  x_nested_lock_os_int()ΥͥȲ
 *  νѲʤ褦volatile 
 */
extern volatile uint8 nested_lock_os_int_cnt;

/*
 *  OS߶ػ
 *  API¹Ի˸ƤӽФ
 *  ͥ٥ޥISR2ͥ٥ޥϰϤ⤤֤ǸƤӽФ
 *  ȤϤʤ(ISR1ƤӽФ뤳ȤϤʤ)
 */
LOCAL_INLINE void
x_nested_lock_os_int(void)
{
	/*
	 *  ܤʤߤζػߥ٥ͥ٥ޥͤ¸
	 */
	if (nested_lock_os_int_cnt == 0U) {
		set_pmr(pmr_isr2_mask);   /* OS߶ػߤ */
	}
	nested_lock_os_int_cnt++;

	V850_MEMORY_CHANGED
}

/*
 *  OS߲
 *  API¹Ի˸ƤӽФ
 *  ͥ٥ޥISR2ͥ٥ޥϰϤ⤤֤ǸƤӽФ
 *  ȤϤʤ(ISR1ƤӽФ뤳ȤϤʤ)
 */
LOCAL_INLINE void
x_nested_unlock_os_int(void)
{
	V850_MEMORY_CHANGED
	ASSERT(nested_lock_os_int_cnt > 0U);
	nested_lock_os_int_cnt--;

	/*
	 *  ֳ¦ʤͥ٥ޥ򹹿
	 */
	if (nested_lock_os_int_cnt == 0U) {
		set_pmr(pmr_setting_tbl[current_iintpri]);
	}
}

/*
 *  SuspendOSInterrupts()ƤӽФOS߶ػ߾֤ؤΰܹ
 *  x_nested_lock_os_int()Ȥΰ㤤ϡISR1ƤӽФǽ뤿ᡤ
 *  ߤISPROS߶ػ߻ͤ꾮ISR1ƤӽФ줿Ȥơ
 *  ⤻꥿󤹤
 */
LOCAL_INLINE void
x_suspend_lock_os_int(void)
{
	uint16 ispr;

	ispr = get_ispr();

	if ((ispr & pmr_isr1_mask) == 0U) {
		/*
		 *  ƥ1 ISRƤФ줿ϲ⤷ʤ
		 */
		if (nested_lock_os_int_cnt == 0U) {
			set_pmr(pmr_isr2_mask);   /* OS߶ػߤ */
		}
		nested_lock_os_int_cnt++;
		V850_MEMORY_CHANGED
	}
}

/*
 *  ResumeOSInterrupts()ƤӽФOS߶ػ߾֤β
 *  x_nested_lock_os_int()Ȥΰ㤤ϡISR1ƤӽФǽ뤿ᡤ
 *  ߤISPROS߶ػ߻ͤ꾮ISR1ƤӽФ줿Ȥơ
 *  ⤻꥿󤹤
 */
LOCAL_INLINE void
x_resume_unlock_os_int(void)
{
	uint16	ispr;

	V850_MEMORY_CHANGED
	ispr = get_ispr();

	if ((ispr & pmr_isr1_mask) == 0U) {
		/*
		 *  ƥ1 ISRƤФ줿ϲ⤷ʤ
		 */
		ASSERT(nested_lock_os_int_cnt > 0U);
		nested_lock_os_int_cnt--;

		/*
		 *  ֳ¦ʤͥ٥ޥ򹹿
		 */
		if (nested_lock_os_int_cnt == 0U) {
			set_pmr(pmr_setting_tbl[current_iintpri]);
		}
	}
}


/*
 *  (ǥ)ͥ٥ޥ
 *
 *  OSǤϼΩ
 *    * OS߶ػ߾֤ǸƤӽФ
 *    * OS߶ػ߻ͥ٤⤤ͤϻꤵʤ
 *  OS߶ػߤPMRǼ¸ƤꡤPMRѹȡOS߶ػ
 *  礬뤿ᡤѿ(current_iintpri) ѹΤߤԤ
 *  ͥ٥ޥѹϡAPIνиǸƤӽФ롤x_nested_unlock_os_int()
 *  Ǽ»ܤ롥
 */
LOCAL_INLINE void
x_set_ipm(PriorityType intpri)
{
	ASSERT(nested_lock_os_int_cnt > 0U);

	current_iintpri = INT_IPM(intpri);
}

/*
 *  (ǥ)ͥ٥ޥλ
 *
 *  OSǤϼΩ
 *    * OS߶ػ߾֤ǸƤӽФ
 */
LOCAL_INLINE PriorityType
x_get_ipm(void)
{
	ASSERT(nested_lock_os_int_cnt > 0U);
	return(EXT_IPM(current_iintpri));
}

/*
 *  ׵ػߥե饰Υå
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
LOCAL_INLINE boolean
x_disable_int(InterruptNumberType intno)
{
	uint32 eic_address = EIC_ADDRESS(intno);

	if (!VALID_INTNO(intno)) {
		return(FALSE);
	}

	/* ߤζػ(7bitܤ򥻥å) */
	sil_wrh_mem((void *) eic_address,
				sil_reh_mem((void *) eic_address) | (0x01U << 7));

	return(TRUE);
}
/*
 *  ׵ػߥե饰β
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */

LOCAL_INLINE boolean
x_enable_int(InterruptNumberType intno)
{
	uint32 eic_address = EIC_ADDRESS(intno);

	if (!VALID_INTNO(intno)) {
		return(FALSE);
	}

	/* 7bitܤ򥯥ꥢ */
	sil_wrh_mem((void *) eic_address,
				sil_reh_mem((void *) eic_address) & ~(0x01U << 7));

	return(TRUE);
}

/*
 *  ׵Υꥢ
 */
LOCAL_INLINE boolean
x_clear_int(InterruptNumberType intno)
{
	uint32 eic_address = EIC_ADDRESS(intno);

	if (!VALID_INTNO(intno)) {
		return(FALSE);
	}

	/* ߤΥꥢ(12bitܤ򥯥ꥢ) */
	sil_wrh_mem((void *) eic_address,
				sil_reh_mem((void *) eic_address) & ~(0x01U << 12));

	return(TRUE);
}

/*
 *  ׵Υå
 */
LOCAL_INLINE boolean
x_probe_int(InterruptNumberType intno)
{
	uint32	eic_address = EIC_ADDRESS(intno);
	uint16	tmp;

	if (!VALID_INTNO(intno)) {
		return(FALSE);
	}

	tmp = sil_reh_mem((void *) (eic_address));
	return((tmp & 0x1000) != 0);
}

/*
 *  ׵饤°
 */
extern void x_config_int(InterruptNumberType intno, AttributeType intatr, PriorityType intpri);

/*
 *  ߥϥɥɬפIRC
 */
LOCAL_INLINE void
i_begin_int(InterruptNumberType intno)
{

}

/*
 *  ߥϥɥνиɬפIRC
 */
LOCAL_INLINE void
i_end_int(InterruptNumberType intno)
{

}

/*
 *  ̤γߤäν
 */
extern void default_int_handler(void);
extern void _start(void);
extern void prc_hardware_initialize(void);

/*
 *  ץå¸ν
 */
extern void prc_initialize(void);

/*
 *  ץå¸νλ
 */
extern void prc_terminate(void);

/*
 *  ǥѥå
 */

/*
 *  ǹ̥ͥؤΥǥѥåprc_support.S
 *
 *  dispatch ϡƥȤƤӽФ줿ӥ
 *  ǡOS߶ػ߾֤ǸƤӽФʤФʤʤ
 */
extern void dispatch(void);

/*
 *  ǥѥåưϡprc_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡߶ػ߾֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void start_dispatch(void) NoReturn;

/*
 *  ߤΥƥȤΤƤƥǥѥåprc_support.S
 *
 *  exit_and_dispatch ϡOS߶ػ߾֤ǸƤӽФʤФʤʤ
 */
extern void exit_and_dispatch(void) NoReturn;

/* =begin added for SC3 */
/*
 *  ߤΥƥȤΤƤƥǥѥåprc_support.S
 *   PosttaskHook ƤФʤȥ
 *
 *  exit_and_dispatch_nohook ϡOS߶ػ߾֤ǸƤӽФʤФʤʤ
 */
extern void exit_and_dispatch_nohook(void) NoReturn;
/* =end added for SC3 */

/*
 *  ƥȥ֥å
 */
typedef struct task_context_block {
    /* =begin modified for SC3 */
	void	*ssp;               /* ƥॹåݥ */
	void	*usp;               /* 桼åݥ */
    boolean priv_mode;          /* ø⡼ɼ¹椫 */
    /* =end modified for SC3 */
	FunctionRefType	pc;         /* ץ५ */
} TSKCTXB;

/* =begin modified for SC3 */
/*
 *	ƥȥ֥å
 */
#define USE_TSKINICTXB	/*  TSKINICTXBѤ  */

typedef struct task_initialization_context_block {
	MemorySizeType sstksz;  /* åΰΥʴݤ᤿͡ */
	void	*sstk_bottom;	/* åݥ󥿤ν͡ʥåν͡ */
	MemorySizeType stksz;   /* åΰΥʴݤ᤿͡ */
	void	*stk_bottom;	/* åݥ󥿤ν͡ʥåν͡ */
} TSKINICTXB;

/* 
 *  åMPU
 */
typedef struct task_stack_mpu_info_block {
    uint8 *start_ustk_label;
    uint8 *limit_ustk_label;
} STKMPUINFOB;

/*
 *  OSץꥱMPU
 */

#if 0
typedef struct {
    uint8 *start_text_label;
    uint8 *limit_text_label;
    uint8 *start_rosdata_label;
    uint8 *limit_rosdata_label;
    uint8 *start_ram_label;
    uint8 *limit_ram_label;
    uint8 *start_sram_label;
    uint8 *limit_sram_label;
    uint8 *start_srpw_label;
    uint8 *limit_srpw_label;
    uint8 *start_ssrpw_label;
    uint8 *limit_ssrpw_label;
} OSAPMPUINFOB_INFO;

typedef struct {
    OSAPMPUINFOB_INFO *p_osap_mpu_info;
} OSAPMPUINFOB;
#else
typedef struct {
#ifdef __v850e2v3__
    uint8 *start_text_label;
    uint8 *limit_text_label;
    uint8 *start_rosdata_label;
    uint8 *limit_rosdata_label;
    uint8 *start_ram_label;
    uint8 *limit_ram_label;
    uint8 *start_sram_label;
    uint8 *limit_sram_label;
#endif /* __v850e2v3__ */
    uint8 *start_srpw_label;
    uint8 *limit_srpw_label;
    uint8 *start_ssrpw_label;
    uint8 *limit_ssrpw_label;
    uint32 mprc;
} OSAPMPUINFOB;
#endif
/* =end modified for SC3 */

/*
 *  ƥȤν
 *
 *  ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *  ǥåΰȤäƤϤʤʤ
 *
 *  activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *  λǤTCBƤʤǤ
 */
/* =begin modified for SC3 */
extern void    start_stask_r(void);
extern void    start_utask_r(void);

#define activate_context(p_tcb)                                         \
{\
	(p_tcb)->tskctxb.ssp = (p_tcb)->p_tinib->tskinictxb.sstk_bottom;	\
	(p_tcb)->tskctxb.pc = ((p_tcb)->p_tinib->p_osapcb->p_osapinib->osap_trusted != FALSE) ? (FunctionRefType)start_stask_r: (FunctionRefType)start_utask_r;       \
	(p_tcb)->tskctxb.priv_mode = 0U; \
}

#define TOPPERS_SSTK_MAGIC_REGION(p_tinib)	((StackType *) ((uint32)(p_tinib)->tskinictxb.sstk_bottom - (uint32)(p_tinib)->tskinictxb.sstksz))
/* =end modified for SC3 */

/* ηϥϡɥ륵uint32ˤƱ */
extern void stack_change_and_call_func_1(void *func, uint32 arg1);
extern void stack_change_and_call_func_2(void *func, uint8 arg1, uint8 arg2);

#ifdef ENABLE_RETURN_MAIN
/*
 *  AKTSPѤmain()ؤΥ꥿󥳡ɡprc_support.S
 */
extern void return_main(void);
#endif /* ENABLE_RETURN_MAIN */

/* =begin modified for SC3 */
#define call_protectionhk_main_stkchg(ercd)	stack_change_and_call_func_1((void *) &call_protectionhk_main, ((uint32) (ercd)))

extern AccessType probe_nthkstk(const MemoryStartAddressType start, const MemoryStartAddressType end);
extern void cancel_nontrusted_hook(void);
extern void call_nontrusted_hook(void *hook, StatusType arg, uint32 HookType);
#if 0
extern void exit_nontrusted_shutdown_hook(void) NoReturn;
#endif
extern void exit_nontrusted_hook(void) NoReturn;

extern void call_trusted_hook(void *hook, StatusType arg);
extern void exit_trusted_shutdown_hook(void) NoReturn;
extern StatusType trustedfunc_stack_check(MemorySizeType size);
extern StatusType no_support_service(void);

/*
 * եå롼¹ԤΥƥॹåΥåݥ
 */
extern uint32		hook_savedsp;

extern uint32		shutdown_hook_savedsp;

extern uint32		trusted_hook_savedsp;

/*
 * OS߶ػ߻status.ILؤ
 */
extern const uint32	tmin_status_il;

/*
 *  x_nested_lock_os_int()ΥͥȲ
 *  νѲʤ褦volatile 
 */
extern volatile uint8	nested_lock_os_int_cnt;

LOCAL_INLINE void
x_clear_nested_os_int(void)
{
	ASSERT(nested_lock_os_int_cnt > 0U);
	nested_lock_os_int_cnt = 1U;
}

/*
 * եå롼μ¹椫
 */
LOCAL_INLINE boolean
is_running_nontrusted_hook(void)
{
	return(hook_savedsp != 0U);
}

/*
 * ꥷåȥեåμ¹椫
 */
LOCAL_INLINE boolean
is_running_nontrusted_shtdwnhk(void)
{
	return(shutdown_hook_savedsp != 0U);
}

#define check_address_sstack(base, size, p_tinib) (check_address_stack(base, size, (const MemoryStartAddressType)((uint32)(p_tinib)->tskinictxb.sstk_bottom - (uint32)(p_tinib)->tskinictxb.sstksz), (p_tinib)->tskinictxb.sstksz))
#define check_address_ustack(base, size, p_tinib) (check_address_stack(base, size, (const MemoryStartAddressType)((uint32)(p_tinib)->tskinictxb.stk_bottom - (uint32)(p_tinib)->tskinictxb.stksz), (p_tinib)->tskinictxb.stksz))

/* =end modified for SC3 */

#endif /* TOPPERS_MACRO_ONLY */

/* =begin modified for SC3 */
/*
 *  syscallΥѥ᡼
 */
#define NO_SVC          1   /* ӥƤӽФsvcΰ */
#define NO_HOOK_RET     2   /* եåΥ꥿svcΰ */

#ifdef USE_KERNEL_LIBRARY_SYSLOG
#include "prc_syslog.h"
#endif /* USE_KERNEL_LIBRARY_SYSLOG */
/* =end modified for SC3 */

#endif /* TOPPERS_PRC_CONFIG_H */
