/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_insn.h 187 2015-06-25 03:39:04Z t_ishikawa $
 */

/*
 *		ץåü̿Υ饤ؿV850ѡ
 */
#ifndef TOPPERS_PRC_INSN_H
#define TOPPERS_PRC_INSN_H

#ifndef TOPPERS_MACRO_ONLY

#define V850_MEMORY_CHANGED	Asm("" ::: "memory");
#define SYNCM	Asm("syncm");

LOCAL_INLINE uint32
current_psw(void)
{
	volatile uint32 psw;
	Asm("   ldsr	r0,31 \n" /* Select CPU function grp */
		"\t stsr 5 , %0 \n"
		: "=r" (psw) :);
	return(psw);
}

LOCAL_INLINE void
set_psw(uint32 psw)
{
	Asm("   ldsr	r0,31 \n"  /* Select CPU function grp */
		"\t ldsr %0 , 5 \n"
		:  : "r" (psw));
	return;
}

LOCAL_INLINE void
set_psw_wo_fgs(uint32 psw)
{
	Asm("\t ldsr %0 , 5 \n"
		:  : "r" (psw));
	return;
}

LOCAL_INLINE void
disable_int(void)
{
	Asm("	di");
}

LOCAL_INLINE void
enable_int(void)
{
	Asm("	ei");
}

LOCAL_INLINE void
set_bit(uint8 bit_offset, uint32 addr)
{
	uint32 any;

	Asm("mov %1 , %0;"
		"set1 %2 , 0[%0]" : "=r" (any) : "i" (addr), "i" (bit_offset));
}

LOCAL_INLINE void
clr_bit(uint8 bit_offset, uint32 addr)
{
	uint32 any;

	Asm("mov %1 , %0;"
		"clr1 %2 , 0[%0]" : "=r" (any) : "i" (addr), "i" (bit_offset));
}

#ifdef __v850e2v3__

#define LDSR_REG(reg, val) {\
    Asm("\tldsr %0, " #reg \
        : : "r"(val) : "memory" ); \
}

#define STSR_REG(reg, val) {\
    Asm("\tstsr " #reg ", %0" \
        : "=r"(val) : : "memory" ); \
}


#elif defined(__v850e3v5__)

/*
 *  V850E3V5Ѥγߥȥ롼
 */
LOCAL_INLINE void
set_pmr(uint16 pmr)
{
	uint32 psw;

	/* PMR must be set in di sate(PSW.ID = 1) */
	psw = current_psw();
	disable_int();

	Asm("ldsr %0, sr11, 2" ::"r" (pmr));

	set_psw_wo_fgs(psw);
	Asm("syncp");
}

LOCAL_INLINE uint16
get_ispr(void)
{
	uint16 ispr;
	Asm("stsr sr10, %0, 2" : "=r" (ispr) :);
	return(ispr);
}

LOCAL_INLINE void
clear_ispr(void)
{
	uint32 psw;

	/* ISPR must be set in di sate(PSW.ID = 1) */
	psw = current_psw();
	disable_int();

	Asm("ldsr %0, sr13, 2" ::"r" (1));  /* INTCFG = 1; ISPR 񤭴ǽ */
	Asm("ldsr %0, sr10, 2" ::"r" (0));  /* ISPR = 0 */
	Asm("ldsr %0, sr13, 2" ::"r" (0));  /* INTCFG = 0; ISPR 񤭴ػߤ(ư) */

	set_psw_wo_fgs(psw);
	Asm("syncp");
}

LOCAL_INLINE uint32
current_cpuid(void)
{
	uint32 htcfg0_val;
	Asm("stsr sr0, %0, 2":"=r"(htcfg0_val):);
	return(((htcfg0_val >> 16) & 0x03));
}

#define LDSR_REG(reg, sel, val) {\
    uint32 sval = val; \
    Asm("ldsr %0, "#reg", "#sel"\n"\
            ::"r"(sval));\
}

#define STSR_REG(reg, sel, val) {\
    Asm("stsr "#reg", %0, "#sel"\n"\
            :"=r"(val) );\
}

#define MPA_WRITE(mpuid, mpla, mpua, mpat) { \
    __LDSR(mpuid*4, 6, mpla); \
    __LDSR(mpuid*4+1, 6, mpua); \
    __LDSR(mpuid*4+2, 6, mpat); \
}

LOCAL_INLINE void
set_intbp(uint32 intbp)
{
	uint32 psw;

	/* INTBP must be set in di sate(PSW.ID = 1) */
	psw = current_psw();
	disable_int();

	Asm("\t ldsr	%0, 4, 1 \n"
		: : "r" (intbp) :);

	set_psw_wo_fgs(psw);

	return;
}

#else /* __v850e3v5__ */
#error please define ether __v850e2v3__ or __v850e3v5__
#endif /* __v850e2v3__ */

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_INSN_H */
