/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *	
 *	Copyright (C) 2013 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	MPUɥ饤
 */

#include "kernel_impl.h"
#include "task.h"
#include "memory.h"
#include "prc_sil.h"
#include "Os_Lcfg.h"
#include "target_mpu.h"
#include <t_syslog.h>

void *p_ctxosap;

void
target_mpu_initialize(void)
{
#ifdef __v850e2v3__
    uint8 *ipal;
    uint8 *ipau;

    /*
     *  bselݸѤ
     */
    ipal = (uint8 *)0x00001001;
    LDSR_REG(BSEL, (uint32)ipal);

    /*
     *  IPA2: ͭ꡼ΰ
     */
    ipal = shared_meminib_table[0];
    ipau = shared_meminib_table[1];
    IPA_WRITE(2, ipal, ipau);

    /*
     *  IPA3: ͭrosdata
     */
    ipal = shared_meminib_table[2];
    ipau = shared_meminib_table[3];
    IPA_WRITE(3, ipal, ipau);

    /*
     *  DPA5: ͭ꡼ɥ饤ΰ
     */
    ipal = shared_meminib_table[4];
    ipau = shared_meminib_table[5];
    DPA_WRITE(5, ipal, ipau);

    /*
     *  MPUͭ
     *  ø⡼ɤǤϥǥեȤΥޥå
     *  ϥɥǤMPU̵
     */
    ipal = (uint8 *)0x07;
    LDSR_REG(MPM, (uint32)ipal);

    /*
     *  bselѤ᤹
     */
    LDSR_REG(BSEL, (0U));

#elif defined(__v850e3v5__)
    uint32 mpm = 0x0U;

    /*
     *  ͭ꡼ɥ饤ΰ
     *  MPA3
     */
    mpm = (uint32)shared_meminib_table[0];
    LDSR_REG(12, 6, (uint32)mpm);
    mpm = (uint32)shared_meminib_table[1];
    LDSR_REG(13, 6, (uint32)mpm);

#if (MPU_REGION_NUM >= 11)
    /*
     *  ͭ꡼ΰ
     *  MPA8
     */
    mpm = (uint32)shared_meminib_table[2];
    LDSR_REG(0, 7, (uint32)mpm);
    mpm = (uint32)shared_meminib_table[3];
    LDSR_REG(1, 7, (uint32)mpm);

    /*
     *  ͭrosdata
     *  MPA9
     */
    mpm = (uint32)shared_meminib_table[4];
    LDSR_REG(4, 7, (uint32)mpm);
    mpm = (uint32)shared_meminib_table[5];
    LDSR_REG(5, 7, (uint32)mpm);

    /*
     *  ͭ꡼ͭ饤Ȥ
     *  MPA10
     */
    mpm = (uint32)shared_meminib_table[6];
    LDSR_REG(8, 7, (uint32)mpm);
    mpm = (uint32)shared_meminib_table[7];
    LDSR_REG(9, 7, (uint32)mpm);

#endif /* (MPU_REGION_NUM >= 11) */

    /*
     *  MPAT
     */
    LDSR_REG(2, 6, (uint32)(MPAT_E | MPAT_G | MPAT_UX | MPAT_UW | MPAT_UR))
    LDSR_REG(6, 6, (uint32)(MPAT_E | MPAT_G | MPAT_UX | MPAT_UW | MPAT_UR))
    LDSR_REG(10, 6, (uint32)(MPAT_E | MPAT_G | MPAT_UX | MPAT_UW | MPAT_UR))
    LDSR_REG(14, 6, (uint32)(MPAT_E | MPAT_G | MPAT_UX | MPAT_UW | MPAT_UR))
#if (MPU_REGION_NUM >= 11)
    LDSR_REG(18, 6, (uint32)(MPAT_E | MPAT_G | MPAT_UX | MPAT_UR))
    LDSR_REG(22, 6, (uint32)(MPAT_E | MPAT_G | MPAT_UX | MPAT_UR))
    LDSR_REG(26, 6, (uint32)(MPAT_E | MPAT_G | MPAT_UX | MPAT_UW | MPAT_UR))
    LDSR_REG(30, 6, (uint32)(MPAT_E | MPAT_G | MPAT_UX | MPAT_UW | MPAT_UR))
    LDSR_REG(3,  7, (uint32)(MPAT_E | MPAT_G | MPAT_UX | MPAT_UR))
    LDSR_REG(7,  7, (uint32)(MPAT_E | MPAT_G | MPAT_UX | MPAT_UR))
    LDSR_REG(10, 7, (uint32)(MPAT_E | MPAT_G | MPAT_UX | MPAT_UR))
#endif /* (MPU_REGION_NUM >= 11) */

    /*
     *  MPUͭ
     *   DW = 0  Хå饦ɤνߤ϶ػ
     *   SVP = 0 øǤΥ¤Ϥʤ
     *   MPE = 1 MPUͭ
     */
    /*
     *  RH850/F1LѤ
     *   DR = 1  Хå饦ɤνߤ϶ػ
     *   DW = 0  Хå饦ɤνߤ϶ػ
     *   DX = 1  Хå饦ɤνߤ϶ػ
     *  RH850/F1HѤ
     *   DR = 0  Хå饦ɤΥ϶ػ
     *   DW = 0  Хå饦ɤΥ϶ػ
     *   DX = 0  Хå饦ɤΥ϶ػ
     */
#if (MPU_REGION_NUM >= 11)
    mpm = 0x001U;
#else /* (MPU_REGION_NUM >= 11) */
    mpm = 0x501U;
#endif /* (MPU_REGION_NUM >= 11) */
    LDSR_REG(0, 5, (uint32)mpm);

#else /* __v850e3v5__ */
#error please define ether __v850e2v3__ or __v850e3v5__
#endif /* __v850e2v3__ */

}

void
target_impu_exc_handler(void *p_excinf)
{
    uint32 sreg;
    uint32 vmtid;

#if defined(__v850e2v3__)
    sreg = 0x00001000;      /* ץåݸȿХ */
    LDSR_REG(BSEL, sreg);
    STSR_REG(VMTID, vmtid);
    STSR_REG(VMADR, sreg);
    LDSR_REG(BSEL, (0U));

#elif defined(__v850e3v5__)
    vmtid = (uint32)p_runosap;
    STSR_REG(2, 0, (sreg));

#else /* __v850e3v5__ */
#error please define ether __v850e2v3__ or __v850e3v5__
#endif /* __v850e2v3__ */

    syslog(LOG_EMERG, "MPU EXCEPTION (RX) at 0x%x OCCURED!!", sreg);
    syslog(LOG_EMERG, "p_dominib = 0x%x", vmtid);
    while(1);
}

void
target_dmpu_exc_handler(void *p_excinf)
{
    uint32 sreg;
    uint32 vmtid;

#if defined(__v850e2v3__)
    sreg = 0x00001000;      /* ץåݸȿХ */
    LDSR_REG(BSEL, (sreg));
    STSR_REG(VMTID, (vmtid));
    STSR_REG(VMADR, (sreg));
    LDSR_REG(BSEL, (0U));
#elif defined(__v850e3v5__)
    vmtid = (uint32)p_runosap;
    STSR_REG(2, 0, (sreg));

#else /* __v850e3v5__ */
#error please define ether __v850e2v3__ or __v850e3v5__
#endif /* __v850e2v3__ */

    syslog(LOG_EMERG, "MPU EXCEPTION (RWX) at 0x%x OCCURED!!", sreg);
    syslog(LOG_EMERG, "p_dominib = 0x%x", vmtid);
    while(1);
}

/*
 *  ݸȿFE٥㳰ϥɥ
 */
void
target_protection_handler(void *p_excinf)
{
    uint32 feic = 0;

    /*
     *  FE٥㳰װɽФ
     */
#if defined(__v850e2v3__)
    LDSR_REG(BSEL, 0U);
	STSR_REG(FEIC, feic);

#elif defined(__v850e3v5__)
	STSR_REG(FEIC, 0, feic);

#else /* __v850e3v5__ */
#error please define ether __v850e2v3__ or __v850e3v5__
#endif /* __v850e2v3__ */

    switch(feic){
        case FE_MIP: /* ¹ݸȿ㳰 */
            target_impu_exc_handler(NULL);
            break;
        case FE_MDP: /* ǡݸȿ㳰 */
            target_dmpu_exc_handler(NULL);
            break;
        default:
            break;
    }
}

#if 1
/*
 *  ꤵ줿ɥ쥹桼⡼ɻ˽߲ǽå
 */
#ifdef OMIT_PROBE_MEM_WRITE
boolean
probe_mem_write(const MemoryStartAddressType base, MemorySizeType size)
{
    uint32 sreg;
    boolean ret;

    /*
     *  OSAPʤǤդΥɥ쥹˥ǽ
     */
    if(run_trusted != FALSE){
        return TRUE;
    }

#ifdef __v850e2v3__
    sreg = 0x00001000;      /* ץåݸȿХ */
    /*
     *  Х󥯤򥻥å
     */
    LDSR_REG(BSEL, (sreg));
    /*
     *  Ƭɥ쥹MCA˥å
     */
    LDSR_REG(MCA, (uint32)base);

    /*
     *  MCS˥å
     */
    LDSR_REG(MCS, (uint32)size);

    /*
     *  ݸå
     */
    LDSR_REG(MCC, 0U);

    /*
     *  ݸå̤ɤ߽Ф
     */
    STSR_REG(MCR, sreg);
#elif __v850e3v5__
    /*
     *  Ƭɥ쥹MCA˥å
     */
    LDSR_REG(8, 5, (uint32)base);
    /*
     *  MCS˥å
     */
    LDSR_REG(9, 5, (uint32)size);
    /*
     *  ݸå
     */
    LDSR_REG(10, 5, 0U);
    /*
     *  ݸå̤ɤ߽Ф
     */
    STSR_REG(11, 5, sreg);
#else
#error hoge!
#endif

    if(sreg & 0x00000100){
        /* Хեξ */
        ret = FALSE;
    } else if(sreg & 0x00000004){
        /* 饤ȵĤξ */
        ret = TRUE;
    } else {
        ret = FALSE;
    }

#ifdef __v850e2v3__
    /*
     *  Х󥯤᤹
     */
    LDSR_REG(BSEL, 0U);
#endif /* __v850e2v3__ */

	return ret;
}
#endif /* OMIT_PROBE_MEM_WRITE */

#ifdef __v850e2v3__
/*
 *  ꤵ줿ɥ쥹桼⡼ɻɹ߲ǽå
 */
#ifdef OMIT_PROBE_MEM_READ
boolean
probe_mem_read(const MemoryStartAddressType base, MemorySizeType size)
{
    uint32 sreg;
    boolean ret;

    /*
     *  OSAPʤǤդΥɥ쥹˥ǽ
     */
    if(run_trusted != FALSE){
        return TRUE;
    }

    sreg = 0x00001000;      /* ץåݸȿХ */
    /*
     *  Х󥯤򥻥å
     */
    LDSR_REG(BSEL, sreg);

    /*
     *  Ƭɥ쥹MCA˥å
     */
    LDSR_REG(MCA, (uint32)base);

    /*
     *  MCS˥å
     */
    LDSR_REG(MCS, (uint32)size);

    /*
     *  ݸå
     */
    LDSR_REG(MCC, (uint32)size);

    /*
     *  ݸå̤ɤ߽Ф
     */
    STSR_REG(MCR, sreg);

    if(sreg & 0x00000100){
        /* Хեξ */
        ret = FALSE;
    } else if(sreg & 0x00000002){
        /* ꡼ɵĤξ */
        ret = TRUE;
    } else {
        ret = FALSE;
    }

    /*
     *  Х󥯤᤹
     */
    LDSR_REG(BSEL, 0U);

	return ret;
}
#endif /* OMIT_PROBE_MEM_READ */

/*
 *  ꤵ줿ΰ褬桼åΰ˼ޤäƤ뤫å
 */
#ifdef OMIT_PROBE_STACK

boolean
probe_stack(const void *base, MemorySizeType size)
{
    uint32 sreg;
    boolean ret;

    sreg = 0x00001000;      /* ץåݸȿХ */
    /*
     *  Х󥯤򥻥å
     */
    LDSR_REG(BSEL, sreg);

    /*
     *  Ƭɥ쥹MCA˥å
     */
    LDSR_REG(MCA, (uint32)base);

    /*
     *  MCS˥å
     */
    LDSR_REG(MCS, (uint32)size);

    /*
     *  ݸå
     */
    LDSR_REG(MCC, 0U);

    /*
     *  ݸå̤ɤ߽Ф
     */
    STSR_REG(MCR, sreg);

    if(sreg & 0x00000100){
        /* Хեξ */
        ret = FALSE;
    } else if(sreg & 0x00000010){
        /* åξ */
        ret = TRUE;
    } else {
        ret = FALSE;
    }

    /*
     *  Х󥯤᤹
     */
    LDSR_REG(BSEL, 0U);

	
	return ret;
}
#endif /* OMIT_PROBE_STACK */
#endif /* __v850e2v3__ */
#endif

AccessType
probe_trusted_osap_mem(const MemoryStartAddressType sadr, const MemoryStartAddressType eadr)
{
    /*
     *  OSAPʤǤդΥɥ쥹˥ǽ
     */
    return(AP_Executable|AP_Readable|AP_Writable);
}

