/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_sil.h 117 2014-12-10 03:58:03Z t_ishikawa $
 */

/*
 *		ڤӼեɥ쥹Υץå¸V850ѡ
 */
#include <prc_insn.h>

#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

#define PSW_ID_BITPTN	(1U << 5)

#define EIRFn		0x1000                      /* ׵ӥå(bit12) */
#define EIMKn		0x0080                      /* ߵĥӥå(bit7) */

/*
 *  ץåΥǥ
 */
#define SIL_ENDIAN_LITTLE

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ֥ؿ
 */

/*
 *  8ӥåñ̤ɽФ
 */
LOCAL_INLINE uint8
sil_reb_mem(void *mem)
{
	uint8 data;

	data = *((volatile uint8 *) mem);
	return(data);
}

LOCAL_INLINE void
sil_wrb_mem(void *mem, uint8 data)
{
	*((volatile uint8 *) mem) = data;
}

/*
 *  16ӥåñ̤ɽФ
 */
LOCAL_INLINE uint16
sil_reh_mem(void *mem)
{
	uint16 data;

	data = *((volatile uint16 *) mem);
	return(data);
}

LOCAL_INLINE void
sil_wrh_mem(void *mem, uint16 data)
{
	*((volatile uint16 *) mem) = data;
}

/*
 *  32ӥåñ̤ɽФ
 */
LOCAL_INLINE void
sil_wrw_mem(void *mem, uint32 data)
{
	*((volatile uint32 *) mem) = data;
}

LOCAL_INLINE uint32
sil_rew_mem(void *mem)
{
	uint32 data;

	data = *((volatile uint32 *) mem);
	return(data);
}

/*
 *  NMI٤Ƥγߤζػ
 */
LOCAL_INLINE uint32
TOPPERS_disint(void)
{
	/* ߤPSWIDӥåȤ򥻥åȤ */
	volatile uint32 psw = current_psw();
	set_psw(psw | PSW_ID_BITPTN);

	return(psw);
}

/*
 *  ͥ٥ޥɽˤθͤ
 */
LOCAL_INLINE void
TOPPERS_enaint(uint32 TOPPERS_psw)
{
	if ((TOPPERS_psw & PSW_ID_BITPTN) == 0u) {
		set_psw(current_psw() & ~PSW_ID_BITPTN);
	}
}

/*
 *  ߥå֤
 */
#define SIL_PRE_LOC		volatile uint32 TOPPERS_psw
#define SIL_LOC_INT()	TOPPERS_psw = TOPPERS_disint()
#define SIL_UNL_INT()	TOPPERS_enaint(TOPPERS_psw)

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_SIL_H */
