/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *	
 *	Copyright (C) 2013 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */


#ifndef TOPPERS_PRC_SVC_H
#define TOPPERS_PRC_SVC_H

#ifndef TOPPERS_MACRO_ONLY

typedef sint32 FunctionCodeType;                  /* ǽɤη */

/*
 *  ͥΥӥΥ󥿥ե
 *
 *  å쥸
 *    r10 : ֤
 *    r11ؿ
 *    r6 - r9 : 4Ĥޤǡ
 *  ؿƤӽФ(jarl)ǥӥƤӽФᡤlp¸
 *  syscallsvc_entryإ
 */

/* "memory"ꤢ */

#define CAL_SVC_0M(TYPE, FNCD) \
	register TYPE  r10 asm("r10"); \
	register FunctionCodeType    r11 asm("r11") = (FunctionCodeType)(FNCD); \
	Asm ( \
        "syscall 1\n\t" \
        "nop\n\t" \
		:"=r"(r10),"+r"(r11) \
		: \
		:"memory","lp","r6","r7","r8","r9","r12","r13","r14","r15","r16","r17","r18","r19", "ep" \
	); \
	return(r10);

#define CAL_SVC_1M(TYPE, FNCD, TYPE1, PAR1) \
	register TYPE  r10 asm("r10"); \
	register TYPE1  r6 asm("r6") = (TYPE1)(PAR1); \
	register FunctionCodeType    r11 asm("r11") = (FunctionCodeType)(FNCD); \
	Asm ( \
        "syscall 1\n\t" \
        "nop\n\t" \
		:"=r"(r10),"+r"(r11),"+r"(r6) \
		: \
		:"memory","lp","r7","r8","r9","r12","r13","r14","r15","r16","r17","r18","r19", "ep" \
	); \
	return(r10);


#define CAL_SVC_2M(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2) \
	register TYPE  r10 asm("r10"); \
	register TYPE1  r6 asm("r6") = (TYPE1)(PAR1); \
	register TYPE2  r7 asm("r7") = (TYPE2)(PAR2); \
	register FunctionCodeType    r11 asm("r11") = (FunctionCodeType)(FNCD); \
	Asm ( \
        "syscall 1\n\t" \
        "nop\n\t" \
		:"=r"(r10),"+r"(r11),"+r"(r6),"+r"(r7) \
		: \
		:"memory","lp","r8","r9","r12","r13","r14","r15","r16","r17","r18","r19", "ep" \
	); \
	return(r10);


#define CAL_SVC_3M(TYPE, FNCD, TYPE1, PAR1, \
							TYPE2, PAR2, TYPE3, PAR3) \
	register TYPE  r10 asm("r10"); \
	register TYPE1  r6 asm("r6") = (TYPE1)(PAR1); \
	register TYPE2  r7 asm("r7") = (TYPE2)(PAR2); \
	register TYPE3  r8 asm("r8") = (TYPE3)(PAR3); \
	register FunctionCodeType    r11 asm("r11") = (FunctionCodeType)(FNCD); \
	Asm ( \
        "syscall 1\n\t" \
        "nop\n\t" \
		:"=r"(r10),"+r"(r11),"+r"(r6),"+r"(r7),"+r"(r8) \
		: \
		:"memory","lp","r9","r12","r13","r14","r15","r16","r17","r18","r19", "ep" \
	); \
	return(r10);

/* 
 *  ֤ͤvoidξ
 *  r10˲쥸˲ä
 */

#define CAL_SVC_0N(TYPE, FNCD) \
	register FunctionCodeType    r11 asm("r11") = (FunctionCodeType)(FNCD); \
	Asm ( \
        "syscall 1\n\t" \
        "nop\n\t" \
		:"+r"(r11) \
		: \
		:"memory","lp","r6","r7","r8","r9","r10","r12","r13","r14","r15","r16","r17","r18","r19", "ep" \
	);

#define CAL_SVC_1N(TYPE, FNCD, TYPE1, PAR1) \
	register TYPE1  r6 asm("r6") = (TYPE1)(PAR1); \
	register FunctionCodeType    r11 asm("r11") = (FunctionCodeType)(FNCD); \
	Asm ( \
        "syscall 1\n\t" \
        "nop\n\t" \
		:"+r"(r11),"+r"(r6) \
		: \
		:"memory","lp","r7","r8","r9","r10","r12","r13","r14","r15","r16","r17","r18","r19", "ep" \
	);


#define CAL_SVC_2N(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2) \
	register TYPE1  r6 asm("r6") = (TYPE1)(PAR1); \
	register TYPE2  r7 asm("r7") = (TYPE2)(PAR2); \
	register FunctionCodeType    r11 asm("r11") = (FunctionCodeType)(FNCD); \
	Asm ( \
        "syscall 1\n\t" \
        "nop\n\t" \
		:"+r"(r11),"+r"(r6),"+r"(r7) \
		: \
		:"memory","lp","r8","r9","r10","r12","r13","r14","r15","r16","r17","r18","r19", "ep" \
	);


#define CAL_SVC_3N(TYPE, FNCD, TYPE1, PAR1, \
							TYPE2, PAR2, TYPE3, PAR3) \
	register TYPE1  r6 asm("r6") = (TYPE1)(PAR1); \
	register TYPE2  r7 asm("r7") = (TYPE2)(PAR2); \
	register TYPE3  r8 asm("r8") = (TYPE3)(PAR3); \
	register FunctionCodeType    r11 asm("r11") = (FunctionCodeType)(FNCD); \
	Asm ( \
        "syscall 1\n\t" \
        "nop\n\t" \
		:"+r"(r11),"+r"(r6),"+r"(r7),"+r"(r8) \
		: \
		:"memory","lp","r9","r10","r12","r13","r14","r15","r16","r17","r18","r19", "ep" \
	);


#ifndef TOPPERS_SVC_CALL
#include "gcc/tool_svc.h"
#endif /* TOPPERS_SVC_CALL */

#endif /* TOPPERS_MACRO_ONLY */


#endif /* TOPPERS_TARGET_SVC_H */

