/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *  Copyright (C) 2013 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: start.S 187 2015-06-25 03:39:04Z t_ishikawa $
 */

/*
 *		ͥбΥȥåץ⥸塼V850ѡ
 */

#define OMIT_INCLUDE_OS_CFG		/* Os_Cfg.h󥯥롼޻ */

#include <v850asm.inc>

	.section .text_kernel
	.align  4
	.global __start
    .extern _bsssecinib_table
    .extern _tnum_bsssec
    .extern _datasecinib_table
    .extern _tnum_datasec
    .extern _syscall_table
FLABEL(__start)
	di                                  /* ߶ػ */

	/*
	 * Ƽݥ󥿤ν(SP/TP/EP/GP/CTBP)
	 */
	Lea     __ostkpt, r3
	ld.w	0[r3],r3
    /* =begin modified for SC3 */
    /*
     * ep, ctbpϤȤꤢѤʤ
     * tp, gpsdataǥѥ餬Ѥ
     */
	Lea		__tp, tp 
	/* Lea		__ep , ep */
	Lea 	__gp , gp
	/* Lea		__ctbp , r6 */
	/* ldsr	r6 , 20 */
    /*
     *  syscallư
     */
#ifdef __v850e2v3__
    mov     SYSCALL_SIZE, r6
    ldsr    r6, sccfg
    Lea     _syscall_table, r6
    ldsr    r6, scbp
#elif defined(__v850e3v5__)
    mov     SYSCALL_SIZE, r6
    ldsr    r6, 11, 1
    Lea     _syscall_table, r6
    ldsr    r6, 12, 1
    syncp
#endif /* __v850e2v3__ */

    /* =end modified for SC3 */

#ifdef TOPPERS_USE_HFLOAT
	/* 
	 *  FPUͭ
	 */
	stsr psw, r12       /* load psw */
	mov  0x00010000,r13 /* PSW.CU0(PSW[16]) = 1 */
	or   r13, r12
	ldsr r12, psw       /* store psw */
#endif /* TOPPERS_USE_HFLOAT */
 	
	/*
	 *  hardware_init_hook θƽФ0 Ǥʤ
	 *
	 *  åȥϡɥ˰¸ɬפʽ
	 *  ϡhardware_init_hook ȤؿѰդ롥
	 */
	Lea		_hardware_init_hook, r1
	cmp		r0, r1
	be		hardware_init_hook_end
	jarl	_hardware_init_hook, lp
FLABEL(hardware_init_hook_end)
	
	/*
	 *  BSS
     *  r0: 쥸
	 */
    mov     r0, r6                  /* r6: ơ֥Υǥå i */
    Lea     _tnum_bsssec, r7
    ld.w    0[r7], r7               /* r7: ơ֥ǿ num */
    Lea     _bsssecinib_table, r8   /* r8: ơ֥Υɥ쥹 */
FLABEL(bss_clear_start)
    cmp     r7, r6                  /* 롼׽λ: i >= num */
    bnl     bss_clear_end
    ld.w    0[r8], ep               /* ep: bssƬ */
    ld.w    4[r8], r9               /* r9: bssνλ */
	cmp     r9, ep                  /* bss */
	bnl 	bss_clear_start_hook    /* ʤмbss */
    nop
FLABEL(bss_clear_body)
    /*
     *  bssΰϡ4byte˥饤󤵤Ƥ
     *  äơ4byteĥǡ򥳥ԡƤ
     */
	sst.w   r0, 0[ep]           /* bssΰ0ǽ */
	add     4, ep              /* Ϥ */
	cmp     r9, ep              /* bssνλϤޤ褿 */
	bl      bss_clear_body      /* λϤǤʤХ롼 */
#ifdef BSSSEC_ALIGN_MASK
    /*
     *  ˤʤޤǽ³
     */
    mov     BSSSEC_ALIGN_MASK, r10
FLABEL(bss_clear_body2)
    tst     r10, ep         /* ep & 0xf == 0 ? */
    bz      bss_clear_start_hook
	sst.w	r0, 0[ep]       /* 0 */
    add     4, ep
    jr      bss_clear_body2
#endif /* BSSSEC_ALIGN_MASK */
    nop
FLABEL(bss_clear_start_hook)
    add     8, r8 /* ơ֥Υɥ쥹򥤥󥯥 4byte * 2 -> 8 */
    add     1, r6 /* ơ֥Υǥå򥤥󥯥: i++ */
    br      bss_clear_start
    nop
FLABEL(bss_clear_end)

#ifndef OMIT_DATA_INIT
	/*
	 *  dataνROMб
	 *
	 */
    mov     r0, r6                  /* r6: ơ֥Υǥå i */
    Lea     _tnum_datasec, r7
    ld.w    0[r7], r7               /* r7: ơ֥ǿ num */
    Lea     _datasecinib_table, r8  /* r8: ơ֥Υɥ쥹 */
FLABEL(data_init_start)
    cmp     r7, r6                  /* 롼׽λ: i >= num */
    bnl     data_init_end
    ld.w    0[r8], ep               /* ep : dataƬ */
    ld.w    4[r8], r9               /* r9 : dataνλ */
    ld.w    8[r8], r2               /* r2: idataνλ */
	cmp     r9, ep                  /* data */
	bnl 	data_init_start_hook    /* ʤмdata */
    nop
FLABEL(data_init_body)
	ld.b	0[r2], r10      /* idataͤ */
	sst.b	r10, 0[ep]      /* idataͤdataΥɥ쥹إȥ */
	add		1, ep           /* dataμϤ */
	add		1, r2           /* idataμϤ */
    cmp     r9, ep          /* dataνλϤޤ褿 */
    bl      data_init_body  /* λϤǤʤХ롼 */
#ifdef DATASEC_ALIGN_MASK
    /*
     *  ˤʤޤǽ³
     */
    mov     DATASEC_ALIGN_MASK, r10
FLABEL(data_init_body2)
    tst     r10, ep         /* ep & 0xf == 0 ? */
    bz      data_init_start_hook
	sst.b	r0, 0[ep]       /* 0 */
    add     1, ep
    jr      data_init_body2
#endif /* DATASEC_ALIGN_MASK */
    nop
FLABEL(data_init_start_hook)        
    add     12, r8  /* ơ֥Υɥ쥹򥤥󥯥 4byte * 3 -> 12 */
    add     1, r6   /* ơ֥Υǥå򥤥󥯥: i++ */
	br		data_init_start         
    nop
FLABEL(data_init_end)
#endif /* OMIT_DATA_INIT */

	/*
	 *  software_init_hook ƽФ0 Ǥʤ
	 *
	 *  եȥĶä˥饤֥ˤ˰¸ɬפʽ
	 *  ϡsoftware_init_hook ȤؿѰդ
	 *  褤
	 */

	Lea		_software_init_hook, r1
	cmp		r0, r1
	be		software_init_hook_end
	jarl	_software_init_hook, r31
FLABEL(software_init_hook_end)

	/*
	 *  ͥư롥
	 */
	jarl    _target_hardware_initialize, r31
	jarl    _main, r31
	halt

	.end
