/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Spansion LLC, USA
 *  Copyright (C) 2014 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: tauj_hw_counter.c 154 2015-01-28 11:33:39Z t_ishikawa $
 */

/*
 *		ʲϡɥ󥿥ץΥåȰ¸fl850fx4ѡ
 *
 *  Ѥ륿ޡ
 *    ʬޡŪλ֤ꤹθ߻(ͥ)
 *              ȼλ֤Ȥл֤򥫥Ȥ뤳Ȥ
 *              Ūл֤λȤȤ
 *              count mode:count down once
 *
 *    ͥޡ󥿼ʬΥ١ޤ¸
 *              (л֤򥫥)
 *              count mode:continuous count down
 *
 *    ޤ嵭Υޤ32bitΥ󥫥󥿥ޤǤ
 *
 *  ˡ
 *
 *   ͥޤϥ桼󥿺2+1ޤǥȤ
 *   ޤȤϢ³ȥ󤷤ơ˸߻
 *   롥ȯɬפʤᡤߤʤ⡼
 *
 *   ʬޤϡλԤᡤߤ⡼ɤư
 *   顼ʤɤλȥޡ1Ǽ߻κ
 *   ͥޤꤹ
 *
 *  ݥȡ
 *   λϡ߻ƶʤᡤͥޤߤƤ
 *
 */

#include "Os.h"
#include "prc_sil.h"
#include "target_hw_counter.h"

/*
 *  =begin ϡɥ󥿤TAUJn¸
 */
/*
 *  ϡɥ󥿤ν
 *   n_d  : ʬޤΥ˥åֹ
 *   ch_d : ʬޤΥͥ
 *   n_c  : ͥޤΥ˥åֹ
 *   ch_c : ͥޤΥͥ
 */
static void
init_hwcounter_tauj(uint8 n_d, uint8 ch_d, uint8 n_c, uint8 ch_c, TickType maxval, TimeType nspertick, TickRefType cycle)
{
	uint16	wk;
	*cycle = maxval;

	/* assert((tauj_id + 1) < TAUJ_MAX); */

	/* ʬ߽ */
	SetTimerStopTAUJ(n_d, ch_d);
	/* ߶ػ */
	HwcounterDisableInterrupt(TAUJ_INTNO(n_d, ch_d));
	/* ׵᥯ꥢ */
	HwcounterClearInterrupt(TAUJ_INTNO(n_d, ch_d));

	/* ʬޤΥץꥹ PCLK/2^0 */
	wk = sil_reh_mem((void *) TAUJTPS(n_d));
	wk &= MCU_TAUJ_MASK_CK0;
	wk |= MCU_TAUJ_CK0_0;
	sil_wrh_mem((void *) TAUJTPS(n_d), wk);

	/* ͥޤΥץꥹ PCLK/2^0 */
	wk = sil_reh_mem((void *) TAUJTPS(n_c));
	wk &= MCU_TAUJ_MASK_CK0;
	wk |= MCU_TAUJ_CK0_0;
	sil_wrh_mem((void *) TAUJTPS(n_c), wk);

	/* ʬޤ򥤥󥿡Х륿ޤȤ */
	sil_wrh_mem((void *) TAUJCMOR(n_d, ch_d), MCU_TAUJ00_CMOR);
	sil_wrb_mem((void *) TAUJCMUR(n_d, ch_d), MCU_TAUJ00_CMUR);

	/* ߽ͥ */
	SetTimerStopTAUJ(n_c, ch_c);
	/* ߶ػ */
	HwcounterDisableInterrupt(TAUJ_INTNO(n_c, ch_c));
	/* ׵᥯ꥢ */
	HwcounterClearInterrupt(TAUJ_INTNO(n_c, ch_c));

	/* ͥޤ򥤥󥿡Х륿ޤȤ */
	sil_wrh_mem((void *) TAUJCMOR(n_c, ch_c), MCU_TAUJ00_CMOR);
	sil_wrb_mem((void *) TAUJCMUR(n_c, ch_c), MCU_TAUJ00_CMUR);

	/* ޥȼ */
	sil_wrw_mem((void *) TAUJCDR(n_c, ch_c), maxval);
}
/*
 *  ϡɥ󥿤γ
 */
static void
start_hwcounter_tauj(uint8 n_c, uint8 ch_c)
{
	/* ͥ޳ */
	SetTimerStartTAUJ(n_c, ch_c);
}

/*
 *  ϡɥ󥿤
 *   n_d  : ʬޤΥ˥åֹ
 *   ch_d : ʬޤΥͥ
 *   n_c  : ͥޤΥ˥åֹ
 *   ch_c : ͥޤΥͥ  
 */
static void
stop_hwcounter_tauj(uint8 n_d, uint8 ch_d, uint8 n_c, uint8 ch_c)
{
	/* ʬޤ */
	SetTimerStopTAUJ(n_d, ch_d);

	/* ʬޤγ߶ػ */
	HwcounterDisableInterrupt(TAUJ_INTNO(n_d, ch_d));
	/* ʬޤγ׵Υꥢ */
	HwcounterClearInterrupt(TAUJ_INTNO(n_d, ch_d));

	/* ͥޤ */
	SetTimerStopTAUJ(n_c, ch_c);

	/* ͥޤγ߶ػ */
	/* HwcounterDisableInterrupt(TAUJ_INTNO(tauj_id + 1)); */
	/* ͥޤγ׵Υꥢ */
	HwcounterClearInterrupt(TAUJ_INTNO(n_c, ch_c));
}

/*
 *  ϡɥ󥿤ؤλ֤
 *   n_d  : ʬޤΥ˥åֹ
 *   ch_d : ʬޤΥͥ
 *   n_c  : ͥޤΥ˥åֹ
 *   ch_c : ͥޤΥͥ    
 */
static void
set_hwcounter_tauj(uint8 n_d, uint8 ch_d, uint8 n_c, uint8 ch_c, TickType exprtick, TickType maxval)
{
	TickType	curr_time;
	TickType	value;

	/* ʬޤγ׵Υꥢ */
	HwcounterClearInterrupt(TAUJ_INTNO(n_d, ch_d));
	/* ʬޤγߵ */
	HwcounterEnableInterrupt(TAUJ_INTNO(n_d, ch_d));

	/* ߻μ */
	curr_time = GetCurrentTimeTAUJ(n_c, ch_c, maxval);

	/* ޤꤹͤ򻻽	*/
	if (exprtick >= curr_time) {
		value = exprtick - curr_time;
	}
	else {
		value = (exprtick - curr_time) + (maxval + 1U);
	}

	/*
	 *  ޤ0x00ꤷȯ塤0ꤷ硤2ܤ
	 *  0x00γߤȯʤΤǡ0x00ͤ0x01ľ
	 */
	if (value == 0x00U) {
		value = 0x01U;
	}

	/* ʬޤΥ */
	sil_wrw_mem((void *) TAUJCDR(n_d, ch_d), (value));

	/*
	 * ȳ
	 */
	SetTimerStartTAUJ(n_d, ch_d);
}

/*
 *  ϡɥ󥿤θ߻֤μ
 */
static TickType
get_hwcounter_tauj(uint8 n_c, uint8 ch_c, TickType maxval)
{
	return(GetCurrentTimeTAUJ(n_c, ch_c, maxval));
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
static void
cancel_hwcounter_tauj(uint8 n_d, uint8 ch_d)
{
	/* ʬޤ */
	SetTimerStopTAUJ(n_d, ch_d);
}

/*
 *  ϡɥ󥿤ζ׵
 */
static void
trigger_hwcounter_tauj(uint8 n_d, uint8 ch_d)
{
	/* ʬ */
	SetTimerStopTAUJ(n_d, ch_d);

	/* ʬޤγ׵Υꥢ */
	HwcounterClearInterrupt(TAUJ_INTNO(n_d, ch_d));
	/* ʬޤγߵ */
	HwcounterEnableInterrupt(TAUJ_INTNO(n_d, ch_d));

	/* ʬޥ󥿡0x01򥻥åȤ뤳Ȥǡλ */
	sil_wrw_mem((void *) TAUJCDR(n_d, ch_d), (1));

	/*  ʬ޳ */
	SetTimerStartTAUJ(n_d, ch_d);
}

/*
 *  ׵Υꥢ
 */
static void
int_clear_hwcounter_tauj(uint8 n_d, uint8 ch_d)
{
	/* ׵᥯ꥢ */
	HwcounterClearInterrupt(TAUJ_INTNO(n_d, ch_d));
}

/*
 *  ׵Υ󥻥
 *  ڥǥ󥰤Ƥ׵򥭥󥻥
 */
static void
int_cancel_hwcounter_tauj(uint8 n_d, uint8 ch_d)
{
	/* ׵᥯ꥢ */
	HwcounterClearInterrupt(TAUJ_INTNO(n_d, ch_d));
}

/*
 *  ϡɥ󥿤Υ󥯥
 */
static void
increment_hwcounter_tauj(uint8 n_d, uint8 ch_d)
{
	/* ̤ݡ */
	return;
}
/*
 *  =end ϡɥ󥿤TAUJn¸
 */


/*
 *  =begin MAIN_HW_COUNTER
 */
/* 󥿤κͤ2+1 */
static TickType MAIN_HW_COUNTER_maxval;

/*
 *  ϡɥ󥿤ν
 */
void
init_hwcounter_MAIN_HW_COUNTER(TickType maxval, TimeType nspertick)
{
	init_hwcounter_tauj(HWC_DTIM_UNIT, HWC_DTIM_ID,
						HWC_CTIM_UNIT, HWC_CTIM_ID,
						maxval, nspertick, &MAIN_HW_COUNTER_maxval);
}

/*
 *  ϡɥ󥿤γ
 */
void
start_hwcounter_MAIN_HW_COUNTER(void)
{
	start_hwcounter_tauj(HWC_CTIM_UNIT, HWC_CTIM_ID);
}

/*
 *  ϡɥ󥿤
 */
void
stop_hwcounter_MAIN_HW_COUNTER(void)
{
	stop_hwcounter_tauj(HWC_DTIM_UNIT, HWC_DTIM_ID,
						HWC_CTIM_UNIT, HWC_CTIM_ID);
}

/*
 *  ϡɥ󥿤ؤλ֤
 */
void
set_hwcounter_MAIN_HW_COUNTER(TickType exprtick)
{
	set_hwcounter_tauj(HWC_DTIM_UNIT, HWC_DTIM_ID,
					   HWC_CTIM_UNIT, HWC_CTIM_ID,
					   exprtick, MAIN_HW_COUNTER_maxval);
}

/*
 *  ϡɥ󥿤θ߻֤μ
 */
TickType
get_hwcounter_MAIN_HW_COUNTER(void)
{
	return(get_hwcounter_tauj(HWC_CTIM_UNIT, HWC_CTIM_ID,
							  MAIN_HW_COUNTER_maxval));
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
cancel_hwcounter_MAIN_HW_COUNTER(void)
{
	cancel_hwcounter_tauj(HWC_DTIM_UNIT, HWC_DTIM_ID);
}

/*
 *  ϡɥ󥿤ζ׵
 */
void
trigger_hwcounter_MAIN_HW_COUNTER(void)
{
	trigger_hwcounter_tauj(HWC_DTIM_UNIT, HWC_DTIM_ID);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_clear_hwcounter_MAIN_HW_COUNTER(void)
{
	int_clear_hwcounter_tauj(HWC_DTIM_UNIT, HWC_DTIM_ID);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_cancel_hwcounter_MAIN_HW_COUNTER(void)
{
	int_cancel_hwcounter_tauj(HWC_DTIM_UNIT, HWC_DTIM_ID);
}

/*
 *  ϡɥ󥿤Υ󥯥
 */
void
increment_hwcounter_MAIN_HW_COUNTER(void)
{
	increment_hwcounter_tauj(HWC_DTIM_UNIT, HWC_DTIM_ID);
}

/*
 *  =end MAIN_HW_COUNTER
 */
