/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: uart.c 117 2014-12-10 03:58:03Z t_ishikawa $
 */

/*
 *		ꥢI/OǥХSIO˥ɥ饤СUARTѡ
 */

#include "Os.h"
#include "target_serial.h"
#include "uart.h"
#include "Os_Lcfg.h"

/*
 *  ѥХåե
 */
static uint8 rx_buf;

/* ؿΥץȥ */
LOCAL_INLINE boolean uart_getready(void);
LOCAL_INLINE uint8 uart_getchar(void);

/*
 *  ʸå
 */
LOCAL_INLINE boolean
uart_getready(void)
{
	boolean ans;
	uint8	stat;
	uint8	rx_tmp;

	stat = sil_reb_mem((void *) URTEnSTR1);                     /* ơɤ߹ */
	rx_tmp = sil_reb_mem((void *) URTEnRX);                     /* ǡɤ߹ */

	ans = FALSE;
	if ((stat & 0x07) == 0)	{
		rx_buf = rx_tmp;
		ans = TRUE;
	}
	sil_wrb_mem((void *) URTEnSTC, 0x1f);                            /* ơꥢ */

	return(ans);
}

/*
 *  ʸμФ
 */
LOCAL_INLINE uint8
uart_getchar(void)
{
	return(rx_buf);
}

/*
 *  
 */
void
InitHwSerial(void)
{
	sil_wrh_mem((void *) URTEnCTL2, URTEnCTL2_VAL);
	sil_wrh_mem((void *) URTEnCTL1, 0x0103);        /* 8bit, LSB First */
	sil_wrb_mem((void *) URTEnCTL0, 0x80);
	sil_wrb_mem((void *) URTEnCTL0, 0xe0);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
TermHwSerial(void)
{
	/* ߤζػ */
	sil_wrb_mem((void *) URTEnCTL0, 0x00);
}

/*
 *  SIOγߥϥɥ
 */
ISR(RxHwSerialInt)
{
	if (uart_getready() != FALSE) {
		/*
		 *  ΥХå롼ƤӽФ
		 */
		RxSerialInt(uart_getchar());
	}
}
