/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: v850.h 187 2015-06-25 03:39:04Z t_ishikawa $
 */

/*
 *		V850Υϡɥ񸻤ʳȯĶ̡
 */

#ifndef TOPPERS_V850_H
#define TOPPERS_V850_H

#ifdef __v850e2v3__

#ifdef _V850E2M_
#define TNUM_INTPRI	16
#elif defined(_V850E2S_)
#define TNUM_INTPRI	8
#else
#error please define ether _V850E2M_ or _V850E2S_
#endif /* _V850E2M_ */

/*
 *  V850E2Ѥγߥȥ롼
 */
#ifndef TOPPERS_MACRO_ONLY

#include "prc_sil.h"

LOCAL_INLINE void
set_pmr(uint16 pmr)
{
	sil_wrh_mem((void *) PMR, pmr);
	SYNCM;
}

LOCAL_INLINE uint16
get_ispr(void)
{
	return(sil_reh_mem((void *) ISPR_H));
}

LOCAL_INLINE void
clear_ispr(void)
{
	sil_wrh_mem((void *) ISPC_H, 0xffff);
	sil_wrh_mem((void *) ISPR_H, 0x0000);
}

#endif /* TOPPERS_MACRO_ONLY */

#define FE_MIP 0x430U
#define FE_MDP 0x431U
#define FE_PPI 0x432U
#define FE_TSI 0x433U

#elif defined(__v850e3v5__)

#ifdef _RH850G3M_
#define TNUM_INTPRI	16
#elif defined(_RH850G3K_)
#define TNUM_INTPRI	8
#else
#error please define ether _RH850G3M_ or _RH850G3K_
#endif /* _RH850G3M_ */

#define FE_MIP 0x90U
#define FE_MDP 0x91U

#else /* __v850e3v5__ */
#error please define ether __v850e2v3__ or __v850e3v5__
#endif /* __v850e2v3__ */

/*
 *  V850E2M ƥ쥸
 */
 
#define FEIC	14
#define SCBP	12
#define SCCFG	11
#define VMTID	 5
#define VMADR	 6

#define IPA0L	 6
#define IPA0U	 7
#define IPA1L	 8
#define IPA1U	 9
#define IPA2L	10
#define IPA2U	11
#define IPA3L	12
#define IPA3U	13
#define IPA4L	14
#define IPA4U	15

#define DPA0L	16
#define DPA0U	17
#define DPA1L	18
#define DPA1U	19
#define DPA2L	20
#define DPA2U	21
#define DPA3L	22
#define DPA3U	23
#define DPA4L	24
#define DPA4U	25
#define DPA5L	26
#define DPA5U	27

#define MCA		24
#define MCS		25
#define MCC		26
#define MCR		27

#define MPM		 0

#define BSEL	31

#ifdef __v850e2v3__
#define PSW_SV  16
#define FE_MP_MASK 0x43e
#define FE_MP_BIT  0x430

#elif defined(__v850e3v5__)
#define PSW_SV  2
#define FE_MP_MASK 0x9e
#define FE_MP_BIT  0x90
#define MPAT_E  0x80    /* ͭ */
#define MPAT_G  0x40    /* ASID̵ */
#define MPAT_UX 0x04    /* 桼¹ */
#define MPAT_UW 0x02    /* 桼 */
#define MPAT_UR 0x01    /* 桼ɽ */

#else /* __v850e3v5__ */
#error please define ether __v850e2v3__ or __v850e3v5__
#endif /* __v850e2v3__ */

#endif /* TOPPERS_V850_H */
