#
#  TOPPERS ATK2
#      Toyohashi Open Platform for Embedded Real-Time Systems
#      Automotive Kernel Version 2
#
#  Copyright (C) 2012-2014 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
#  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
#  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
#  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
#  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
#  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
#  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
#  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
#  Copyright (C) 2013 by Embedded and Real-Time Systems Laboratory
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
#  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
#  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
#  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Makefile.prc 182 2015-06-24 07:14:37Z t_ishikawa $
#

#
#		Makefile Υץå¸V850ѡ
#

#
#  ץå̾ȯĶ̾
#
PRC  = v850
TOOL = ghs

#
#  ץå¸ǥ쥯ȥ̾
#
PRCDIR = $(SRCDIR)/arch/$(PRC)_$(TOOL)
PRCDIR_GCC = $(SRCDIR)/arch/$(PRC)_gcc

#
#  ѥ륪ץ
#
INCLUDES := $(INCLUDES) -I$(PRCDIR) -I$(PRCDIR_GCC) -I$(SRCDIR)/arch/$(TOOL) 
COPTS := $(COPTS) -ansi -preprocess_assembly_files \
         -srec -kanji=euc -noobj \
         -no_callt \
         -prepare_dispose \
         -registermode=32 \
         -keeptempfiles \
         --no_commons \
         -dual_debug -G\
         --no_slash_comment \
         -sda=all \
         -reserve_r2

LDFLAGS := $(LDFLAGS) -Wl,-append

#
#  ƥڤؤ
#
ifeq ($(ARCH),V850E2V3)
	COPTS := $(COPTS) -cpu=v850e2v3
	CDEFS := $(CDEFS) -D__v850e2v3__
	KERNEL_ASMOBJS := $(KERNEL_ASMOBJS) Os_Lcfg_asm.o
endif
ifeq ($(ARCH),V850E3V5)
	COPTS := $(COPTS) -cpu=v850e3v5
	CDEFS := $(CDEFS) -D__v850e3v5__
endif

#
#  ()ˤڤؤ
#
ifeq ($(CORETYPE),RH850G3K)
	#COPTS := $(COPTS) -fsoft
	COPTS := $(COPTS) -fsoft -sda=0
endif
ifeq ($(CORETYPE),RH850G3M)
	ifeq ($(USE_HARD_FLOAT),true)
		COPTS := $(COPTS) -DTOPPERS_USE_HFLOAT
	else
		COPTS := $(COPTS) -fsoft
	endif
endif

#
#  Ŭ˴ؤ륪ץ
#
# Makefile  -O2 դʤ
OMIT_OPTIMIZATION = true
#COPTS := $(COPTS) -Ospace -Omax -Olink -Ointerproc
COPTS := $(COPTS) -Odebug

#
#  ٹ˴ؤ륪ץ
#
COPTS := $(COPTS) --prototype_warnings  \
                   -Wimplicit-int \
                   -Wshadow \
                   -Wundef \
                   -Wtrigraphs \
                   --assembler_warnings \
                   -linker_warnings \
                   --diag_suppress 174,188,191,767 

#
#  ͥ˴ؤ
#
KERNEL_DIR := $(KERNEL_DIR) $(PRCDIR) $(PRCDIR_GCC)
KERNEL_ASMOBJS := $(KERNEL_ASMOBJS) prc_support.o prc_tool.o 
KERNEL_COBJS := $(KERNEL_COBJS) prc_config.o prc_mpu.o 

#
#  GNUȯĶΥåȥƥ
#
GCC_TARGET = v850-elf

#
#  ȥåץ⥸塼˴ؤ
#
START_OBJS := $(START_OBJS) start.o

$(START_OBJS): %.o: %.S
	$(CC) -c $(CFLAGS) $(KERNEL_CFLAGS) $<

$(START_OBJS:.o=.d): %.d: %.S
	@$(PERL) $(SRCDIR)/utils/makedep -C $(CC) \
		-O "$(CFLAGS) $(KERNEL_CFLAGS)" $< >> Makefile.depend



#
#  󥯤˴ؤ
#
LDFLAGS := $(LDFLAGS) -e __reset -nostartfiles

CFG1_OUT_LDFLAGS := -nostartfiles
CFG1_OUT_LDFLAGS := $(CFG1_OUT_LDFLAGS) $(LDFLAGS)
CFG2_OUT_LDFLAGS := $(CFG2_OUT_LDFLAGS) $(LDFLAGS)
CFG3_OUT_LDFLAGS := $(CFG3_OUT_LDFLAGS) $(LDFLAGS)

# ַλŪʥ󥫥ץ
CFG2_OUT_LDSCRIPT = cfg2_out.ld
# ַΥ󥫥ץ
CFG3_OUT_LDSCRIPT = cfg3_out.ld
# ǽŪʥ󥫥ץ
LDSCRIPT = ldscript.ld
ifeq ($(ARCH),V850E2V3)
	USE_CFG_PASS3 = true
endif

$(LDSCRIPT): kernel_cfg.timestamp
$(CFG2_OUT_LDSCRIPT): kernel_cfg.timestamp

#
#  ¸ط
#
cfg1_out.c: $(PRCDIR_GCC)/prc_def.csv
Os_Lcfg.timestamp: $(PRCDIR)/prc.tf
$(OBJFILE): $(PRCDIR_GCC)/prc_mem.tf
offset.h: $(PRCDIR_GCC)/prc_offset.tf


#
#  ͥ졼طѿ
#
CFG_TABS := $(CFG_TABS) --cfg1-def-table $(PRCDIR_GCC)/prc_def.csv

#
#  ȯġΥޥ̾
#
ifeq ($(ARCH),V850E2V3)
	CC = ccv850.exe
	AR = ccv850.exe
endif

ifeq ($(ARCH),V850E3V5)
	CC = ccrh850.exe
	AR = ccrh850.exe
endif

NM = nm

#
#  clean Ǻե
#
CLEAN_FILES := $(CLEAN_FILES) *.dbo *.dla *.map *.run *.dnm *.dep *.dba *.si *.inf
