/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: v850asm.inc 151 2015-01-19 11:41:16Z t_ishikawa $  
 */

/*
 *  V850֥ե
 */
#define TOPPERS_MACRO_ONLY
#define UINT_C(val)			(val)		/* ̵ޥ */
#define CAST(type, val)		(val)		/* 㥹ȤԤޥ */

#include "kernel_impl.h"

/*
 * ֥ޥǤΰλ
 */
#define AMARG(name)  name

	/*
	 * ٥ Lea (Load Effective Address)
	 */

	.macro	Lea name, destination
	mov	name, destination
	.endm

	/*
	 * ٥ Flabel
	 *
	 *   ؿ̾ȤƻȤ٥դԤ
	 */
	.macro	Flabel name
	.type	name,@function
name:
	.endm

#define FLABEL(name) Flabel name

	/*
	 * å - ץå
	 */
	
	.macro	Push source
	add	-4, sp
	st.w	source, 0[sp]
	.endm
	
	/*
	 * å - ݥå
	 */
	
	.macro	Pop dest
	ld.w	0[sp],dest
	add	4, sp
	.endm

	/*
	 * ߶ػ
	 */
	.macro	X_LOCK_ALL_INT reg1 reg2
	ld.w	PMR, reg1
	ld.w	0xffff, reg2
	and		reg2,reg1
	st.w	reg2
	.endm

/*
 *  ߶ػߥޥ
 */
.macro LOCK_ALL_INT
    di
.endm

/*
 *  ߶ػ߲ޥ
 */
.macro UNLOCK_ALL_INT
    ei
.endm

/*
 *  V850E2M ƥ쥸
 */
 
#define scbp	12
#define sccfg	11
#define vmtid	 5
#define vmadr	 6

#define ipa0l	 6
#define ipa0u	 7
#define ipa1l	 8
#define ipa1u	 9
#define ipa2l	10
#define ipa2u	11
#define ipa3l	12
#define ipa3u	13
#define ipa4l	14
#define ipa4u	15

#define dpa0l	16
#define dpa0u	17
#define dpa1l	18
#define dpa1u	19
#define dpa2l	20
#define dpa2u	21
#define dpa3l	22
#define dpa3u	23
#define dpa4l	24
#define dpa4u	25
#define dpa5l	26
#define dpa5u	27

#define mca		24
#define mcs		25
#define mcc		26
#define mcr		27

#define mpm		 0

