/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: ioc_impl.h 187 2015-06-25 03:39:04Z t_ishikawa $
 */

/*
 *		IOCǽ
 */

#ifndef TOPPERS_IOC_IMPL_H
#define TOPPERS_IOC_IMPL_H

#include "kernel_impl.h"
#include "osap.h"

/*
 *  Wrapper IDIOCWRPINIBФΥޥ
 */
#define get_iocwrpinib(WrapperId)	(&iocwrpinib_table[(WrapperId)])

/*
 *  IOC IDIOCCB,IOCINIBФΥޥ
 */
#define get_ioccb(iocid)		(&ioccb_table[(iocid)])
#define get_iocinib(iocid)		(&iocinib_table[(iocid)])

/*
 *  IOCWRPINIBIOC IDФΥޥ
 */
#define IOCID(p_iocwrpinib)	((IocType) (((p_iocwrpinib)->p_iocinib) - iocinib_table))



/*
 *  IOC֥å
 */
typedef struct ioc_initialization_block {
	uint32	maxque;                 /* 塼 */
	uint32	datasz;                 /* ǡ */
	uint32	alignsz;                /* 饤󥵥 */
#ifdef CFG_USE_ERRORHOOK
	boolean	groupflg;            /* 롼̿ե饰 */
#endif /* CFG_USE_ERRORHOOK */
	OSAPCB	*p_rcvosapcb;        /* Receiver°OSAPν֥åؤΥݥ */
	void	*p_iocmb;
} IOCINIB;

/*
 *  IOC֥åOs_Lcfg.c
 */
typedef struct ioc_control_block {
	uint32	quecnt;                 /* ߤΥ塼 */
	uint32	head;                   /* 塼Ƭ */
	uint32	tail;                   /* 塼κǸ */
	boolean	lostflg;                /* 塼ե륨顼(E_LOST_DATA)ѥե饰 */
} IOCCB;

/*
 *  IOC Wrapper֥å
 */
typedef struct ioc_wrapper_initialization_block {
	const IOCINIB	*p_iocinib;         /* IOC֥åؤΥݥ */
	OSAPCB			*p_sndosapcb;       /* Sender°OSAPν֥åؤΥݥ */
	SenderIdType	senderid;           /* SenderID */
} IOCWRPINIB;


extern const IocType	tnum_ioc;       /* IOCο */
extern const IocType	tnum_queueioc;  /* 塼IOCο */

/*
 *  IOC Wrapper֥åOs_Lcfg.c
 */
extern const IOCWRPINIB	iocwrpinib_table[];

/*
 *  IOC֥åOs_Lcfg.c
 */
extern const IOCINIB	iocinib_table[];

/*
 *  IOC֥åOs_Lcfg.c
 */
extern IOCCB			ioccb_table[];

/*
 *  IOC WRAPPER֥åOs_Lcfg.c
 */
extern const IOCWRPINIB	iocwrpinib_table[];

/*
 *  IOCͥơ֥
 */
extern void				*ioc_inival_table[];

/*
 *  IOC⥸塼ν
 */
extern void ioc_initialize(void);

#endif /* TOPPERS_IOC_IMPL_H */
