/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: osctl.c 187 2015-06-25 03:39:04Z t_ishikawa $
 */

/*
 *		OS⥸塼
 */

#include "kernel_impl.h"
#include "interrupt.h"
#include "task.h"

/*
 *  ȥ졼ޥΥǥե
 */

#ifndef LOG_ERRHOOK_ENTER
#define LOG_ERRHOOK_ENTER(ercd)
#endif /* LOG_ERRHOOK_ENTER */

#ifndef LOG_ERRHOOK_LEAVE
#define LOG_ERRHOOK_LEAVE()
#endif /* LOG_ERRHOOK_LEAVE */

#ifndef LOG_ERRHOOKOSAP_ENTER
#define LOG_ERRHOOKOSAP_ENTER(p_runosap, ercd)
#endif /* LOG_ERRHOOKOSAP_ENTER */

#ifndef LOG_ERRHOOKOSAP_LEAVE
#define LOG_ERRHOOKOSAP_LEAVE(p_runosap)
#endif /* LOG_ERRHOOKOSAP_LEAVE */

#ifndef LOG_PROHOOK_ENTER
#define LOG_PROHOOK_ENTER(ercd)
#endif /* LOG_PROHOOK_ENTER */

#ifndef LOG_PROHOOK_LEAVE
#define LOG_PROHOOK_LEAVE(pret)
#endif /* LOG_PROHOOK_LEAVE */

#ifndef LOG_SHUTHOOK_ENTER
#define LOG_SHUTHOOK_ENTER(ercd)
#endif /* LOG_SHUTHOOK_ENTER */

#ifndef LOG_SHUTHOOK_LEAVE
#define LOG_SHUTHOOK_LEAVE()
#endif /* LOG_SHUTHOOK_LEAVE */

#ifndef LOG_SHUTHOOKOSAP_ENTER
#define LOG_SHUTHOOKOSAP_ENTER(index, ercd)
#endif /* LOG_SHUTHOOKOSAP_ENTER */

#ifndef LOG_SHUTHOOKOSAP_LEAVE
#define LOG_SHUTHOOKOSAP_LEAVE(index)
#endif /* LOG_SHUTHOOKOSAP_LEAVE */

#ifndef LOG_STUTOS_ENTER
#define LOG_STUTOS_ENTER(ercd)
#endif /* LOG_STUTOS_ENTER */

#ifndef LOG_STUTOS_LEAVE
#define LOG_STUTOS_LEAVE()
#endif /* LOG_STUTOS_LEAVE */

#ifdef CFG_USE_ERRORHOOK
/*
 *  顼եåϤǼѿ
 */
#ifdef TOPPERS_internal_call_errorhook

#ifdef CFG_USE_GETSERVICEID
DEFINE_VAR_SEC_NOBITS(OSServiceIdType, _errorhook_svcid, ".srpw_bss_kernel");
#endif /* CFG_USE_GETSERVICEID */

#ifdef CFG_USE_PARAMETERACCESS
_ErrorHook_Par	_errorhook_par1;
_ErrorHook_Par	_errorhook_par2;
_ErrorHook_Par	_errorhook_par3;
DEFINE_VAR_SEC_NOBITS(_ErrorHook_Par, errorhook_par1, ".srpw_bss_kernel");
DEFINE_VAR_SEC_NOBITS(_ErrorHook_Par, errorhook_par2, ".srpw_bss_kernel");
DEFINE_VAR_SEC_NOBITS(_ErrorHook_Par, errorhook_par3, ".srpw_bss_kernel");
#endif /* CFG_USE_PARAMETERACCESS */

/*
 *  顼եåθƤӽФ
 */
void
internal_call_errorhook(StatusType ercd, OSServiceIdType svcid)
{
	void (*volatile errorhook_adr) (StatusType Error);
	uint8	saved_sus_all_cnt_ctx;
	uint8	saved_sus_os_cnt_ctx;

	boolean	saved_run_trusted = run_trusted;

	saved_sus_all_cnt_ctx = sus_all_cnt_ctx;
	saved_sus_os_cnt_ctx = sus_os_cnt_ctx;

	sus_all_cnt_ctx = 0U;
	sus_os_cnt_ctx = 0U;

#ifdef CFG_USE_SYSTEM_ERRORHOOK
	/*
	 *  CεʤǤϴؿΥɥ쥹0ˤʤʤȤ󤫤,
	 *  ѥκŬˤErrorHookΥɥ쥹Ƚʬ
	 *  Ƥޤ礬뤿, volatileꤷѿ
	 *  ɥ쥹ƤȽꤷƤ
	 */
	errorhook_adr = &ErrorHook;

	if (errorhook_adr != NULL) {
		if ((callevel_stat & (TCL_ERROR | TSYS_ISR1)) == TCL_NULL) {

#ifdef CFG_USE_GETSERVICEID
			_errorhook_svcid = svcid;
#endif /* CFG_USE_GETSERVICEID */

#ifdef CFG_USE_PARAMETERACCESS
			errorhook_par1 = _errorhook_par1;
			errorhook_par2 = _errorhook_par2;
			errorhook_par3 = _errorhook_par3;
#endif /* CFG_USE_PARAMETERACCESS */

			ENTER_CALLEVEL(TCL_SYS_ERROR);
			run_trusted = TRUE;

			LOG_ERRHOOK_ENTER(ercd);
			ErrorHook(ercd);
			LOG_ERRHOOK_LEAVE();
			LEAVE_CALLEVEL(TCL_SYS_ERROR);

			release_interrupts(OSServiceId_HookMissingEnd);
		}
	}
#endif /* CFG_USE_SYSTEM_ERRORHOOK */

#ifdef CFG_USE_OSAP_ERRORHOOK
	/* OSץꥱΥ顼եåƽФ */
	errorhook_adr = NULL;
	if (p_runosap != NULL) {
		errorhook_adr = p_runosap->p_osapinib->ErrorHook;
	}

	if (errorhook_adr != NULL) {
		if ((callevel_stat & (TCL_ERROR | TSYS_ISR1)) == TCL_NULL) {
#ifdef CFG_USE_GETSERVICEID
			_errorhook_svcid = svcid;
#endif /* CFG_USE_GETSERVICEID */

#ifdef CFG_USE_PARAMETERACCESS
			errorhook_par1 = _errorhook_par1;
			errorhook_par2 = _errorhook_par2;
			errorhook_par3 = _errorhook_par3;
#endif /* CFG_USE_PARAMETERACCESS */

			ENTER_CALLEVEL(TCL_OSAP_ERROR);

			LOG_ERRHOOKOSAP_ENTER(p_runosap, ercd);
			if (p_runosap->p_osapinib->osap_trusted != FALSE) {
				run_trusted = TRUE;
				errorhook_adr(ercd);
			}
			else {
				run_trusted = FALSE;
				call_nontrusted_hook((void *) errorhook_adr, ercd, ERROR_HOOK);
			}
			LOG_ERRHOOKOSAP_LEAVE(p_runosap);

			LEAVE_CALLEVEL(TCL_OSAP_ERROR);

			release_interrupts(OSServiceId_HookMissingEnd);
		}
	}
#endif /* CFG_USE_OSAP_ERRORHOOK */

	sus_all_cnt_ctx = saved_sus_all_cnt_ctx;
	sus_os_cnt_ctx = saved_sus_os_cnt_ctx;

	run_trusted = saved_run_trusted;
}

#endif /* TOPPERS_internal_call_errorhook */

#endif /* CFG_USE_ERRORHOOK */

#ifdef CFG_USE_POSTTASKHOOK
/*
 *  ݥȥեåθƤӽФ
 */
#ifdef TOPPERS_call_posttaskhook

void
call_posttaskhook(void)
{
	boolean saved_run_trusted;

	ENTER_CALLEVEL(TCL_PREPOST);
	saved_run_trusted = run_trusted;
	run_trusted = TRUE;

	PostTaskHook();

	run_trusted = saved_run_trusted;

	LEAVE_CALLEVEL(TCL_PREPOST);

	release_interrupts(OSServiceId_HookMissingEnd);
}

#endif /* TOPPERS_call_posttaskhook */

#endif /* CFG_USE_POSTTASKHOOK */

#ifdef CFG_USE_PRETASKHOOK
/*
 *  ץ쥿եåθƤӽФ
 */
#ifdef TOPPERS_call_pretaskhook

void
call_pretaskhook(void)
{
	boolean saved_run_trusted;

	ENTER_CALLEVEL(TCL_PREPOST);
	saved_run_trusted = run_trusted;
	run_trusted = TRUE;

	PreTaskHook();

	run_trusted = saved_run_trusted;

	LEAVE_CALLEVEL(TCL_PREPOST);

	release_interrupts(OSServiceId_HookMissingEnd);
}

#endif /* TOPPERS_call_pretaskhook */

#endif /* CFG_USE_PRETASKHOOK */

#ifdef CFG_USE_STACKMONITORING

#ifdef TOPPERS_init_stack_magic_region

/*
 *  å˥󥰵ǽν
 *  å˥󥰵ǽΤΥޥåʥСΰν
 */
void
init_stack_magic_region(void)
{
	StackType *p_stack_magic_region;

	/*
	 *  å˥󥰵ǽΤᡤåĹθ
	 *  󥿥åΥޥåʥСΰν
	 */
	p_stack_magic_region = TOPPERS_ISTK_MAGIC_REGION(_ostk, _ostksz);
	*p_stack_magic_region = STACK_MAGIC_NUMBER;
}

#endif /* TOPPERS_init_stack_magic_region */

#endif /* CFG_USE_STACKMONITORING */

/*
 *  åȥեåζλ
 */
#ifdef TOPPERS_cancel_shutdown_hook

void
cancel_shutdown_hook(void)
{

	if (is_running_nontrusted_shtdwnhk() != FALSE) {
		/* եåζλ */
		exit_nontrusted_hook();
	}
	else {
		/* եåζλ */
		exit_trusted_shutdown_hook();
	}
	ASSERT(0);
}
#endif /* TOPPERS_cancel_shutdown_hook */

/*
 *  ٥åդOSåȥ
 *  ץƥեåθƤӽФƤФ
 *  åȥեå¹ȯ硤
 *  åȥեå򥭥󥻥뤷Ƹ³å
 *  ³
 *
 */
#ifdef TOPPERS_callevel_chk_shutdown

void
callevel_chk_shutdown(StatusType ercd)
{

	if ((callevel_stat & TCL_SHUTDOWN) != TCL_NULL) {
		if (((callevel_stat & TCL_OSAP_SHUTDOWN) != TCL_NULL) && (p_runosap != NULL)) {
			p_runosap->osap_stat = APPLICATION_TERMINATED;
		}
		cancel_shutdown_hook();
	}
	else {
		internal_shutdownos(ercd);
	}
}
#endif /* TOPPERS_callevel_chk_shutdown */

/*
 *  ץƥեåθƤӽФ
 *  κǾ̥ӥåȤϡƤӽФս򼨤䤬
 */
#ifdef TOPPERS_call_protectionhk_main

void
call_protectionhk_main(StatusType peob_ercd)
{
	StatusType				protection_error = peob_ercd & (~PROTECTION_ERROR_OPTIONAL_BIT);

#ifdef CFG_USE_PROTECTIONHOOK

	boolean					saved_run_trusted;

	ProtectionReturnType	pret;
	ProtectionReturnType	(*volatile protectionhook_adr) (StatusType FatalError);
	uint8					saved_sus_all_cnt_ctx;
	uint8					saved_sus_os_cnt_ctx;

	/* ץƥեå¹ݸȿȯ */
	if ((callevel_stat & TCL_PROTECT) == TCL_PROTECT) {
		callevel_chk_shutdown(E_OS_PROTECTION_FATAL);
	}

	/*
	 *  CεʤǤϴؿΥɥ쥹0ˤʤʤȤ󤫤,
	 *  ѥκŬˤProtectionHookΥɥ쥹Ƚʬ
	 *  Ƥޤ礬뤿, volatileꤷѿ
	 *  ɥ쥹ƤȽꤷƤ
	 */
	protectionhook_adr = &ProtectionHook;

	/* ʲ ƥΥץƥեåƽФ */
	if (protectionhook_adr != NULL) {

		saved_sus_all_cnt_ctx = sus_all_cnt_ctx;
		saved_sus_os_cnt_ctx = sus_os_cnt_ctx;

		sus_all_cnt_ctx = 0U;
		sus_os_cnt_ctx = 0U;

		ENTER_CALLEVEL(TCL_PROTECT);
		saved_run_trusted = run_trusted;

		run_trusted = TRUE;
		LOG_PROHOOK_ENTER(protection_error);
		pret = protectionhook_adr(protection_error);
		LOG_PROHOOK_LEAVE(pret);
		run_trusted = saved_run_trusted;

		LEAVE_CALLEVEL(TCL_PROTECT);

		release_interrupts(OSServiceId_HookMissingEnd);

		sus_all_cnt_ctx = saved_sus_all_cnt_ctx;
		sus_os_cnt_ctx = saved_sus_os_cnt_ctx;

		/* ʲ ProtectionHook ¹Ըν */
		switch (pret) {
		case PRO_SHUTDOWN:
			callevel_chk_shutdown(protection_error);
			break;
		case PRO_TERMINATETASKISR:
			if ((callevel_stat & TCL_SHUTDOWN) != TCL_NULL) {
				if (((callevel_stat & TCL_OSAP_SHUTDOWN) != TCL_NULL) && (p_runosap != NULL)) {
					p_runosap->osap_stat = APPLICATION_TERMINATED;
				}
				cancel_shutdown_hook();
			}
			if ((callevel_stat & TSYS_ISR1) != TSYS_NULL) {
				internal_shutdownos(E_OS_PROTECTION_FATAL);
			}
			if ((callevel_stat & (TCL_STARTUP | TCL_ERROR | TCL_PREPOST)) != TCL_NULL) {
				/* ȥåץեå¹ϥåȥ */
				internal_shutdownos(E_OS_PROTECTION_FATAL);
			}

			if (p_runisr != NULL) {
				/* ǽ٥2ǤC2ISR¹ϥåȥ */
				internal_shutdownos(E_OS_PROTECTION_FATAL);
			}
			else if ((p_runtsk != NULL) && (p_runtsk->calltfn == FALSE)) {
				/* ξ */
				force_terminate_task(p_runtsk, peob_ercd, FALSE);

				/*
				 *  ǥѥå㡤ǤΥå˥
				 *  ξϡ뤬ʳξ礳ʤ
				 */
			}
			else {
				/* ǽ٥2ǥC2ISR¸ߤʤ */
				internal_shutdownos(E_OS_PROTECTION_FATAL);
			}
			break;
		case PRO_IGNORE:
			if (protection_error != E_OS_PROTECTION_EXCEPTION) {
				callevel_chk_shutdown(E_OS_PROTECTION_FATAL);
			}
			break;
		case PRO_TERMINATEAPPL:
			if ((callevel_stat & TCL_SHUTDOWN) != TCL_NULL) {
				if (((callevel_stat & TCL_OSAP_SHUTDOWN) != TCL_NULL) && (p_runosap != NULL)) {
					p_runosap->osap_stat = APPLICATION_TERMINATED;
				}
				cancel_shutdown_hook();
			}
			if ((callevel_stat & TSYS_ISR1) != TSYS_NULL) {
				internal_shutdownos(E_OS_PROTECTION_FATAL);
			}
			if ((callevel_stat & (TCL_SYS_STARTUP | TCL_SYS_ERROR | TCL_PREPOST)) != TCL_NULL) {
				internal_shutdownos(E_OS_PROTECTION_FATAL);
			}
			if ((p_runosap == NULL) || (run_trusted != FALSE)) {
				internal_shutdownos(E_OS_PROTECTION_FATAL);
			}
			else {
				internal_term_osap(p_runosap, NO_RESTART);
			}
			break;
		case PRO_TERMINATEAPPL_RESTART:
			if ((callevel_stat & TCL_SHUTDOWN) != TCL_NULL) {
				if (((callevel_stat & TCL_OSAP_SHUTDOWN) != TCL_NULL) && (p_runosap != NULL)) {
					p_runosap->osap_stat = APPLICATION_TERMINATED;
				}
				cancel_shutdown_hook();
			}
			if ((callevel_stat & TSYS_ISR1) != TSYS_NULL) {
				internal_shutdownos(E_OS_PROTECTION_FATAL);
			}
			if ((callevel_stat & (TCL_STARTUP | TCL_SYS_ERROR | TCL_PREPOST)) != TCL_NULL) {
				internal_shutdownos(E_OS_PROTECTION_FATAL);
			}
			if ((p_runosap == NULL) || (run_trusted != FALSE)) {
				internal_shutdownos(E_OS_PROTECTION_FATAL);
			}
			else {
				internal_term_osap(p_runosap, RESTART);
			}
			break;
		default:
			/* ProtectionHook֤ͤä */
			callevel_chk_shutdown(E_OS_PROTECTION_FATAL);
			break;
		}
	}
	else {
		callevel_chk_shutdown(protection_error);
	}

#else /* CFG_USE_PROTECTIONHOOK */

	/*
	 *  ץƥեåե졼̵
	 *  Ƥ硤OSݸȿȤOSåȥ
	 *  Ԥ
	 *  ΤȤOSåȥΥѥ᡼Ȥơ
	 *  ȿζ̤򼨤顼ɤꤹ
	 */
	callevel_chk_shutdown(protection_error);
#endif /* CFG_USE_PROTECTIONHOOK */

}

#endif /* TOPPERS_call_protectionhk_main */

/*
 *  OSShutdownOSθƤӽФ
 */
#ifdef TOPPERS_internal_shutdownos

void
internal_shutdownos(StatusType ercd)
{
	LOG_STUTOS_ENTER(ercd);

	x_nested_lock_os_int();

#ifdef CFG_USE_SHUTDOWNHOOK
	call_shutdownhook(ercd);
#endif /* CFG_USE_SHUTDOWNHOOK */

	/* ƥ⥸塼νλ */
	object_terminate();

	/* ߶ػ߾֤˰ܹ */
	x_lock_all_int();

	LOG_STUTOS_LEAVE();

	/* åȰ¸νλ */
	target_exit();

	/*
	 * åȰ¸֤äƤ硤
	 * ̵¥롼פԤ
	 */
	while (1) {
	}

}

#endif /* TOPPERS_internal_shutdownos */

#ifdef TOPPERS_internal_call_shtdwnhk

#ifdef CFG_USE_SHUTDOWNHOOK

void
internal_call_shtdwnhk(StatusType ercd)
{

	void (*volatile shutdownhook_adr) (StatusType Error);
#ifdef CFG_USE_OSAP_SHUTDOWNHOOK
	ApplicationType i;
#endif /* CFG_USE_OSAP_SHUTDOWNHOOK */

	/*
	 *  åȥեåΥåȥǤϥåȥեå
	 *  ϸƤӽФʤ
	 */
	if ((callevel_stat & TCL_SHUTDOWN) == TCL_NULL) {

		sus_all_cnt_ctx = 0U;
		sus_os_cnt_ctx = 0U;

#ifdef CFG_USE_OSAP_SHUTDOWNHOOK
		/*
		 *  OSץꥱShutdownHookƽФ
		 *
		 *  OSץꥱ֥åꤵ줿ȥ꤬
		 *  NULLǤʤм¹Ԥ
		 */

		for (i = 0U; i < tnum_osap; i++) {
			shutdownhook_adr = osapinib_table[i].ShutdownHook;
			p_runosap = &(osapcb_table[i]);
			if ((shutdownhook_adr != NULL) && (p_runosap->osap_stat == APPLICATION_ACCESSIBLE)) {
				ENTER_CALLEVEL(TCL_OSAP_SHUTDOWN);
				LOG_SHUTHOOKOSAP_ENTER(i, ercd);
				if (p_runosap->p_osapinib->osap_trusted != FALSE) {
					run_trusted = TRUE;
					call_trusted_hook((void *) shutdownhook_adr, ercd);
				}
				else {
					run_trusted = FALSE;
					call_nontrusted_hook((void *) shutdownhook_adr, ercd, SHUTDOWN_HOOK);
				}
				LOG_SHUTHOOKOSAP_LEAVE(i);
				LEAVE_CALLEVEL(TCL_OSAP_SHUTDOWN);

				release_interrupts(OSServiceId_HookMissingEnd);
			}
		}
#endif /* CFG_USE_OSAP_SHUTDOWNHOOK */

#ifdef CFG_USE_SYSTEM_SHUTDOWNHOOK
		p_runosap = NULL;

		/*
		 *  ShutdownHook θƤӽФ
		 *
		 *  CεʤǤϴؿΥɥ쥹0ˤʤʤȤ󤫤,
		 *  ѥκŬˤShutdownHookΥɥ쥹Ƚʬ
		 *  Ƥޤ礬뤿, volatileꤷѿ
		 *  ɥ쥹ƤȽꤷƤ
		 */
		shutdownhook_adr = &ShutdownHook;

		if (shutdownhook_adr != NULL) {
			ENTER_CALLEVEL(TCL_SYS_SHUTDOWN);
			run_trusted = TRUE;
			LOG_SHUTHOOK_ENTER(ercd);
			call_trusted_hook((void *) &ShutdownHook, ercd);
			LOG_SHUTHOOK_LEAVE();
			LEAVE_CALLEVEL(TCL_SYS_SHUTDOWN);

			release_interrupts(OSServiceId_HookMissingEnd);
		}
#endif /* CFG_USE_SYSTEM_SHUTDOWNHOOK */
	}
}
#endif /* CFG_USE_SHUTDOWNHOOK */

#endif /* TOPPERS_internal_call_shtdwnhk */
