/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: log_output.c 187 2015-06-25 03:39:04Z t_ishikawa $
 */

/*
 *		ƥΥեޥåȽ
 */

#include "log_output.h"

void
_kernel_KernelLibrarySyslog(void *param)
{
#ifdef USE_KERNEL_LIBRARY_SYSLOG
	KERLIBSLG_PRM *prm = (KERLIBSLG_PRM	*) param;

	switch (prm->index) {
	case KERLIBSLG_ID_SYSLOG_INITIALIZE:
		_syslog_syslog_initialize();
		break;

	case KERLIBSLG_ID_SYSLOG_WRI_LOG:
		prm->return_er = _syslog_syslog_wri_log(prm->prio, prm->p_const_syslog);
		break;

	case KERLIBSLG_ID_SYSLOG_MSK_LOG:
		prm->return_er = _syslog_syslog_msk_log(prm->lowmask);
		break;

	case KERLIBSLG_ID_SYSLOG_PRINTF:
		_syslog_syslog_printf(prm->p_format, prm->p_args, prm->outputc);
		break;

	case KERLIBSLG_ID_SYSLOG_PRINT:
		_syslog_syslog_print(prm->p_const_syslog, prm->outputc);
		break;

	default:
		/* 嵭Υʳξ硤ϹԤʤ */
		break;
	}
#endif /* USE_KERNEL_LIBRARY_SYSLOG */
	return;
}

/*
 *  ͤʸѴuintptrοͤκʸ
 *  8ʿ10ʿ16ʿѴ
 *  ư㡧
 *  2Byteξ硧16ʿFFFF  4ʸ
 *             10ʿ65535 5ʸ
 *              8ʿ1777776ʸ
 *               CONVERT_BUFLENϺ6ʸ֤
 *  ׻ѥ᡼
 *  8U:1ХȤΥӥåȿ
 *  2U:3ǳäݤ;1ӥåȡޤ2ӥåʬޤ뤿
 *  3U:10ʿѴ3ӥåȤ1ʸˤʤ
 *     (4ӥåȤ2ˤʤ뤿)
 *  ׻㡧
 *  2Byteξ
 *     ӥåȿ2 * 8U = 16bit
 *     ñ3ǳȡ16 / 3 = 5Ȥʤꡤ;1ӥåʬʸ
 *     ڤΤƤƤޤ
 *     3ǳ2ӥåʬ­ȤǡڼΤƤɤ
 *     (16 + 2) / 3 = 6ʸ
 */
#define CONVERT_BUFLEN	(((sizeof(uintptr) * 8U) + 2U) / 3U)

/*
 *  ͤʸѴ
 */
static void
convert(uintptr val, uint32 radix, const char8 *radchar,
		uint32 width, boolean minus, boolean padzero, void (*outputc)(char8 c))
{
	char8	buf[CONVERT_BUFLEN];
	uint32	i, j;

	i = 0U;
	do {
		buf[i++] = radchar[val % radix];
		val /= radix;
	} while ((i < CONVERT_BUFLEN) && (val != 0U));

	if ((minus != FALSE) && (width > 0U)) {
		width -= 1U;
	}
	if ((minus != FALSE) && (padzero != FALSE)) {
		(*outputc)('-');
	}
	for (j = i; j < width; j++) {
		(*outputc)((char8) ((padzero != FALSE) ? '0' : ' '));
	}
	if ((minus != FALSE) && (padzero == FALSE)) {
		(*outputc)('-');
	}
	while (i > 0U) {
		(*outputc)(buf[--i]);
	}
}

/*
 *  ʸ
 */
static const char8	raddec[] = "0123456789";
static const char8	radhex[] = "0123456789abcdef";
static const char8	radHEX[] = "0123456789ABCDEF";

void
_syslog_syslog_printf(const char8 *format, const uintptr *p_args, void (*outputc)(char8 c))
{
	char8		c;
	uint32		width;
	boolean		padzero;
	sintptr		val;
	const char8	*str;

	while ((c = *format++) != '\0') {
		if (c != '%') {
			(*outputc)(c);
			continue;
		}

		width = 0U;
		padzero = FALSE;
		if ((c = *format++) == '0') {
			padzero = TRUE;
			c = *format++;
		}
		while (('0' <= c) && (c <= '9')) {
			width = (width * 10U) + (c - '0');
			c = *format++;
		}
		if (c == 'l') {
			c = *format++;
		}
		switch (c) {
		case 'd':
			val = (sintptr) (*p_args++);
			if (val >= 0) {
				convert((uintptr) val, 10U, raddec,
						width, FALSE, padzero, outputc);
			}
			else {
				convert((uintptr) (-val), 10U, raddec,
						width, TRUE, padzero, outputc);
			}
			break;
		case 'u':
			val = (sintptr) (*p_args++);
			convert((uintptr) val, 10U, raddec, width, FALSE, padzero, outputc);
			break;
		case 'x':
		case 'p':
			val = (sintptr) (*p_args++);
			convert((uintptr) val, 16U, radhex, width, FALSE, padzero, outputc);
			break;
		case 'X':
			val = (sintptr) (*p_args++);
			convert((uintptr) val, 16U, radHEX, width, FALSE, padzero, outputc);
			break;
		case 'c':
			(*outputc)((char8) (uintptr) (*p_args++));
			break;
		case 's':
			str = (const char8 *) (*p_args++);
			while ((c = *str++) != '\0') {
				(*outputc)(c);
			}
			break;
		case '%':
			(*outputc)('%');
			break;
		case '\0':
			format--;
			break;
		default:
			/* 嵭Υʳξ硤ϹԤʤ */
			break;
		}
	}
}

/*
 *  ν
 */
void
_syslog_syslog_print(const SYSLOG *p_syslog, void (*outputc)(char8 c))
{
	switch (p_syslog->logtype) {
	case LOG_TYPE_COMMENT:
		_syslog_syslog_printf((const char8 *) (p_syslog->loginfo[0]),
							  &(p_syslog->loginfo[1]), outputc);
		break;
	case LOG_TYPE_ASSERT:
		_syslog_syslog_printf("%s:%u: Assertion '%s' failed.",
							  &(p_syslog->loginfo[0]), outputc);
		break;
	default:
		/* 嵭Υʳξ硤ϤϹԤʤ */
		break;
	}
}
