/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: fl850f1l.h 164 2015-06-03 01:22:29Z t_ishikawa $
 */
/*
 *		FL-850/F1Lܡɤ
 */

#ifndef TOPPERS_FL850F1L_H
#define TOPPERS_FL850F1L_H

#include "v850_gcc/rh850_f1l.h"

/*
 *  å®
 */

/*
 *  PLLϢ
 */
#define MAINOSC_CLOCK_MHZ	8       /* Main OSC is 8MHz */
#define SUBOSC_CLOCK_KHZ	32768   /* Sub OSC is 32.768kHz */
#define INTOSCH_CLK_MHZ		8       /* High Speed Internal OSC Clock is 8MHz */
#define INTOSCL_CLK_KHZ		240     /* Low Speed Internal OSC Clock is 240kHz */

#define PLL_CLK_MHZ		80  /* PLL is 80MHz */
#define PLLC_OUTBSEL	0   /* PLLOUTBSEL */
#define PLLC_mr			1   /* M[1:0]   */
#define PLLC_par		4   /* PA[2:0]  */
#define PLLC_nr			40  /* N[5:0]+1 */

/*
 * Port 8 Configuration for LED
 *   P8_4: LED4(OUT)
 *   P8_5: LED3(OUT)
 *   P8_6: LED2(OUT)
 *   P8_7: LED1(OUT)
 */
#define LED_P8_MASK				((uint16) 0x00F0)
#define LED_PM8_INIT			((uint16) 0xFF0F)
#define LED_P8_INIT				((uint16) 0x00F0)

#ifndef _PIN_100_

/*
 *  Port 1 Configration for RLIN35
 *   P1_5 : RLIN35TX
 *   P1_4 : RLIN35RX
 */
#define RLIN35_P1_MASK			((uint16) 0x0030)
#define RLIN35_PMC1_INIT		((uint16) 0x0030)
#define RLIN35_PFC1_INIT		((uint16) 0x0000)
#define RLIN35_PM1_INIT			((uint16) 0x0010)
#define RLIN35_PIBC1_INIT		((uint16) 0x0010)

#else /* _PIN_100_ */

/*
 *  Port 0 Configration for RLIN35
 *   P0_13 : RLIN32RX
 *   P0_14 : RLIN32TX
 */
#define RLIN32_P0_MASK			((uint16) 0x6000)
#define RLIN32_PMC0_INIT		((uint16) 0x6000)
#define RLIN32_PFCAE0_INIT		((uint16) 0x0000)
#define RLIN32_PFCE0_INIT		((uint16) 0x0000)
#define RLIN32_PFC0_INIT		((uint16) 0x0000)
#define RLIN32_PM0_INIT			((uint16) 0x2000)
#define RLIN32_PIBC0_INIT		((uint16) 0x2000)

#endif /* _PIN_100_ */ 

/*
 * Macro for fl850_led_output
 */
#define POS_LED1				((uint16) 0x01)
#define POS_LED2				((uint16) 0x02)
#define POS_LED3				((uint16) 0x04)
#define POS_LED4				((uint16) 0x08)
#define POS_LED_ALL				((uint16) 0x0F)

#endif /* TOPPERS_FL850F1L_H */
