/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_config.c 164 2015-06-03 01:22:29Z t_ishikawa $
 */

/*
 *		åȰ¸⥸塼FL-850/F1Lѡ
 */

#include "kernel_impl.h"
#include "v850_gcc/uart_rlin.h"
#include "v850_gcc/prc_sil.h"
#include "target_sysmod.h"
#ifdef ENABLE_RETURN_MAIN
#include "interrupt.h"
#endif /* ENABLE_RETURN_MAIN */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ʸν
 */
void
target_fput_str(const char8 *c)
{
	while (*c != '\0') {
		uart_putc(*c);
		c++;
	}
	uart_putc('\n');
}

void
fl850_led_output(uint8 pattern)
{
	uint16 wk;

	pattern = ~pattern;
	wk = sil_reh_mem((void *) P(8));
	wk &= ~LED_P8_MASK;
	wk |= (pattern & LED_P8_MASK);
	sil_wrh_mem((void *) P(8), wk);
}

/*
 *  ݡȤν
 */
void
target_port_initialize(void)
{
	uint16 wk;

	/*
	 * PORT8(LED)
	 */
	/* PM8  */
	wk = sil_reh_mem((void *) PM(8));
	wk &= ~LED_P8_MASK;
	wk |= (LED_PM8_INIT & LED_P8_MASK);
	sil_wrh_mem((void *) PM(8), wk);

	/* P8  */
	wk = sil_reh_mem((void *) P(8));
	wk &= ~LED_P8_MASK;
	wk |= (LED_P8_INIT & LED_P8_MASK);
	sil_wrh_mem((void *) P(8), wk);

#ifndef _PIN_100_
	/*
	 * PORT1(RLIN35)
	 */
	/* PFC1  */
	wk = sil_reh_mem((void *) PFC(1));
	wk &= ~RLIN35_P1_MASK;
	wk |= (RLIN35_PFC1_INIT & RLIN35_P1_MASK);
	sil_wrh_mem((void *) PFC(1), wk);

	/* PMC1  */
	wk = sil_reh_mem((void *) PMC(1));
	wk &= ~RLIN35_P1_MASK;
	wk |= (RLIN35_PMC1_INIT & RLIN35_P1_MASK);
	sil_wrh_mem((void *) PMC(1), wk);

	/* PM1  */
	wk = sil_reh_mem((void *) PM(1));
	wk &= ~RLIN35_P1_MASK;
	wk |= (RLIN35_PM1_INIT & RLIN35_P1_MASK);
	sil_wrh_mem((void *) PM(1), wk);

	/* PIBC1  */
	wk = sil_reh_mem((void *) PIBC(1));
	wk &= ~RLIN35_P1_MASK;
	wk |= (RLIN35_PIBC1_INIT & RLIN35_P1_MASK);
	sil_wrh_mem((void *) PIBC(1), wk);

#else /* _PIN_100_ */

	/*
	 * PORT0(RLIN32)
	 */
	/* PFCAE0  */
	wk = sil_reh_mem((void *) PFCAE(0));
	wk &= ~RLIN32_P0_MASK;
	wk |= (RLIN32_PFCAE0_INIT & RLIN32_P0_MASK);
	sil_wrh_mem((void *) PFCAE(0), wk);

	/* PFCE0  */
	wk = sil_reh_mem((void *) PFCE(0));
	wk &= ~RLIN32_P0_MASK;
	wk |= (RLIN32_PFCE0_INIT & RLIN32_P0_MASK);
	sil_wrh_mem((void *) PFCE(0), wk);

	/* PFC0  */
	wk = sil_reh_mem((void *) PFC(0));
	wk &= ~RLIN32_P0_MASK;
	wk |= (RLIN32_PFC0_INIT & RLIN32_P0_MASK);
	sil_wrh_mem((void *) PFC(0), wk);

	/* PMC0  */
	wk = sil_reh_mem((void *) PMC(0));
	wk &= ~RLIN32_P0_MASK;
	wk |= (RLIN32_PMC0_INIT & RLIN32_P0_MASK);
	sil_wrh_mem((void *) PMC(0), wk);

	/* PM0  */
	wk = sil_reh_mem((void *) PM(0));
	wk &= ~RLIN32_P0_MASK;
	wk |= (RLIN32_PM0_INIT & RLIN32_P0_MASK);
	sil_wrh_mem((void *) PM(0), wk);

	/* PIBC0  */
	wk = sil_reh_mem((void *) PIBC(0));
	wk &= ~RLIN32_P0_MASK;
	wk |= (RLIN32_PIBC0_INIT & RLIN32_P0_MASK);
	sil_wrh_mem((void *) PIBC(0), wk);

#endif /* _PIN_100_ */ 
}

/*
 *  åطν
 */
void
target_clock_initialize(void)
{
	uint32 errcnt = 0;

	/* Init Main Clock */
	if (EnableMainOSC(MHz(MAINOSC_CLOCK_MHZ)) != UC_SUCCESS) {
		errcnt++;
	}

	/* Init PLL */
	if (EnablePLL() != UC_SUCCESS) {
		errcnt++;
	}

	/* Set CPU Clock */
	if (SetClockSelection(CKSC_CPUCLKS_CTL, CKSC_CPUCLKS_ACT,
						  PNO_CtrlProt1, 0x03, /* 80MHz f_CPUCLK */
						  CKSC_CPUCLKD_CTL, CKSC_CPUCLKD_ACT,
						  0x01) != UC_SUCCESS) {
		errcnt++;
	}

	if (errcnt > 0) {
		infinite_loop();
	}
}

/*
 *  åȰ¸Υϡɥν
 *  åץ롼󤫤ƤӽФ롥
 */
void
target_hardware_initialize(void)
{
	/* åν */
	target_clock_initialize();

	/* ݡȤν */
	target_port_initialize();
}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 *  V850¸ν
	 */
	prc_initialize();



#ifdef TOPPERS_ENABLE_TRACE
	/*
	 *  ȥ졼ǽν
	 */
	trace_initialize((uintptr) (TRACE_AUTOSTOP));
#endif /* TOPPERS_ENABLE_TRACE */
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
#ifdef TOPPERS_ENABLE_TRACE
	/*
	 *  ȥ졼Υ
	 */
	trace_dump(target_fput_log);
#endif /* TOPPERS_ENABLE_TRACE */

#ifndef ENABLE_RETURN_MAIN
	/*
	 *  åȥν
	 */
	target_fput_str("Kernel Exit...");
#else
	target_fput_str("Kernel Shutdown...");
#endif /* ENABLE_RETURN_MAIN */

	/*
	 *  FL-850/F1L¸νλ
	 */
	prc_terminate();

#ifdef ENABLE_RETURN_MAIN
	p_ctxosap = NULL;
	kerflg = FALSE;
	except_nest_cnt = 0U;
	nested_lock_os_int_cnt = 0U;
	hook_savedsp = 0U;
	shutdown_hook_savedsp = 0U;
    sus_all_cnt = 0U;
    sus_all_cnt_ctx = 0U;
    sus_os_cnt = 0U;
    sus_os_cnt_ctx = 0U;

	/* åݥ󥿤νmain()θƤӽФ */
	return_main();
#endif /* ENABLE_RETURN_MAIN */

	infinite_loop();
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char8 c)
{
	if (c == '\n') {
		uart_putc('\r');
	}
	uart_putc(c);
}
