/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Spansion LLC, USA
 *  Copyright (C) 2014 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_hw_counter.h 165 2015-06-04 05:24:57Z t_ishikawa $
 */

/*
 *		ϡɥ󥿤ΥåȰ¸fl850f1lѡ
 */

#ifndef TOPPERS_TARGET_HW_COUNTER_H
#define TOPPERS_TARGET_HW_COUNTER_H

/*
 *  Ѥ륿ޡΥ˥åֹȺʬޤȸͥޤΥͥ
 */
#define HWC_DTIM_UNIT  0  /* 0 or 1 */
#define HWC_DTIM_ID    0
#define HWC_CTIM_UNIT  0  /* 0 or 1 */
#define HWC_CTIM_ID    1

/*
 *  ֹ
 */
#if (HWC_DTIM_UNIT == 0)
#define HWC_DTIM_INTNO  (TAUFJ0I0_INTNO + HWC_DTIM_ID)
#elif (HWC_DTIM_UNIT == 1)
#define HWC_DTIM_INTNO  (TAUFJ1I0_INTNO + HWC_DTIM_ID)
#else /*(HWC_DTIM_UNIT == 1) */
#error define HWC_UNIT  0 or 1.
#endif /* (HWC_DTIM_UNIT == 0) */

/*
 *  ͥ
 */
#define HWC_DTIM_INTPRI  1

/*
 *  ޥåȿHzˡ8MHz
 */
#define TIMER_CLOCK_HZ		((uint32) 8000000)

/*
 *  TAUJϢ쥸
 */
#define TAUJ_BASE(n)	((uint32) (0xffe50000U + (n * 0x1000U)))
#define TAUJTPS(n)		(TAUJ_BASE(n) + 0x90U)
#define TAUJCDR(n, ch)	(TAUJ_BASE(n) + (ch * 0x04U))
#define TAUJCNT(n, ch)	(TAUJ_BASE(n) + 0x10U + (ch * 0x04U))
#define TAUJCMOR(n, ch)	(TAUJ_BASE(n) + 0x80U + (ch * 0x04U))
#define TAUJCMUR(n, ch)	(TAUJ_BASE(n) + 0x20U + (ch * 0x04U))
#define TAUJTS(n)		(TAUJ_BASE(n) + 0x54U)
#define TAUJTT(n)		(TAUJ_BASE(n) + 0x58U)

#define MCU_TAUJ_MASK_CK0				((uint16) 0xfff0)
#define MCU_TAUJ_CK0_0					((uint16) 0x0000) /* ʬʤ */
#define MCU_TAUJ00_CMOR					((uint16) 0x0000)
#define MCU_TAUJ00_CMUR					((uint8) 0x01)

/*
 *  TAUJΥ˥åֹȥͥ뤫ϳֹؤѴ
 */
#define TAUJ_INTNO(n, ch)	(n == 0)? ((uint32) ((TAUFJ0I0_INTNO + ch))) : ((uint32) (TAUFJ1I0_INTNO + ch))

/*
 *  ׵Υꥢ
 */
LOCAL_INLINE void
HwcounterClearInterrupt(uint32 intno)
{
	/* 쥸 */
	uint32 eic_address = EIC_ADDRESS(intno);

	/* ׵ӥåȤΥꥢ */
	sil_wrh_mem((void *) eic_address,
				sil_reh_mem((void *) eic_address) & ~EIRFn);
}

/*
 *  ߶ػߡ
 */
LOCAL_INLINE void
HwcounterDisableInterrupt(uint32 intno)
{
	/* 쥸 */
	uint32 eic_address = EIC_ADDRESS(intno);

	/* ߥޥӥåȤΥå */
	sil_wrh_mem((void *) eic_address,
				sil_reh_mem((void *) eic_address) | EIMKn);
}

LOCAL_INLINE void
HwcounterEnableInterrupt(uint32 intno)
{
	/* 쥸 */
	uint32 eic_address = EIC_ADDRESS(intno);

	/* ߥޥӥåȤΥå */
	sil_wrh_mem((void *) eic_address,
				sil_reh_mem((void *) eic_address) & ~EIMKn);
}

/*
 *  TAUJn ޤưϡ߽
 */
LOCAL_INLINE void
SetTimerStartTAUJ(uint8 n, uint8 ch)
{
	/* ޳Ͻ */
	sil_wrh_mem((void *) TAUJTS(n), (1 << ch));
}

LOCAL_INLINE void
SetTimerStopTAUJ(uint8 n, uint8 ch)
{
	/* ߽ */
	sil_wrh_mem((void *) TAUJTT(n), (1 << ch));
}

/*
 *  TAUJnϡɥ󥿸ߥƥåͼ
 */
LOCAL_INLINE TickType
GetCurrentTimeTAUJ(uint8 n, uint8 ch, TickType maxval)
{
	TickType	count;
	TickType	curr_time = 0U;

	count = sil_rew_mem((void *) (TAUJCNT(n, ch)));

	/* 󥫥󥿤ΰ١ߥåͤѴ */
	curr_time = maxval - count;
	curr_time = (curr_time % maxval);

	return(curr_time);
}

/*
 *  TAUBϢ쥸
 */
#define TAUB_BASE(n)	((uint32) (0xffe30000U + (n * 0x1000U)))
#define TAUBTPS(n)		(TAUB_BASE(n) + 0x240U)
#define TAUBCDR(n, ch)	(TAUB_BASE(n) + (ch * 0x04U))
#define TAUBCNT(n, ch)	(TAUB_BASE(n) + 0x80U + (ch * 0x04U))
#define TAUBCMOR(n, ch)	(TAUB_BASE(n) + 0x2000U + (ch * 0x04U))
#define TAUBCMUR(n, ch)	(TAUB_BASE(n) + 0xC0U + (ch * 0x04U))
#define TAUBTS(n)		(TAUB_BASE(n) + 0x1C4U)
#define TAUBTT(n)		(TAUB_BASE(n) + 0x1C8U)

#define MCU_TAUB_MASK_CK0				((uint16) 0xfff0)
#define MCU_TAUB_CK0_0					((uint16) 0x0000) /* ʬʤ */
#define MCU_TAUB00_CMOR					((uint16) 0x0000)
#define MCU_TAUB00_CMUR					((uint8) 0x01)

#define TAUB_INTNO(n, ch)	(n == 0)? ((uint32) ((134 + ch))) : ((uint32) (248 + ch))

/*
 *  TAUBn ޤưϡ߽
 */
LOCAL_INLINE void
SetTimerStartTAUB(uint8 n, uint8 ch)
{
	/* ޳Ͻ */
	sil_wrh_mem((void *) TAUBTS(n), (1 << ch));
}

LOCAL_INLINE void
SetTimerStopTAUB(uint8 n, uint8 ch)
{
	/* ߽ */
	sil_wrh_mem((void *) TAUBTT(n), (1 << ch));
}

/*
 *  TAUBnϡɥ󥿸ߥƥåͼ
 */
LOCAL_INLINE TickType
GetCurrentTimeTAUB(uint8 n, uint8 ch, TickType maxval)
{
	TickType	count;
	TickType	curr_time = 0U;

	count = (TickType)sil_reh_mem((void *) (TAUBCNT(n, ch)));

	/* 󥫥󥿤ΰ١ߥåͤѴ */
	curr_time = maxval - count;
	curr_time = (curr_time % maxval);

	return(curr_time);
}


/* MAIN_HW_COUNTER */
extern void init_hwcounter_MAIN_HW_COUNTER(TickType maxval, TimeType nspertick);
extern void start_hwcounter_MAIN_HW_COUNTER(void);
extern void stop_hwcounter_MAIN_HW_COUNTER(void);
extern void set_hwcounter_MAIN_HW_COUNTER(TickType exprtick);
extern TickType get_hwcounter_MAIN_HW_COUNTER(void);
extern void cancel_hwcounter_MAIN_HW_COUNTER(void);
extern void trigger_hwcounter_MAIN_HW_COUNTER(void);
extern void int_clear_hwcounter_MAIN_HW_COUNTER(void);
extern void int_cancel_hwcounter_MAIN_HW_COUNTER(void);
extern void increment_hwcounter_MAIN_HW_COUNTER(void);

/*
 *  10msȰפƥå(ץץ)
 */
#define TICK_FOR_10MS	TIMER_CLOCK_HZ / 100

#endif /* TOPPERS_TARGET_HW_COUNTER_H */
